commit a08327fe2e74269d26eef1cddd7c9f9b7efa96e2
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Fri Mar 9 18:32:29 2018 -0600

    Update NEWS for 1.8.0 final release
    
    Change-Id: I70d73b832cd69395c712b42a391cd4d6d3ea4c8f
    Reviewed-on: https://gerrit.openafs.org/12953
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit acb0e84df0cdff1ee1b4098b2705e5a30dd7eb38
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Thu Mar 1 20:28:23 2018 -0600

    afs_pioctl: avoid -Wpointer-sign
    
    Change the declaration of 'addr' to be a signed int, to match
    RXAFS_CallBackRxConnAddr() and the afsd_pd_GetInt() used with it.
    This was detected by clang 4.0 in FreeBSD 11.1, via -Wpointer-sign.
    
    Reviewed-on: https://gerrit.openafs.org/12934
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit 79f33b859aeb3c91f2cce7597fdc138978c4e1d9)
    
    Change-Id: Iee85059bebfc8d6fbda3409b720576bd4f6c5f8f
    Reviewed-on: https://gerrit.openafs.org/12938
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit b73863b8d2669830a17c097abf1d846d0108a2f4
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Thu Mar 1 23:16:56 2018 -0500

    LINUX: fix RedHat 7.5 ENOTDIR issues
    
    Red Hat Linux 7.5 beta introduces a new file->f_mode flag
    FMODE_KABI_ITERATE as a means for certain in-tree filesystems to
    indicate that they have implemented file operation iterate() instead of
    readdir().  The kernel routine iterate_dir() tests this flag to decide
    whether to invoke the file operation iterate() or readdir().
    
    The OpenAFS configure script detects that the file operation iterate()
    is available under RH7.5 and so implements iterate() as
    afs_linux_readdir().  However, since OpenAFS does not set
    FMODE_KABI_ITERATE on any of its files, the kernel's iterate_dir() will
    not invoke iterate() for any OpenAFS files.  OpenAFS has also not
    implemented readdir(), so iterate_dir() must return -ENOTDIR.
    
    Instead, modify OpenAFS to fall back to readdir() in this case.
    
    Reviewed-on: https://gerrit.openafs.org/12935
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit c818f86b79a636532d396887d4f22cc196c86288)
    
    Change-Id: I71386b17f0c751b69c86ef0f5766a5baf3dc36bd
    Reviewed-on: https://gerrit.openafs.org/12950
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 55fbc8ee055958b309011eeb62d7166ff0415905
Author: Andrew Deason <adeason@dson.org>
Date:   Thu Feb 15 16:41:33 2018 -0600

    rxdebug: NUL-terminate version before printing
    
    Currently, 'rxdebug -version' never initializes the buffer we read the
    version string into. Usually this is not noticeable, since all OpenAFS
    binaries tend to pad the Rx version response packet with NULs, so we
    get back several NULs to terminate the string. However, this is not
    guaranteed, and if we do not get back a NUL-terminated string, we can
    easily read beyond the end of the buffer.
    
    To avoid this, initialize the 'version' buffer with NULs before we do
    anything, and set the last byte to NUL, in case we exactly filled the
    buffer.
    
    Reviewed-on: https://gerrit.openafs.org/12908
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: Andrew Deason <adeason@sinenomine.net>
    (cherry picked from commit a66629eac4dda4eea37b4f06e0850641cb2a7387)
    
    Change-Id: I850ce16840ee264dce506e8b3c887004bca11e20
    Reviewed-on: https://gerrit.openafs.org/12912
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 3d58c397c6935afd64e3a41017baf627106a3003
Author: Andrew Deason <adeason@sinenomine.net>
Date:   Thu Feb 15 16:53:57 2018 -0600

    doc: Edits to the 'afsd -volume-ttl' manpage
    
    Make a few misc changes to the text for the new -volume-ttl option:
    
    - Minor grammatical/typo fixes
    
    - Emphasize a little more that the default behavior allows for vldb
      info to be cached _forever_
    
    - Provide some info on the effects of changing this value
    
    - Provide a suggested "typical" value, to give some clue as to what
      should be set here, so a curious user doesn't just set this to the
      first value they see (10 minutes)
    
    Reviewed-on: https://gerrit.openafs.org/12909
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: Andrew Deason <adeason@sinenomine.net>
    (cherry picked from commit e6c2624249a6ab96053c1d1134aec8e3f6bcee9e)
    
    Change-Id: I781ec2e8b4873093f65d11b5883f8b74ad397cff
    Reviewed-on: https://gerrit.openafs.org/12913
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 2a196ba47247742fb294e5a879cb9e54c956028a
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Tue Feb 20 20:31:11 2018 -0500

    redhat: package libuafs perl bindings
    
    Require the swig package as a build dependency. Build and package the
    libuafs perl bindings.  Place these libraries in the openafs-devel
    package, along with the man page (moved from the openfs-client package).
    
    This fixes an rpm build error when the swig package is present on the
    build system,
    
        RPM build errors:
        Installed (but unpackaged) file(s) found:
        /usr/lib64/perl/AFS/ukernel.pm
        /usr/lib64/perl/ukernel.so
    
    FIXES 134470
    
    Reviewed-on: https://gerrit.openafs.org/12919
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit 278581c24a802834719e0d57f27978321556c9bb)
    
    Change-Id: I892e1f58e92f1eb66eeae8fb0d237bed0bdb2a62
    Reviewed-on: https://gerrit.openafs.org/12921
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 774df869fc1753e94f79c6a0b617b7adb9e4060c
Author: Jeffrey Altman <jaltman@auristor.com>
Date:   Sat Feb 10 10:47:24 2018 -0500

    rx: Do not count RXGEN_OPCODE towards abort threshold
    
    An RXGEN_OPCODE is returned for opcodes that are not implemented by the
    rx service.  These opcodes might be deprecated opcodes that are no
    longer supported or more recently registered opcodes that have yet to
    be implemented.  Clients should not be punished for issuing unsupported
    calls.  The clients might be old and are issuing no longer supported
    calls or they might be newer and are issuing yet to be implemented calls
    as part of a feature test and fallback strategy.
    
    This change ignores RXGEN_OPCODE errors when deciding how to adjust the
    rx_call.abortCount.  When an RXGEN_OPCODE abort is sent the
    rx_call.abortCount and rx_call.abortError are left unchanged which
    preserves the state for the next failing call.
    
    Note that this change intentionlly prevents the incrementing of the
    abortCount for client connections as they never send delay aborts.
    
    Reviewed-on: https://gerrit.openafs.org/12906
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit f82d1c7d5aeae148305e867c1f79c6ea2f9e0a2a)
    
    Change-Id: I7a4216bea3a355c31a390c5b4753b4ab0c25661c
    Reviewed-on: https://gerrit.openafs.org/12914
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit cabecc719195047ea321bd62e95d52503d15686e
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Tue Dec 26 17:42:39 2017 -0600

    Make OpenAFS 1.8.0pre5
    
    Update version strings for the fifth 1.8.0 prerelease.
    
    Change-Id: I118da0fc55013ccfb2b5cd586cefb1b0c27f10d9
    Reviewed-on: https://gerrit.openafs.org/12910
    Reviewed-by: Stephan Wiesand <stephan.wiesand@desy.de>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 5f0714312b211c4a6d6157df6f1f3d9e26dcc03f
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Fri Feb 9 17:59:19 2018 -0500

    Update NEWS for 1.8.0pre5
    
    Change-Id: I09e509694c5f7ad59e279b89bd9e144aca2ec4e7
    Reviewed-on: https://gerrit.openafs.org/12904
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Stephan Wiesand <stephan.wiesand@desy.de>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 50fcd6763d4387950390b732d2a131c230d44c99
Author: Marcio Barbosa <mbarbosa@sinenomine.net>
Date:   Wed Jun 21 16:24:05 2017 -0400

    ubik: check if epoch is sane before db relabel
    
    The sync-site relabels its database at the end of the first write
    transaction. The new label will be equal to the time at which the
    sync-site in question first received its coordinator mandate. This time
    is stored by a global called ubik_epochTime. In order to make sure that
    the new database label is sane, only relabel the database if
    ubik_epochTime is within a specific range.
    
    Reviewed-on: https://gerrit.openafs.org/12640
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Andrew Deason <adeason@dson.org>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    (cherry picked from commit f5c289d00aaf7c5525b477da5b89f6675456c211)
    
    Change-Id: I78ebd2b8aeae01ef5e3b826ad6f1de5a5c1db79e
    Reviewed-on: https://gerrit.openafs.org/12886
    Reviewed-by: Marcio Brito Barbosa <mbarbosa@sinenomine.net>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 2b3df9b2f48dcbf3690e093000879b0f06c7e176
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Sat Dec 9 11:37:59 2017 -0600

    Replace <rpc/types.h> with <rx/xdr.h>
    
    Our in-tree xdr.h appears to have started life as a concatenation of
    rpc/types.h and rpc/xdr.h, and should include all the needed functionality.
    Indeed, commit 7293ddf325b149cae60d3abe7199d08f196bd2b9 even indicates
    that we expect to be using our in-tree XDR everywhere anyway, so the
    system XDR is superfluous.
    
    Note that afs/sysincludes.h (not afsincludes.h!) already includes
    rx/xdr.h ifndef AFS_LINUX22_ENV.
    
    This change should help systems running glibc 2.26 or newer, which has
    stopped providing the Sun RPC headers by default.
    
    While here remove some duplicate includes of rpc/types.h in the
    AIX-specific sources.
    
    The Solaris NFS translator bits cannot really be changed, since the system
    headers are used and have tight interdependencies.
    
    Update rxgen to not emit rpc/types.h inclusion.
    
    [mmeffie: squash 12801 to not emit rpc/types.h from rxgen]
    
    Reviewed-on: https://gerrit.openafs.org/12800
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit e443a9fb67dbc29e6cc36661a4ac6e91af113f23)
    
    Change-Id: I351e5c1e1223c49ca76e3d68c264ac1625abae60
    Reviewed-on: https://gerrit.openafs.org/12894
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 833e2783a39367f3cebfb79f403a75752f81ab09
Author: Ian Wienand <iwienand@redhat.com>
Date:   Fri Feb 2 10:52:26 2018 +1100

    Add .gitreview
    
    git-review [1] makes it much easier to submit changes.  Add a default
    configuration file.
    
    [1] https://docs.openstack.org/infra/git-review/usage.html
    
    Reviewed-on: https://gerrit.openafs.org/12884
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit c7c71d2429cf685f3ffad6b2e6d102d900edc197)
    
    Change-Id: I271cfeb6aea888ae40539e248a18131b0affeda8
    Reviewed-on: https://gerrit.openafs.org/12901
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 780ed24d360df6772b2408017a5d555ae36217c0
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Tue Jun 30 01:54:21 2015 -0400

    SOLARIS: Avoid vcache locks when flushing pages for RO vnodes
    
    We have multiple code paths that hold the following locks at the same
    time:
    
        - avc->lock for a vcache
        - The page lock for a page in 'avc'
    
    In order to avoid deadlocks, we need a consistent ordering for obtaining
    these two locks. The code in afs_putpage() currently obtains avc->lock
    before the page lock (Obtain*Lock is called before pvn_vplist_dirty).
    
    The code in afs_getpages() also obtains avc->lock before the page lock,
    but it does so in a loop for all requested pages (via pvn_getpages()).
    On the second iteration of that loop, it obtains avc->lock, and the page
    from the first iteration of the loop is still locked. Thus, it obtains a
    page lock before locking avc->lock in some cases.
    
    Since we have two code paths that obtain those two locks in a different
    order, a deadlock can occur. Fixing this properly requires changing at
    least one of those code paths, so the locks are taken in a consistent
    order. However, doing so is complex and will be done in a separate
    future commit.
    
    For this commit, we can avoid the deadlock for RO volumes by simply
    avoiding taking avc->lock in afs_putpages() at all while the pages are
    locked. Normally, we lock avc->lock because pvn_vplist_dirty() will call
    afs_putapage() for each dirty page (and afs_putapage() requires
    avc->lock held). But for RO volumes, we will have no dirty pages
    (because RO volumes cannot be written to from a client), and so
    afs_putapage() will never be called.
    
    So to avoid this deadlock issue for RO volumes, avoid taking avc->lock
    across the pvn_vplist_dirty() call in afs_putpage(). We now pass a dummy
    pageout callback function to pvn_vplist_dirty() instead, which should
    never be called, and which panics if it ever is.
    
    We still need to hold avc->lock a few other times during afs_putpage()
    for other minor reasons, but none of these hold page locks at the same
    time, so the deadlock issue is still avoided.
    
    [mmeffie: comments, and fix missing write lock, fix lock releases]
    [adeason: revised commit message]
    
    Reviewed-on: https://gerrit.openafs.org/12247
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Andrew Deason <adeason@dson.org>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit 5e09a694ec2c0cd20f5dee500eff6bc3dd04c097)
    
    Change-Id: I5d4e4ddba12c09dc549edeee3cad7de40582ac65
    Reviewed-on: https://gerrit.openafs.org/12900
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 5bb7684f07b5f346b68230c2f38edad4c46dc648
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Thu Jan 4 22:00:15 2018 -0600

    rx: remove trailing semicolons from FBSD mutex operations
    
    Since the first introduction of FreeBSD support, the macros
    (MUTEX_ENTER, etc.) for kernel mutex operations have included
    trailing semicolons, unique among all the platforms.
    
    This did not cause problems until the recent work on rx event
    handlers, which put a MUTEX_ENTER() in the body of an 'if' clause
    with no brackets, and attempted to follow it with an 'else' clause.
    This results in the following (rather obtuse) compiler error:
    
       /root/openafs/src/rx/rx.c:3666:5: error: expected expression
           else
           ^
    
    Which is more visible in the preprocessed source, as
    
       if (condition)
           expression;;
       else
           other_expression;
    
    is clearly invalid C.
    
    To fix the FreeBSD kernel module build, remove the unneeded semicolons.
    
    Reviewed-on: https://gerrit.openafs.org/12853
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit 0760feb7992e1e39f716c5f583fe7f6e85584262)
    
    Change-Id: I503a5967a167e9be92721af8dc82d191f3bf18ba
    Reviewed-on: https://gerrit.openafs.org/12899
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 2f07951a47a8a820c89e4e6ab1e347858acd8ab5
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Sat Dec 9 11:44:51 2017 -0600

    libuafs: remove stale afs_nfsdisp.lo rule
    
    afs_nfsdisp.lo is not used, so we do not need a build rule for it.
    
    Reviewed-on: https://gerrit.openafs.org/12802
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit decb4308d4e18ad9f6f181e3df5f737698dba7ad)
    
    Change-Id: I53680df1c8648ceb43cc032cada573964622d5b4
    Reviewed-on: https://gerrit.openafs.org/12898
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 4988628a2e41955951a49ea0032cabe13f9337d3
Author: Christof Hanke <christof.hanke@rzg.mpg.de>
Date:   Mon Dec 18 16:58:39 2017 +0100

    Avoid gcc warning
    
    When using the configure option --enable-checking with gcc 7.2.1,
    the compilation fails with
    
    vutil.c:860:20: error: ‘%s’ directive writing up to 255 bytes into \
    a region of size 63 [-Werror=format-overflow=]
    
    This can be seen in the logs of the openSUSE Tumbleweed builder
    for e.g. build 2368.
    Avoid this warning by using snprintf which is provided by libroken
    for all platforms.
    
    Reviewed-on: https://gerrit.openafs.org/12813
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    (cherry picked from commit fd4eaebb60dbefc27be98015fee23a3cf5d9752d)
    
    Change-Id: I3be14f6f1228fd09f036da7ff4f1505c65e49406
    Reviewed-on: https://gerrit.openafs.org/12897
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 35636bd9e32015bc10e09ccbb34a71a1459cdc4b
Author: Marcio Barbosa <mbarbosa@sinenomine.net>
Date:   Mon Aug 21 14:21:54 2017 -0400

    ubik: avoid DISK_Begin on sites that didn't vote for sync
    
    As already described on 7c708506, SDISK_Begin fails on remotes if
    lastYesState is not set. To fix this problem, 7c708506 does not allow
    write transactions until we know that lastYesState is set on at least
    quorum (ubik_syncSiteAdvertised == 1). In other words, if enough sites
    received a beacon packet informing that a sync-site was elected, write
    transactions will be allowed. This means that ubik_syncSiteAdvertised
    can be true while lastYesState is not set in a few sites.
    
    Consider the following scenario in a cell with frequent write
    transactions:
    
    Site A => Sync-site (up)
    Site B => Remote 1 (up)
    Site C => Remote 2 (down - unreachable)
    
    Since A and B are up, we have quorum. After the second wave of beacons,
    ubik_syncSiteAdvertised will be true and write transactions will be
    allowed. At some point, C is not unreachable anymore. Site A sends a
    copy of its database to C, but C did not vote for A yet (lastYesState ==
    0). A new write transaction is initialized and, since lastYesState is
    not set on C, DISK_Begin fails on this remote site and C is marked as
    down. Since C is reachable, A will mark this remote site as up. The
    sync-site will send its database to C, but C did not vote for A yet. A
    new write transaction is initialized and, since lastYesState is not set
    on C, DISK_Begin fails on this remote site and C is marked as down. In a
    cell with frequent write transactions, this cycle will repeat forever.
    As a result, the sync-site will be constantly sending its database to C
    and quorum will be operating with less sites, increasing the chances
    of re-elections.
    
    To fix this problem, do not call DISK_Begin on remotes that did not
    vote for the sync-site yet.
    
    Reviewed-on: https://gerrit.openafs.org/12715
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit 68ec78950a6e39dc1bf15012d4b889728086d0b7)
    
    Change-Id: I3764c23125f0bc675762449cd29b282ba403f871
    Reviewed-on: https://gerrit.openafs.org/12896
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 51816cfd047c05921218ecb1161c9dd7986a422f
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Wed Jan 31 16:52:40 2018 -0500

    add rfc3961.h to kernel sources
    
    Export this header to the kernel sources in the libafs_tree, since it is
    needed for the kernel module build.
    
    FIXES 134476
    
    Reviewed-on: https://gerrit.openafs.org/12882
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit 073522b3d49467af107d1143cfa015c53347e1e3)
    
    Change-Id: I4e5c7883a1dd4b66b9252f4e630ca489f05e9ad3
    Reviewed-on: https://gerrit.openafs.org/12890
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 07811e3b15de8926d63b423804c620bc3501745b
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Mon Jan 8 22:28:24 2018 -0600

    Add param.h files for recent FreeBSD
    
    Add files for FreeBSD 10.4, 11.1, and 12.0 (12-CURRENT), for i386 and amd64.
    
    Reviewed-on: https://gerrit.openafs.org/12863
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Stephan Wiesand <stephan.wiesand@desy.de>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit 88dc4d93f5ef080da8f56fac453f095e6c79d4a0)
    
    Change-Id: I6ddb0f03e209b0ce9c7ed1168c86a675d7802c23
    Reviewed-on: https://gerrit.openafs.org/12888
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 0ba9b5559e112005a6f621ebe55f382bcc2aae0d
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Mon Jan 8 21:27:04 2018 -0600

    FBSD: catch up to missing sysnames
    
    Add sysnames for i386 and amd64 10.4, 11.1, and 12.0 (12-CURRENT, at present).
    
    Reviewed-on: https://gerrit.openafs.org/12862
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Stephan Wiesand <stephan.wiesand@desy.de>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit c390f368a5012f866c1b4ce46d6ac6af6cef2fd5)
    
    Change-Id: I5183c19d446fd0c00bd26c32ca3f7f00a4d12907
    Reviewed-on: https://gerrit.openafs.org/12887
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 1f10f087264cb39a8354c0baf71eb1fa13071466
Author: Marcio Barbosa <mbarbosa@sinenomine.net>
Date:   Mon Aug 21 15:50:14 2017 -0400

    ubik: update ubik_dbVersion during SDISK_SendFile
    
    The ubik_dbVersion global represents the sync site's database version
    and it is mostly used by the remote sites for sanity checks. Currently,
    this global is updated when database changes are made on the sync site
    (SDISK_Commit or SDISK_SetVersion), as well as every time we vote "yes"
    for the sync-site in a beacon reply. Unfortunately, ubik_dbVersion is
    not updated when a copy of the sync site's database is received via
    DISK_SendFile, and it won't get updated until our next "yes" vote.
    During this window, the current database version will not match
    ubik_dbVersion. As a result, any write transaction during this time
    frame will fail on the remote site in question.
    
    To fix this problem, do not wait for the next beacon packet to update
    ubik_dbVersion when the sync site's database is received; just update
    it when we get the new database. Since no write transactions are
    allowed while the db is transferring, ubik_dbVersion can be safely
    updated.
    
    Reviewed-on: https://gerrit.openafs.org/12716
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Andrew Deason <adeason@dson.org>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit 50c1d1088d2adcbb37b6a9d23fdd63617b1267be)
    
    Change-Id: Icbbe9efb9c8dab9ac69237380e824d4a523a53d3
    Reviewed-on: https://gerrit.openafs.org/12885
    Reviewed-by: Marcio Brito Barbosa <mbarbosa@sinenomine.net>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit e9419dc895801bda6962f2ac0f5981631a0d95c7
Author: Andrew Deason <adeason@sinenomine.net>
Date:   Thu Jan 11 21:27:28 2018 -0600

    LINUX: Avoid locking inode in check_dentry_race
    
    Currently, check_dentry_race locks the parent inode in order to ensure
    it is not running in parallel with d_splice_alias for the same inode.
    (For old Linux kernel versions; see commit b0461f2d: "LINUX:
    Workaround d_splice_alias/d_lookup race".)
    
    However, it is possible to hit this area of code when the parent inode
    is already locked. When someone tries to create a file, directory, or
    symlink, Linux tries to lookup the dentry for the target path, to see
    if it already exists. While looking up the last component of the path,
    Linux locks the directory, and if it finds a dentry for the target
    name, it calls d_invalidate on it while the parent directory is
    locked.
    
    For a dentry with a NULL inode, we'll then try to lock the parent
    inode in check_dentry_race. But since the inode is already locked, we
    will deadlock.
    
    From a user's point of view, the hang can be reproduced by doing
    something similar to:
    
        $ mkdir dir # succeeds
        $ rmdir dir
        $ ls -l dir
        ls: cannot access dir: No such file or directory
        $ mkdir dir # hangs
    
    To avoid this, we can just change which lock we're using to avoid
    check_dentry_race/d_splice_alias from running in parallel. Instead of
    locking the parent inode, introduce a new global lock (called
    dentry_race_sem), and lock that in check_dentry_race and around our
    d_splice_alias call. We know that those are the only two users of this
    new lock, so this should avoid any such deadlocks.
    
    This does potentially reduce performance, since all tasks that hit
    check_dentry_race or d_splice_alias will take the same global lock.
    However, this at least still allows us to make use of negative
    dentries, and this entire code path only applies to older Linux
    kernels. It could be possible to add a new lock into struct vcache
    instead, but using a global lock like this commit does is much
    simpler.
    
    Reviewed-on: https://gerrit.openafs.org/12868
    Tested-by: Benjamin Kaduk <kaduk@mit.edu>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit ef1d4c8d328e9b9affc9864fd084257e9fa08445)
    
    Change-Id: Ia8e28519fff36baca7dc4061ceef6719a2a738d4
    Reviewed-on: https://gerrit.openafs.org/12881
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit f523c92a74bace287d1139fab77a030b9598ef61
Author: Caitlyn Marko <cmarko@sinenomine.net>
Date:   Thu Feb 9 09:16:17 2017 -0500

    SOLARIS: save kernel module function arguments for debugging
    
    Add the -Wu,-save_args compiler option when building kernel modules
    under Solaris 10 and 11 for the amd64 architecture.
    
    Binaries generated with this option save function arguments on the stack
    during function entry for debugging purposes. Up to six integer
    arguments are saved on function entry, and are not modified during the
    execution of the function.
    
    [mmeffie: commit message update]
    
    Reviewed-on: https://gerrit.openafs.org/12798
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit 32d0493a7e4f74f5e5efdfde5eca29ed7d1bf3ec)
    
    Change-Id: I478ce65da78b86aa3c13e1c615bafd51d0f5d567
    Reviewed-on: https://gerrit.openafs.org/12903
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 96ce04c78b5f745424165494c9b76d7ce227eeaa
Author: Marcio Barbosa <mbarbosa@sinenomine.net>
Date:   Mon Feb 5 21:16:17 2018 +0000

    autoconf: detect ctf-tools and add ctf to libafs
    
    CTF is a reduced form of debug information similar to DWARF and stab. It
    describes types and function prototypes. The principal objective of the
    format is to shrink the data size as much as possible so that it could
    be included in a production environment. MDB, DTrace, and other tools
    use CTF debug information to read and display structures correctly.
    
    This commit introduces a new configure option called --with-ctf-tools.
    This option can be used to specify an alternative path where the tools
    can be found. If the path is not provided, the tools will be searched
    in a set of default directories (including $PATH). The CTF debugging
    information will only be included if the corresponding --enable-debug /
    --enable-debug-kernel is specified.
    
    Note: at the moment, the Solaris kernel module is the only module
    benefited by this commit.
    
    Reviewed-on: https://gerrit.openafs.org/12680
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit 88cb536f99dc58fdbeb9fa6c47c26774241a0cb6)
    
    Change-Id: I174347370a83b31f68d2631c965e17d72b438cd1
    Reviewed-on: https://gerrit.openafs.org/12902
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 0247eb0a8c154811f495142276029a617ae0825a
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Sat Dec 30 17:59:38 2017 -0500

    autoconf: refactor linux-checks.m4
    
    Further refactoring of the autoconf macros. Divy up the linux kernel
    checks into smaller files.
    
    This is a non-functional change. Care has been taken preserve the
    ordering of the autoconf tests. Except for whitespace, the generated
    configure file has not been changed by this refactoring.  This has been
    verified with a 'diff -u -w -B' comparison of the generated configure
    file before and after applying this commit.
    
    Reviewed-on: https://gerrit.openafs.org/12844
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit 6a2b85cd4c00a08e165cb96d2cb56bf87c6324bc)
    
    Change-Id: Iae325bc14fb160f27791b2f3d82198fe671badd8
    Reviewed-on: https://gerrit.openafs.org/12878
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit e05b0b10b942ba3585f6d5d505a282c2de95c243
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Sat Dec 30 12:12:59 2017 -0500

    autoconf: refactor ostype.m4
    
    Further refactoring of the autoconf macros. Move more linux and solaris
    specific checks into their own files.
    
    This is a non-functional change. Care has been taken preserve the
    ordering of the autoconf tests. Except for whitespace, the generated
    configure file has not been changed by this refactoring.  This has been
    verified with a 'diff -u -w -B' comparison of the generated configure
    file before and after applying this commit.
    
    Reviewed-on: https://gerrit.openafs.org/12843
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit 3c2e39bab7d927aa5f20d02a5e327927a4b2b553)
    
    Change-Id: I4d91753afd90e4735ab61413e757f6852750a3de
    Reviewed-on: https://gerrit.openafs.org/12877
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit e54963757320adb95b0c73bbd84fb8bf34319210
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Fri Dec 29 14:24:28 2017 -0500

    autoconf: refactor acinclude.m4
    
    The acinclude.m4 is very large and often requires to be changed for
    unrelated commits.  Divy up the large acinclude.m4 into a number of
    smaller files to avoid so many contentions and to make the autoconf
    system easier to maintain.
    
    This is a non-functional change. Care has been taken preserve the
    ordering of the autoconf tests. Except for whitespace, the generated
    configure file has not been changed by this refactoring.  This has been
    verified with a 'diff -u -w -B' comparison of the generated configure
    file before and after applying this commit.
    
    Reviewed-on: https://gerrit.openafs.org/12842
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit c72622a244e561173e86ffe88ee3c9a8c823a76a)
    
    Change-Id: I9504eaa2430fd35f79b55c3df96c82cc7e58fafd
    Reviewed-on: https://gerrit.openafs.org/12876
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 0798b54b258f48cae8a5b1b3e107a22693d37937
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Mon Feb 8 12:12:22 2016 -0500

    CellServDB update 14 Mar 2017
    
    Update all remaining copies of CellServDB in the tree, and make the
    Red Hat packaging use it by default too.
    
    Reviewed-on: https://gerrit.openafs.org/12880
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit 3ca1352170f87994d42578c5bc75e52c4103bc69)
    
    Change-Id: I773d35745e14903dd3069a0627932153900e0ba6
    Reviewed-on: https://gerrit.openafs.org/12889
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 5eb64632fd76bb7e26a90ab08c83132e7ac99e23
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Wed Jan 17 17:33:50 2018 -0500

    redhat: fix conditional for kernel-debuginfo files directive
    
    Commit 443dd5367e0cd9050ad39a6594c5be521271b4e9 added support for a
    separate debuginfo package for the kernel module.  Unfortunately, the
    %files directive for the kernel module debuginfo package was incorrectly
    placed in the %if stanza of the build_userspace condition, so the
    rpmbuild fails when attempting to build just the kernel module.
    
    That is, when running rpmbuild with the options:
    
        rpmbuild --define "build_userspace 0" --define "build_modules 1" ...
    
    rpmbuild fails with:
    
        RPM build errors:
           Installed (but unpackaged) file(s) found:
           /usr/lib/debug/lib/modules/.../extra/openafs/openafs.ko.debug
    
    Fix this by moving the new %files directive out of the build_userspace
    conditional.
    
    Reviewed-on: https://gerrit.openafs.org/12874
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit f599e1ce6354c42a9c0c8f7205ba8a03c35ea72b)
    
    Change-Id: I07e25d3dd43b2cd7056cefb8f0f5c10f78347b85
    Reviewed-on: https://gerrit.openafs.org/12875
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 781624f7f4290a1f44a0f48a04d780e10dd5b3e1
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Fri Jul 21 22:30:43 2017 -0400

    redhat: avoid rpmbuild exclude directives
    
    Older versions of rpmbuild do not support the files exclude directive,
    so fall back to the old way in which we remove the files to be excluded
    and list the files to be included.
    
    Reviewed-on: https://gerrit.openafs.org/12733
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit a71288a387095ccb4be83c1abae34ada80f53185)
    
    Change-Id: I01c20bc21ec6143be76458c311d826023c370d51
    Reviewed-on: https://gerrit.openafs.org/12873
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 9d62e1d5c6e9e888a029a0b6080c27c0b4353ba2
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Fri Jul 21 22:16:44 2017 -0400

    redhat: move .krb variants to the kauth-client subpackage
    
    Move the deprecated klog.krb, pagsh.krb, and tokens.krb programs and man
    pages to the optional openafs-kauth-client subpackage.
    
    Reviewed-on: https://gerrit.openafs.org/12732
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit 4d247e1ae446c512031511273d556ef1fd32dca1)
    
    Change-Id: I3c6164022b07f0c3283cb54ffd26e1f9c3dd67bb
    Reviewed-on: https://gerrit.openafs.org/12872
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit ea1bf1bd751d391d49bdb33e2e3f2cc79fe8ccde
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Thu Jul 20 04:13:04 2017 -0400

    redhat: specify man pages without wildcards
    
    Currently, some of the man pages are specified with the full name and
    some are specified with a wildcard for the filename extension. Instead,
    specify all the man pages without a wildcards to be more consistent and
    to avoid putting incorrect man pages in packages.
    
    This change removes a stray copy the klog.krb5.1 man page from
    openafs-kauth-client subpackage and moves the AuthLog/AuthLog.dir man
    pages to the optional openafs-kauth-server subpackage.
    
    Reviewed-on: https://gerrit.openafs.org/12731
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit 671db4ca5a76625d9b7133510cc1cbdda8a5d9b9)
    
    Change-Id: I9d10cc7aad94a2dc004526acb426a9b9badc8e3c
    Reviewed-on: https://gerrit.openafs.org/12871
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit f56ea0e095f4837a65762f5a8fbc6b5c9d58a394
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Fri Jul 21 18:05:48 2017 -0400

    redhat: remove afsd.fuse man page
    
    The afsd.fuse binary is not currently packaged; do not package the man
    page.
    
    Reviewed-on: https://gerrit.openafs.org/12730
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit a9810b829bdccfed4d1718b11cf4dd51f9565e00)
    
    Change-Id: I7c829a492e999cc989e9341e94f56d6669722a4c
    Reviewed-on: https://gerrit.openafs.org/12870
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 79188311b418b39539e0772725b9754130864c11
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Tue Dec 26 17:42:39 2017 -0600

    Make OpenAFS 1.8.0pre4
    
    Update version strings for the fourth 1.8.0 prerelease.
    
    Change-Id: Ib7defe21ca5e5a8c2214879633a467e002f3269b
    Reviewed-on: https://gerrit.openafs.org/12837
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Stephan Wiesand <stephan.wiesand@desy.de>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 90bc3cf9355e3f60455d744b3e00315507e17b92
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Tue Dec 26 17:41:59 2017 -0600

    Update NEWS for 1.8.0pre4
    
    Change-Id: I0ba71b1e837309b36db39895914b6a8b9380a81f
    Reviewed-on: https://gerrit.openafs.org/12836
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Stephan Wiesand <stephan.wiesand@desy.de>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 4feec06c7bdc7102ae654cff20eb02650ec32800
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Thu Nov 30 20:26:46 2017 -0500

    LINUX: Avoid d_invalidate() during afs_ShakeLooseVCaches()
    
    With recent changes to d_invalidate's semantics (it returns void in Linux 3.11,
    and always returns success in RHEL 7.4), it has become increasingly clear that
    d_invalidate() is not the best function for use in our best-effort
    (nondisruptive) attempt to free up vcaches that is afs_ShakeLooseVCaches().
    The new d_invalidate() semantics always force the invalidation of a directory
    dentry, which contradicts our desire to be nondisruptive, especially when
    that directory is being used as the current working directory for a process.
    Our call to d_invalidate(), intended to merely probe for whether a dentry
    can be discarded without affecting other consumers, instead would cause
    processes using that dentry as a CWD to receive ENOENT errors from getcwd().
    
    A previous commit (c3bbf0b4444db88192eea4580ac9e9ca3de0d286) tried to address
    this issue by calling d_prune_aliases() instead of d_invalidate(), but
    d_prune_aliases() does not recursively descend into children of the given
    dentry while pruning, leaving it an incomplete solution for our use-case.
    
    To address these issues, modify the shakeloose routine TryEvictDentries() to
    call shrink_dcache_parent() and maybe __d_drop() for directories, and
    d_prune_aliases() for non-directories, instead of d_invalidate().  (Calls to
    d_prune_aliases() for directories have already been removed by reverting commit
    c3bbf0b4444db88192eea4580ac9e9ca3de0d286.)
    
    Just like d_invalidate(), shrink_dcache_parent() has been around "forever"
    (since pre-git v2.6.12).  Also like d_invalidate(), it "walks" the parent
    dentry's subdirectories and "shrinks" (unhashes) unused dentries.  But unlike
    d_invalidate(), shrink_dcache_parent() will not unhash an in-use dentry, and
    has never changed its signature or semantics.
    
    d_prune_aliases() has also been available "forever", and has also never changed
    its signature or semantics.  The lack of recursive descent is not an issue for
    non-directories, which cannot have such children.
    
    [kaduk@mit.edu: apply review feedback to fix locking and avoid extraneous
    changes, and reword commit message]
    
    Reviewed-on: https://gerrit.openafs.org/12830
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    (cherry picked from commit afbc199f152cc06edc877333f229604c28638d07)
    
    Change-Id: I6d37e5584b57dcbb056385a79f67b92a363e08d2
    Reviewed-on: https://gerrit.openafs.org/12851
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Tested-by: Benjamin Kaduk <kaduk@mit.edu>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 4b633c9681057122b9266b8a775d0ad5aa0a3ac3
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Thu Nov 30 17:56:13 2017 -0500

    LINUX: consolidate duplicate code in osi_TryEvictDentries
    
    The two stanzas for HAVE_DCACHE_LOCK are now functionally identical;
    remove the preprocessor conditionals and duplicate code.
    
    Minor functional change is incurrred for very old (before 2.6.38) Linux
    versions that have dcache_lock; we are now obtaining the d_lock as well.
    
    This is safe because d_lock is also quite old (pre-git, 2.6.12), and it
    is a spinlock that's only held for checking d_unhashed.  Therefore, it
    should have negligible performance impact.  It cannot cause deadlocks or
    violate locking order, because spinlocks can't be held across sleeps.
    
    Reviewed-on: https://gerrit.openafs.org/12792
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Reviewed-by: Andrew Deason <adeason@dson.org>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    (cherry picked from commit 5076dfc14b980aed310f3862875d5e9919fa199d)
    
    Change-Id: I7a17494b40c049a562dec20c50c27125f54436d0
    Reviewed-on: https://gerrit.openafs.org/12850
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 16c0dbd7961fb599ed9f29d700d1a713902bd96d
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Thu Nov 30 16:51:32 2017 -0500

    LINUX: consolidate duplicate code in canonical_dentry
    
    The two stanzas for HAVE_DCACHE_LOCK are now identical;
    remove the preprocessor conditionals and duplicate code.
    
    No functional change should be incurred by this commit.
    
    Reviewed-on: https://gerrit.openafs.org/12791
    Reviewed-by: Andrew Deason <adeason@dson.org>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    (cherry picked from commit 0678ad26b6069040a6ea86866fb59ef5968ea343)
    
    Change-Id: If0f9516201cea747a753db04ba2d0e2cac69971b
    Reviewed-on: https://gerrit.openafs.org/12849
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit c42dea8e0293016ec30fa703956c8bbc5d5cb76d
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Thu Nov 30 16:46:16 2017 -0500

    LINUX: add afs_d_alias_lock & _unlock compat wrappers
    
    Simplify some #ifdefs for HAVE_DCACHE_LOCK by pushing them down into
    new helpers in osi_compat.h.
    
    No functional change should be incurred by this commit.
    
    Reviewed-on: https://gerrit.openafs.org/12790
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    (cherry picked from commit 652cd597d9b3cf1a9daccbbf6bf35f1b0cd55a94)
    
    Change-Id: I6aec7d6a21e68011ca10ceaa15e83d80f52fad59
    Reviewed-on: https://gerrit.openafs.org/12848
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 0ec02ef73d7b94bbe83e7532524c096799cd4b25
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Thu Nov 30 16:08:38 2017 -0500

    LINUX: create afs_linux_dget() compat wrapper
    
    For dentry operations that cover multiple dentry aliases of
    a single inode, create a compatibility wrapper to hide differences
    between the older dget_locked() and the current dget().
    
    No functional change should be incurred by this commit.
    
    Reviewed-on: https://gerrit.openafs.org/12789
    Reviewed-by: Andrew Deason <adeason@dson.org>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    (cherry picked from commit 74f4bfc627c836c12bb7c188b86d570d2afdcae8)
    
    Change-Id: Id854e5957547a1370cadb400f7f699c30d861fd1
    Reviewed-on: https://gerrit.openafs.org/12847
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit ae70407fafa3faa94706979c727f53a625939061
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Thu Nov 30 13:45:27 2017 -0500

    Revert "LINUX: do not use d_invalidate to evict dentries"
    
    Linux recently changed the semantics of d_invalidate() to:
    - return void
    - invalidate even a current working directory
    
    OpenAFS commit c3bbf0b4444db88192eea4580ac9e9ca3de0d286 switched libafs
    to use d_prune_aliases() instead.
    
    However, since that commit, several things have happened:
    - RHEL 7.4 changed the semantics of d_invalidate() such that it
      invalidates the cwd, but did NOT change the return type to void.
      This broke our autoconf test for detecting the new semantics.
    - Further research reveals that d_prune_aliases() was not the best
      choice for replacing d_invalidate().  This is because for directories,
      d_prune_aliases() doesn't invalidate dentries when they are referenced
      by its children, and it doesn't walk the tree trying to invalidate
      child dentries.  So it can leave dentries dangling, if the only
      references to thos dentries are via children.
    
    In preparation for future commits, revert
    c3bbf0b4444db88192eea4580ac9e9ca3de0d286 .
    
    Reviewed-on: https://gerrit.openafs.org/12788
    Reviewed-by: Andrew Deason <adeason@dson.org>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    (cherry picked from commit 367693bd7da2de593e3329f6acc4a4d07621fb97)
    
    Change-Id: I3dfa9127adf8424fe675e237194d6ade5a7fc4f1
    Reviewed-on: https://gerrit.openafs.org/12846
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 2a06e32c398bbb9e74258799d87a599d286f97d9
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Thu Nov 30 14:04:48 2017 -0500

    Revert "LINUX: eliminate unused variable warning"
    
    This reverts commit 19599b5ef5f7dff2741e13974692fe4a84721b59
    to allow also reverting commit
    c3bbf0b4444db88192eea4580ac9e9ca3de0d286 .
    
    Reviewed-on: https://gerrit.openafs.org/12787
    Reviewed-by: Andrew Deason <adeason@dson.org>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit f8247078bd33a825d8734b2c8f05120d15ab3ffd)
    
    Change-Id: I023c88e19d9f1a18b2bfaec8a35bd635f157b570
    Reviewed-on: https://gerrit.openafs.org/12845
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit e412a87b1f6a68a2c0b9e1baad1c328fdccbd41d
Author: Pat Riehecky <riehecky@fnal.gov>
Date:   Thu Mar 12 14:33:10 2015 -0500

    redhat: separate debuginfo package for kmod rpm
    
    Place the debuginfo for the kmod into its own rpm so that
    it doesn't have to track against the userspace packages.
    
    FIXES 132034
    
    Reviewed-on: https://gerrit.openafs.org/11867
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    (cherry picked from commit 443dd5367e0cd9050ad39a6594c5be521271b4e9)
    
    Change-Id: I6a24bb08242ec34c123880e9cbca4580a3560cba
    Reviewed-on: https://gerrit.openafs.org/12822
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 7a80b4ba67b0d295df72e87da4aa638bd5e245de
Author: Stephan Wiesand <stephan.wiesand@desy.de>
Date:   Fri Dec 22 14:40:32 2017 +0100

    Linux 4.15: check for 2nd argument to pagevec_init
    
    Linux 4.15 removes the distinction between "hot" and "cold" cache
    pages, and pagevec_init() no longer takes a "cold" flag as the
    second argument. Add a configure test and use it in osi_vnodeops.c .
    
    Reviewed-on: https://gerrit.openafs.org/12824
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Marcio Brito Barbosa <mbarbosa@sinenomine.net>
    Tested-by: Marcio Brito Barbosa <mbarbosa@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit fb1f14d8ee963678a9caad0538256c99c159c2c4)
    
    Change-Id: Ib9e0751e4900d984a4197d18ee9ebb1bdc7bf331
    Reviewed-on: https://gerrit.openafs.org/12829
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 2ff3ef2ec6f217195dc50c04ba4e3409c23e6a4d
Author: Stephan Wiesand <stephan.wiesand@desy.de>
Date:   Fri Dec 22 14:17:09 2017 +0100

    Linux: use plain page_cache_alloc
    
    Linux 4.15 removes the distinction between "hot" and "cold" cache
    pages, and no longer provides page_cache_alloc_cold(). Simply use
    page_cache_alloc() instead, rather than adding yet another test.
    
    Reviewed-on: https://gerrit.openafs.org/12823
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Marcio Brito Barbosa <mbarbosa@sinenomine.net>
    Tested-by: Marcio Brito Barbosa <mbarbosa@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit be5f5b2aff2d59986dd8e7dd7dd531be24c27cb2)
    
    Change-Id: I2d4df508abfa9d3c7020b8a2817ed3e882a4dbbc
    Reviewed-on: https://gerrit.openafs.org/12828
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit d9bb508e07f32219679c0e696f07f95e3b48886c
Author: Marcio Barbosa <mbarbosa@sinenomine.net>
Date:   Thu Oct 12 12:42:40 2017 -0300

    macos: make the OpenAFS client aware of APFS
    
    Apple has introduced a new file system called APFS. Starting from High
    Sierra, APFS replaces Mac OS Extended (HFS+) as the default file system
    for solid-state drives and other flash storage devices.
    
    The current OpenAFS client is not aware of APFS. As a result, the
    installation of the current client into an APFS volume will panic the
    machine.
    
    To fix this problem, make the OpenAFS client aware of APFS.
    
    Reviewed-on: https://gerrit.openafs.org/12743
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit 6e57b22642bafb177e0931b8fb24042707d6d62f)
    
    Change-Id: I60d2a57fae3ee227bb3327a5e18962f46b49c991
    Reviewed-on: https://gerrit.openafs.org/12827
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 5857724bf60e7706bcefde63d8fa0c7b2119e662
Author: Marcio Barbosa <mbarbosa@sinenomine.net>
Date:   Fri Oct 6 10:01:12 2017 -0300

    macos: packaging support for MacOS X 10.13
    
    This commit introduces the new set of changes / files required to
    successfully create the dmg installer on OS X 10.13 "High Sierra".
    
    Reviewed-on: https://gerrit.openafs.org/12742
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Marcio Brito Barbosa <mbarbosa@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit e533d0737058940d59d93467c9b4d6d3ec2834e6)
    
    Change-Id: I8932f6a3db6a0572aa36944aa339b888fac94b7d
    Reviewed-on: https://gerrit.openafs.org/12826
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit ac8cab7fcd3abf76c39e9e08c2c3d6ec0c184837
Author: Marcio Barbosa <mbarbosa@sinenomine.net>
Date:   Tue Oct 3 17:01:56 2017 -0300

    macos: add support for MacOS 10.13
    
    This commit introduces the new set of changes / files required to
    successfully build the OpenAFS source code on OS X 10.13 "High Sierra".
    
    Reviewed-on: https://gerrit.openafs.org/12741
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    (cherry picked from commit 804c9cbf501d4ca91b69ad8fd6d64e49efa25a47)
    
    Change-Id: I9abcccf8313c8ac075eb1edbd36cbaa565968b38
    Reviewed-on: https://gerrit.openafs.org/12825
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 383688fa0d6904291578eb1f9a7c2ec1e06f54ca
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Thu Dec 14 19:54:57 2017 -0600

    Fix macro used to check kernel_read() argument order
    
    The m4 macro implementing the configure check is called
    LINUX_KERNEL_READ_OFFSET_IS_LAST, but it defines a preprocessor symbol
    that is just KERNEL_READ_OFFSET_IS_LAST.  Our code needs to check
    for the latter being defined, not the former.
    
    Reported by Aaron Ucko.
    
    Reviewed-on: https://gerrit.openafs.org/12808
    Reviewed-by: Anders Kaseorg <andersk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit edc5463f3db4b6af2307741d9f4ee8f2c81cd98e)
    
    Change-Id: I7bc6615118f1200d3f257e7a01652b49b458a8fa
    Reviewed-on: https://gerrit.openafs.org/12809
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 3cae0a01d0a60dca3d3aa089c6a19d52243c75b9
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Mon Dec 4 18:14:22 2017 -0600

    Update NEWS for rx security fix
    
    Change-Id: I30282ac8f51a7b16dd851fdbd41464f8fdafc279

commit eae2575dc738bd69bb6a0a84f87f02f5cf2b4eb9
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Mon Dec 4 17:20:57 2017 -0600

    OPENAFS-SA-2017-001: rx: Sanity-check received MTU and twind values
    
    Rather than blindly trusting the values received in the
    (unauthenticated) ack packet trailer, apply some minmial sanity checks
    to received values.  natMTU and regular MTU values are subject to
    Rx minmium/maximum packet sizes, and the transmit window cannot drop
    below one without risk of deadlock.
    
    The maxDgramPackets value that can also be present in the trailer
    already has sufficient sanity checking.
    
    Extremely low MTU values (less than 28 == RX_HEADER_SIZE) can cause us
    to set a negative "maximum usable data" size that gets used as an
    (unsigned) packet length for subsequent allocation and computation,
    triggering an assertion when the connection is used to transmit data.
    
    FIXES 134450
    
    (cherry picked from commit 894555f93a2571146cb9ca07140eb98c7a424b01)
    
    Change-Id: I98e2a65d1aa291a73e8cfed9c9eaac71c6af00dc

commit 352fbc811162fcdaa39cb7834475f40ba72fad11
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Wed Nov 8 07:11:45 2017 -0600

    Make OpenAFS 1.8.0pre3
    
    Update the version strings for the third 1.8.0 prerelease.
    
    Change-Id: I25a4eee4de04e57ffcf9055f69ae9a3d683b8d64
    Reviewed-on: https://gerrit.openafs.org/12765
    Reviewed-by: Stephan Wiesand <stephan.wiesand@desy.de>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 1efc44f397efb647a55347cb71e7d41c050f6c3c
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Mon Nov 6 21:30:04 2017 -0600

    Update NEWS for 1.8.0pre3
    
    Change-Id: I38110825cbe8b5c4ca18d86e4542374ae26f6fd4
    Reviewed-on: https://gerrit.openafs.org/12764
    Reviewed-by: Stephan Wiesand <stephan.wiesand@desy.de>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>

commit e2c47cae56ba0d804af119fb158a9fe77fa3a15e
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Mon Nov 27 22:17:28 2017 -0600

    afs: Fix bounds check in PNewCell
    
    Reported by the opensuse buildbot:
    
      CC [M]  /home/buildbot/opensuse-tumbleweed-i386-builder/build/src/libafs/MODLOAD-4.13.12-1-default-MP/rx_packet.o
    /home/buildbot/opensuse-tumbleweed-i386-builder/build/src/afs/afs_pioctl.c: In function ‘PNewCell’:
    /home/buildbot/opensuse-tumbleweed-i386-builder/build/src/afs/afs_pioctl.c:3075:55: error: ‘*’ in boolean context, suggest ‘&&’ instead [-Werror=int-in-bool-context]
         if ((afs_pd_remaining(ain) < AFS_MAXCELLHOSTS +3) * sizeof(afs_int32))
             ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~
    
    The bug was introduced in commit 718f85a8b6.
    
    Reviewed-on: https://gerrit.openafs.org/12782
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit 4fa0ee620cfb9991ca9748b5ee116cc8e1e6c505)
    
    Change-Id: I0963403846a62dddf2d13ce3c03d772a6d869119
    Reviewed-on: https://gerrit.openafs.org/12784
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 6e611c56c5b910e329c20c3a20ed2ba5755b0461
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Mon Nov 27 22:07:53 2017 -0600

    rx: fix call refcount leak in error case
    
    The recent event handling normalization in commit
    304d758983b499dc568d6ca57b6e92df24b69de8 had event handlers switch
    to dropping their reference on the associated connection/call just
    before return.  An early return case was missed in the conversion,
    leading to a refcount leak in an error case.
    
    Reviewed-on: https://gerrit.openafs.org/12781
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit 66b74e78ba5fea6a8236dcd3b8b46e1dfa6a0ac7)
    
    Change-Id: I532c49b2ef6ec95dd26a99c02e12ea53348f9690
    Reviewed-on: https://gerrit.openafs.org/12783
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit ad11867973dc2481ee4897540a6d9279ebf36c42
Author: Marcio Barbosa <mbarbosa@sinenomine.net>
Date:   Thu Nov 16 17:24:03 2017 -0500

    afs: fix kernel_write / kernel_read arguments
    
    The order / content of the arguments passed to kernel_write and
    kernel_read are not right. As a result, the kernel will panic if one of
    the functions in question is called.
    
    [kaduk@mit.edu: include configure check for multiple kernel_read()
    variants, per linux commits bdd1d2d3d251c65b74ac4493e08db18971c09240
    and e13ec939e96b13e664bb6cee361cc976a0ee621a]
    
    FIXES 134440
    
    Reviewed-on: https://gerrit.openafs.org/12769
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Tested-by: Marcio Brito Barbosa <mbarbosa@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit 3ce55426ee6912b78460465bcaa1428333ad1fbc)
    
    Change-Id: I28f04f7625a471c37f98515d5186f80082bf6a43
    Reviewed-on: https://gerrit.openafs.org/12780
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 42993b3a33d53a6e16337d2ebe15539d0febdef1
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Mon Nov 6 17:37:46 2017 -0500

    tests: fix out of bounds access in the rx-event test
    
    Use the NUMEVENTS symbol which defines the array size instead of an
    incorrect hard coded number when checking if a second event can be added
    to be fired at the same time.  This fixes a potential out of bounds
    access of the event test array.
    
    Also update the comment which incorrectly mentions the incorrect number
    of events in the test.
    
    Reviewed-on: https://gerrit.openafs.org/12762
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    (cherry picked from commit 50a3eb7b7ee94bffaadc98429bd404164e89ec7f)
    
    Change-Id: I7a975e7498c1c7416a800c9294c97ee4de4fd57a
    Reviewed-on: https://gerrit.openafs.org/12779
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 6c635a66b54bcfa2920ac532905758346c89c772
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Thu Nov 16 04:49:49 2017 -0600

    Sprinkle rx_GetConnection() for concision
    
    Instead of inlining the body (taking the lock, incrementing the
    refcount, and dropping the lock), use the convenience function
    designed for this purpose.
    
    Reviewed-on: https://gerrit.openafs.org/12772
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit 2ae84bf053fe66b73a2c77b5d71305bae2c17587)
    
    Change-Id: I60794d877a76fbb7c8ba59207e710a20641cc8f1
    Reviewed-on: https://gerrit.openafs.org/12778
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 667617b8702e797e34cc957ef200a803030ee901
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Thu Nov 16 04:48:02 2017 -0600

    rx: fix mutex leak in error case
    
    Reported by Mark Vitale
    
    Reviewed-on: https://gerrit.openafs.org/12771
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit 01bcfd3e14f6ee1faa4b8ce5a7932de37d585fd3)
    
    Change-Id: I4384d6813a5cfb053e6991eb3c157fa59ecfa11b
    Reviewed-on: https://gerrit.openafs.org/12777
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 4220eadae01d09b2c54e16c689b1a58e558db19c
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Tue Oct 31 19:49:09 2017 -0500

    Add event-related mutex assertions
    
    In utility functions that access fields of type struct rxevent *,
    assert that the appropriate lock is held for the access in question.
    
    These assertions are only compiled in when built with -DOPR_DEBUG_LOCKS,
    which can be enbled by --debug-locks at configure time.
    
    Reviewed-on: https://gerrit.openafs.org/12757
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit a7a3108e602c83176c5578c9f28b6312f71aba78)
    
    Change-Id: I147a2e475feffb1b75a08ac5b08614bd6d8f46a5
    Reviewed-on: https://gerrit.openafs.org/12776
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 8ce3b5e253d980ebab34c3928720d1097b1ba342
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Sat Oct 7 22:42:38 2017 -0500

    Standardize rx_event usage
    
    Go over all consumers of the rx event framework and normalize its usage
    according to the following principles:
    
    rxevent_Post() is used to create an event, and it returns an event
    handle (with a reference on the event structure) that can be used
    to cancel the event before its timeout fires.  (There is also an
    additional reference on the event held by the global event tree.)
    In all(*) usage within the tree, that event handle is stored within
    either an rx_connection or an rx_call.  Reads/writes to the member variable
    that holds the event handle require either the conn_data_lock or call
    lock, respectively -- that means that in most cases, callers of
    rxevent_Post() and rxevent_Cancel() will be holding one of those
    aforementioned locks.  The event handlers themselves will need to
    modify the call/connection object according to the nature of the
    event, which requires holding those same locks, and also a guarantee
    that the call/connection is still a live object and has not been
    deallocated!  Whether or not rxevent_Cancel() succeeds in cancelling
    the event before it fires, whenever passed a non-NULL event structure
    it will NULL out the supplied pointer and drop a reference on the
    event structure.  This is the correct behavior, since the caller
    has asked to cancel the event and has no further use for the event
    handle or its reference on the event structure.  The caller of
    rxevent_Cancel() must check its return value to know whether or
    not the event was cancelled before its handler was able to run.
    
    The interaction window between the call/connection lock and the lock
    protecting the red/black tree of pending events opens up a somewhat
    problematic race window.  Because the application thread is expected
    to hold the call/connection lock around rxevent_Cancel() (to protect
    the write to the field in the call/connection structure that holds
    an event handle), and rxevent_Cancel() must take the lock protecting
    the red/black tree of events, this establishes a lock order with the
    call/connection lock taken before the eventTree lock.  This is in
    conflict with the event handler thread, which must take the eventTree
    lock first, in order to select an event to run (and thus know what
    additional lock would need to be taken, by virtue of what handler
    function is to be run).  The conflict is easy to resolve in the
    standard way, by having a local pointer to the event that is obtained
    while the event is removed from the red/black tree under the eventTree
    lock, and then the eventTree lock can be dropped and the event run
    based on the local variable referring to it.  The race window occurs
    when the caller of rxevent_Cancel() holds the call/connection lock,
    and rxevent_Cancel() obtains the eventTree lock just after the event
    handler thread drops it in order to run the event.  The event handler
    function begins to execute, and immediately blocks trying to obtain
    the call/connection lock.  Now that rxevent_Cancel() has the eventTree
    lock it can proceed to search the tree, fail to find the indicated event
    in the tree, clear out the event pointer from the call/connection
    data structure, drop its caller's reference to the event structure,
    and return failure (the event was not cancelled).  Only then does the
    caller of rxevent_Cancel() drop the call/connection lock and allow
    the event handler to make progress.
    
    This race is not necessarily problematic if appropriate care is taken,
    but in the previous code such was not the case.  In particular, it
    is a common idiom for the firing event to call rxevent_Put() on itself,
    to release the handle stored in the call/connection that could have
    been used to cancel the event before it fired.  Failing to do so would
    result in a memory leak of event structures; however, rxevent_Put() does
    not check for a NULL argument, so a segfault (NULL dereference) was
    observed in the test suite when the race occurred and the event handler
    tried to rxevent_Put() the reference that had already been released by
    the unsuccessful rxevent_Cancel() call.  Upon inspection, many (but not
    all) of the uses in rx.c were susceptible to a similar race condition
    and crash.
    
    The test suite also papers over a related issue in that the event handler
    in the test suite always knows that the data structure containing the
    event handle will remain live, since it is a global array that is allocated
    for the entire scope of the test.  In rx.c, events are associated with
    calls and connections that have a finite lifetime, so we need to take care
    to ensure that the call/connection pointer stored in the event remains
    valid for the duration of the event's lifecycle.  In particular, even an
    attempt to take the call/connection lock to check whether the corresponding
    event field is NULL is fraught with risk, as it could crash if the lock
    (and containing call/connection) has already been destroyed!  There are
    several potential ways to ensure the liveness of the associated
    call/connection while the event handler runs, most notably to take care
    in the call/connection destruction path to ensure that all associated
    events are either successfully cancelled or run to completion before
    tearing down the call/connection structure, and to give the pending event
    its own reference on the associated call/connection.  Here, we opt for
    the latter, acknowledging that this may result in the event handler thread
    doing the full call/connection teardown and delay the firing of subsequent
    events.  This is deemed acceptable, as pending events are for intentionally
    delayed tasks, and some extra delay is probably acceptable.  (The various
    keepalive events and the challenge event could delay the user experience
    and/or security properties if significantly delayed, but I do not believe
    that this change admits completely unbounded delay in the event handler
    thread, so the practical risk seems minimal.)
    
    Accordingly, this commit attempts to ensure that:
    
    * Each event holds a formal reference on its associated call/connection.
    * The appropriate lock is held for all accesses to event pointers in
      call/connection structures.
    * Each event handler (after taking the appropriate lock) checks whether
      it raced with rxevent_Cancel() and only drops the call/connection's
      reference to the event if the race did not occur.
    * Each event handler drops its reference to the associated call/connection
      *after* doing any actions that might access/modify the call/connection.
    * The per-event reference on the associated call/connection is dropped by
      the thread that removes the event from the red/black tree.  That is,
      the event handler function if the event runs, or by the caller of
      rxevent_Cancel() when the cancellation succeed.
    * No non-NULL event handles remain in a call/connection being destroyed,
      which would indicate a refcounting error.
    
    (*) There is an additional event used in practice, to reap old connections,
        but it is effectively a background task that reschedules itself
        periodically, with no handle to the event retained so as to be able
        to cancel it.  As such, it is unaffected by the concerns raised here.
    
    While here, standardize on the rx_GetConnection() function for incrementing
    the reference count on a connection object, instead of inlining the
    corresponding mutex lock/unlock and variable access.
    
    In contrast to what was done on master, for the 1.8 branch we do not
    force-enable refcount checking.
    
    Reviewed-on: https://gerrit.openafs.org/12756
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit 304d758983b499dc568d6ca57b6e92df24b69de8)
    
    Change-Id: I68e6cc162a148b6ebbabe037a7bc3cccd648423c
    Reviewed-on: https://gerrit.openafs.org/12775
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit 6db2c0a111336a24199c0acf4e02635c97f4ff2b
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Wed Oct 4 23:03:44 2017 -0500

    Adjust rx-event test to exercise cancel/fire race
    
    We currently do not properly handle the case where a thread runs
    rxevent_Cancel() in parallel with the event-handler thread attempting
    to fire that event, but the test suite only picked up on this issue
    in a handful of the Debian automated builds (somewhat less-resourced
    ones, perhaps).
    
    Modify the event scheduling algorithm in the test so as to create a
    larger chunk of events scheduled to fire "right away" and thereby
    exercise the race condition more often when we proceed to cancel
    a quarter of events "right away".
    
    Reviewed-on: https://gerrit.openafs.org/12755
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit bdb509fb1d8e0fdca05dffecdbcbf60a95ea502e)
    
    Change-Id: I27cebed3c2c3daff10b8d3f5f6f949e667791a72
    Reviewed-on: https://gerrit.openafs.org/12774
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 527ead6fdd8acd241db04cf4c43677248b59d164
Author: Michael Laß <lass@mail.uni-paderborn.de>
Date:   Thu Nov 2 21:16:49 2017 +0100

    gtx: link against libtinfo if termlib is seperated
    
    If ncurses is built with "./configure --with-termlib=tinfo", gtx fails
    to link because of an undefined reference to the LINES symbol which is
    then provided by libtinfo.so and not libncurses.so.
    
    If ncurses is present, additionally check whether LINES is provided by
    ncurses or tinfo and set $LIB_curses accordingly.
    
    This change is based on a patch provided by Bastian Beischer.
    
    FIXES 134420
    
    Reviewed-on: https://gerrit.openafs.org/12760
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit 311f1d28a2f626350b33ad432e674055b62511bd)
    
    Change-Id: I2f69fe51bbefeeb2a17145a88aa9c891644f2f61
    Reviewed-on: https://gerrit.openafs.org/12763
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Michael Laß <lass@mail.uni-paderborn.de>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit d93f80622370f50d7bce5c5b00cd062f15ee9eba
Author: Damien Diederen <ddiederen@sinenomine.net>
Date:   Mon Sep 18 12:18:39 2017 +0200

    Linux: Use kernel_read/kernel_write when __vfs variants are unavailable
    
    We hide the uses of set_fs/get_fs behind a macro, as those functions
    are likely to soon become unavailable:
    
    > Christoph Hellwig suggested removing all calls outside of the core
    > filesystem and architecture code; Andy Lutomirski went one step
    > further and said they should all go.
    
        https://lwn.net/Articles/722267/
    
    Reviewed-on: https://gerrit.openafs.org/12729
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit 5ee516b3789d3545f3d78fb3aba2480308359945)
    
    Change-Id: I28a7126bf6ab048f8d949f190e557a3fa44f3f46
    Reviewed-on: https://gerrit.openafs.org/12737
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit c42a25d28fbcc76fdcac2b5f29704f8f1b353b45
Author: Damien Diederen <ddiederen@sinenomine.net>
Date:   Mon Sep 18 11:59:40 2017 +0200

    Linux: Test for __vfs_write rather than __vfs_read
    
    The following commit:
    
        commit eb031849d52e61d24ba54e9d27553189ff328174
        Author: Christoph Hellwig <hch@lst.de>
        Date:   Fri Sep 1 17:39:23 2017 +0200
    
            fs: unexport __vfs_read/__vfs_write
    
    unexports both __vfs_read and __vfs_write, but keeps the former in
    fs.h--as it is is still being used by another part of the tree.
    
    This situation results in a false positive in our Autoconf check,
    which does not see the export statements, and ends up marking the
    corresponding API as available.
    
    That, in turn, causes some code which assumes symmetry with
    __vfs_write to fail to compile.
    
    Switch to testing for __vfs_write, which correctly marks the API as
    unavailable.
    
    Reviewed-on: https://gerrit.openafs.org/12728
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit 929e77a886fc9853ee292ba1aa52a920c454e94b)
    
    Change-Id: I03e3c8222360a6b04b45b45a8f56b5df054f6783
    Reviewed-on: https://gerrit.openafs.org/12736
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit bc384b7d5e4818c567a64fe4a935f021d936444f
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Mon Oct 16 16:53:22 2017 -0500

    Correct m4 conditionals in curses.m4
    
    AS_IF does not invoke the test(1) shell builtin for us, so we must
    take care to consistently use it ourself.
    
    While here, sprinkle some missing double-quotes around variable
    expansions in AS_IF statements in this file.
    
    Submitted by Bastian Beischer.
    
    FIXES 134414
    
    Change-Id: Iccfe311011f17de6317cf64abdc58b0812b81b8c
    Reviewed-on: https://gerrit.openafs.org/12738
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: Benjamin Kaduk <kaduk@mit.edu>
    (cherry picked from commit e0c5ada214596d5adb6798682d5e280cc99f447c)
    Reviewed-on: https://gerrit.openafs.org/12739

commit 688b3570867cda3035ec6bcd9c7538cf651f38f6
Author: Anders Kaseorg <andersk@mit.edu>
Date:   Fri Sep 1 23:37:07 2017 -0400

    vol: Fix two buffers being one char too short
    
    Fixes these warnings:
    
    namei_ops.c: In function 'namei_copy_on_write':
    namei_ops.c:1328:31: warning: 'snprintf' output may be truncated before the last format character [-Wformat-truncation=]
      snprintf(path, sizeof(path), "%s-tmp", name.n_path);
                                   ^~~~~~~~
    namei_ops.c:1328:2: note: 'snprintf' output between 5 and 260 bytes into a destination of size 259
      snprintf(path, sizeof(path), "%s-tmp", name.n_path);
      ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    vol_split.c: In function 'split_volume':
    vol_split.c:576:22: warning: 'sprintf' may write a terminating nul past the end of the destination [-Wformat-overflow=]
         sprintf(symlink, "#%s", V_name(newvol));
                          ^~~~~
    vol_split.c:576:5: note: 'sprintf' output between 2 and 33 bytes into a destination of size 32
         sprintf(symlink, "#%s", V_name(newvol));
         ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    Reviewed-on: https://gerrit.openafs.org/12722
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    (cherry picked from commit 0a9a6b57ce6e1c97fcc651c8cb74e66fc8422a1e)
    
    Change-Id: Ia60439aed7925b786a0213d96a7afb413579e01f
    Reviewed-on: https://gerrit.openafs.org/12723
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 7073408688da021864bba59c592e8924e05adb91
Author: Seth Forshee <seth.forshee@canonical.com>
Date:   Tue Aug 22 07:59:11 2017 -0500

    Linux: Include linux/uaccess.h rather than asm/uaccess.h if present
    
    Starting with Linux 4.12 there is a module build error on s390
    due to asm/uaccess.h using a macro defined in the common header.
    The common header has been around since 2.6.18 and has always
    included asm/uaccess.h, so switch to using the common header
    whenever it is present.
    
    Signed-off-by: Seth Forshee <seth.forshee@canonical.com>
    Reviewed-on: https://gerrit.openafs.org/12714
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    (cherry picked from commit 962f4838dc461567d896304f617a0923745d13d5)
    
    Change-Id: I5a7834b982458159804bc4d940e39ef283253299
    Reviewed-on: https://gerrit.openafs.org/12718
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit a3812407f28439bb69f052f0115171cdf04927da
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Tue Aug 1 20:43:41 2017 -0500

    Make OpenAFS 1.8.0pre2
    
    Update the version strings for the second 1.8.0 prerelease.
    
    Change-Id: I3e3f950d0565b877a4da4f8843a015ac392484d5
    Reviewed-on: https://gerrit.openafs.org/12683
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Stephan Wiesand <stephan.wiesand@desy.de>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit bfc5d1ada2f5ce12bfafe65d352982adbefe9911
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Tue Aug 1 20:57:52 2017 -0500

    Remove src/mcas
    
    This lock-free library toolkit is intriguing and may be the subject
    of future work, but such development will occur on the master branch,
    and these files are just clutter on openafs-stable-1_8_x.  Remove
    them to give the tree a more clean start.
    
    Remove src/mcas and stop mentioning it in SOURCE-MAP; don't reference
    it in the rpctests, either.
    
    Change-Id: I21b1b6b64a709fe40aa53aaf3470d128c0dc2f86
    Reviewed-on: https://gerrit.openafs.org/12682
    Tested-by: Benjamin Kaduk <kaduk@mit.edu>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Stephan Wiesand <stephan.wiesand@desy.de>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 7c2ce4040e94e954e51945daac03cc39e885d3ce
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Tue Aug 1 20:55:52 2017 -0500

    Remove src/rxgk
    
    These files were commited slightly prematurely to the tree; rxgk
    support is intended for the 2.0 release, and will not appear in the
    1.8.x release series.
    
    Remove src/rxgk and drop mentions of rxgk from configure/Makefile.in/etc.
    
    Change-Id: Ib7d40eaac85b05d920781b61f73dbdf8fedfcc2b
    Reviewed-on: https://gerrit.openafs.org/12681
    Tested-by: Benjamin Kaduk <kaduk@mit.edu>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Stephan Wiesand <stephan.wiesand@desy.de>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit e739eaa650ee30dcce54d05908b062839eafbf73
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Fri Apr 14 20:38:27 2017 -0400

    redhat: move bosserver and fssync-debug man pages
    
    Move the bosserver and fssync-debug/dafssync-debug man pages to the
    openafs-server package, which distributes those programs.
    
    Change-Id: I9c84ad485834177fd43b28acd444d3d54c648cc8
    Reviewed-on: https://gerrit.openafs.org/12601
    Reviewed-by: Stephan Wiesand <stephan.wiesand@desy.de>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: Benjamin Kaduk <kaduk@mit.edu>

commit 5b79f95f7457f203213a9170389b17ffcc0208f7
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Thu Apr 13 21:48:06 2017 -0400

    redhat: kauth client and server sub-packages
    
    Move the kaserver and kauth client programs to conditionally built
    packages called openafs-kauth-server and openafs-kauth-client.
    Packagers can build these by specifying '--with kauth'. They are not
    built by default to discourage use.
    
    This commit subsumes the openafs-kpasswd package into the
    openafs-kauth-client package.
    
    Change-Id: I1322f05d7fe11d466c9ed71a5059c21b759d95ab
    Reviewed-on: https://gerrit.openafs.org/12600
    Reviewed-by: Stephan Wiesand <stephan.wiesand@desy.de>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: Benjamin Kaduk <kaduk@mit.edu>

commit 54e478328fa24aa2629398c5ddfad7b50d353dd7
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Mon Apr 10 15:06:02 2017 -0400

    redhat: do not package kauth by default
    
    Do not package kaserver and related programs by default to discourage
    use. Add the '--with kauth' rpmbuild option to allow packagers to
    continue include the kauth programs for compatibility.
    
    Change-Id: I8bf9f6dc221afc22ed6c9a33cf101d705e6c4920
    Reviewed-on: https://gerrit.openafs.org/12597
    Reviewed-by: Stephan Wiesand <stephan.wiesand@desy.de>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: Benjamin Kaduk <kaduk@mit.edu>

commit 6d59b7c4b4b712160a6d60491c95c111bb831fbb
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Sun Jul 30 20:57:05 2017 -0500

    Default to crypt mode for unix clients
    
    Though the protection offered by rxkad, even with rxkad-k5 and rxkad-kdf, is
    insufficient to protect traffic from a determined attacker, it remains the
    case that the internet is not a safe place for user data to travel in the
    clear, and has not been for a long time.  The Windows client encrypts by
    default, and all or nearly all the Unix client packaging scripts set crypt
    mode by default.  Catch up to reality and default to crypt mode in the
    Unix cache manager.
    
    Change-Id: If0061ddca3bedf0df1ade8cb61ccb710ec1181d4
    Reviewed-on: https://gerrit.openafs.org/12668
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit f7ccf0aa00459cda4579a3838b5bd59ba69c03ea
Author: Marcio Barbosa <mbarbosa@sinenomine.net>
Date:   Mon Jul 31 15:27:10 2017 -0400

    ubik: remove useless signal call
    
    The current version does not have a corresponding LWP_WaitProcess call
    for the beacon_globals.ubik_amSyncSite global. As a result, the
    LWP_NoYieldSignal(&beacon_globals.ubik_amSyncSite) signal call can be
    safely removed.
    
    Change-Id: I72c4ccfe8e68551673dc728dd699ba8c561d76d1
    Reviewed-on: https://gerrit.openafs.org/12673
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit b4c3baa2e24890face6433fcb160e85b7409df4c
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Wed Aug 2 15:25:45 2017 -0400

    doc: add a document to describe rx debug packets
    
    This document gives a basic description of Rx debug packets, the
    protocol to exchange debug packets, and the version history.
    
    Change-Id: Ic040d336c1e463f7da145f1a292c20c5d5f215df
    Reviewed-on: https://gerrit.openafs.org/12677
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit b8e8145fa97e3edb6e4157f0d60d3d5e8db597fe
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Tue Aug 1 20:36:18 2017 -0400

    doc: add kolya's rx-spec to doc/txt
    
    Add rx protocol spec and rx debug spec written by Nickolia Zeldovich.
    
    Rx protocol specification draft (2002)
    Nickolai Zeldovich, kolya@MIT.EDU
    
    Change-Id: I65a9a83a8889503f3a82c8fde7a87f84d2736c8d
    Reviewed-on: https://gerrit.openafs.org/12676
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit c6f5ebc4cf95b0f1d3acc7a0a8678ba0d4378243
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Tue Aug 1 20:10:32 2017 -0400

    doc: relocate notes from arch to txt
    
    The doc/txt directory has become the de facto home for text-based
    technical notes. Relocate the contents of the doc/arch directory to
    doc/txt. Relocate doc/examples to doc/txt/examples.
    
    Update the doc/README file to be more current and remove old work in
    progress comments.
    
    Change-Id: Iaa53e77eb1f7019d22af8380fa147305ac79d055
    Reviewed-on: https://gerrit.openafs.org/12675
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 57d32c29146167ff54d3221ed761a5973776ae93
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Tue Aug 1 20:50:37 2017 -0500

    Add NEWS entry for recent ubik changes
    
    Of the ubik-fix-write-after-recovery topic, this seems like the most
    noteworthy portion, with the other bits wrapped up in the preface.
    
    Change-Id: Icc1afb9f851ef2d7ade49c2382cc023997f1bf26
    Reviewed-on: https://gerrit.openafs.org/12679
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit da704137f4bf766250ca87dbdc5a85c2024cb0a6
Author: Marcio Barbosa <mbarbosa@sinenomine.net>
Date:   Thu Jul 20 23:02:15 2017 -0400

    ubik: update epoch as soon as sync-site is elected
    
    The ubik_epochTime represents the time at which the coordinator first
    received its coordinator mandate. However, this global is currently not
    updated at the moment when a new sync-site is elected. Instead,
    ubik_epochTime is only updated at the very end of the first write
    transaction, when a new database label is written (in udisk_commit).
    This causes at least 2 different issues:
    
    For one, this means that we change ubik_epochTime while a remote
    transaction is in progress. If VOTE_Beacon is called after
    ubik_epochTime is updated, but before the remote transaction ends, the
    remote sites will detect that the transaction id in ubik_currentTrans is
    wrong (via urecovery_CheckTid(), since the epoch doesn't match), and
    they will abort the transaction. This means the transaction will fail,
    and it may cause a loss of quorum until another election is completed.
    
    Another issue is that ubik_epochTime can be 0 at the beginning of a
    write transaction, if this is the first election that this site has won.
    Since ubik_epochTime is used to construct transaction ids, this means
    that we can have different transactions that originate from different
    sites at different times, but they have the same epoch in their tid.
    For example, say a write transaction starts with epoch 0, but the
    originating site is killed/interrupted before finishing. That write
    transaction will linger on remote sites in ubik_currentTrans with an
    epoch of 0 (since the originating site will never call
    DISK_ReleaseLocks, or DISK_Abort, etc). Normally the sync site will kill
    such a lingering transaction via urecovery_CheckTid, but since the epoch
    is 0, and the election winner's epoch is also 0, the transaction looks
    valid and may never be killed. If that transaction is holding a lock on
    the database, this means that the database will forever remain locked,
    effectively preventing any access to the db on that site.
    
    To fix both of these issues, update ubik_epochTime with the current
    time as soon as we win the election. This ensures that the epoch is not
    updated in the middle of a transaction, and it ensures that all
    transactions are created with a unique epoch: the epoch of the election
    that we won.
    
    Note that with this commit, we do not ever set ubik_epochTime to the
    magic value of '2' during database init. The special '2' epoch only
    needs to be set in the database itself, and it is never an actual epoch
    that represents a real quorum that went through the election process.
    The database will be labelled with a 'real' epoch after the first write,
    like normal.
    
    [kaduk@mit.edu: comment the locking strategy in ubeacon_Interact()]
    
    Change-Id: I6cdcf5a73c1ea564622bfc8ab7024d9901af4bc8
    Reviewed-on: https://gerrit.openafs.org/12609
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Marcio Brito Barbosa <mbarbosa@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 32ddf88547f921b33dd93473883928051faab950
Author: Joe Gorse <jhgorse@gmail.com>
Date:   Thu Jul 6 15:47:24 2017 -0400

    LINUX: afs_create infinite fetchStatus loop
    
    For a file in a directory with the CStatd bit cleared, we can get
    an infinite fetchStatus loop.
    
    In afs_create(), afs_getDCache() may return NULL due to an error.
    If unchecked it will loop which may produce multiple fetchStatus()
    calls to the fileserver.
    
    Credit: Yadav Yadavendra for identifying and analysing this issue.
    
    Change-Id: Iecd77d49a5f3e8bb629396c57246736b39aa935f
    Reviewed-on: https://gerrit.openafs.org/12651
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 18fabf9aecf358e0f45e25f6249685f7f2e32485
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Wed Aug 2 19:31:17 2017 -0500

    Update NEWS for volume stats default change
    
    Change-Id: I1a184bf638609866f6f7f1d11c224dfee1113eef
    Reviewed-on: https://gerrit.openafs.org/12678
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 8e1ca72b1cbed930d3661dee5cb742cab52737e9
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Tue Aug 1 17:21:13 2017 -0400

    volser: preserve volume stats by default
    
    Commit dfceff1d3a66e76246537738720f411330808d64 added the
    -preserve-vol-stats flag to the volume server. This enabled a change in
    the volume server to preserve volume usage statistics during reclone and
    restore operations. Otherwise, volume usage counters of read-only
    volumes are cleared when volumes are released, making it difficult to
    track usage with the volume stats.
    
    Make this feature the default behavior of the volume server and provide
    the option -clear-vol-stats to use the old behavior if so desired.  This
    change makes the -preserve-vol-stats the default, and keeps it as a
    hidden flag for sites which may already have that flag set in the
    BosConfig.
    
    Since this changes a default behavior of the volume server, this change
    is only appropriate on a major or minor release boundary, not in the
    middle of a stable series.
    
    Change-Id: I3706ede64b7b18a80b39ebd55f2e1824bb7dbc57
    Reviewed-on: https://gerrit.openafs.org/12674
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 7c7085061580ccce7b2d9c17df5604e5e97fcd81
Author: Marcio Barbosa <mbarbosa@sinenomine.net>
Date:   Mon May 22 12:55:32 2017 -0400

    ubik: avoid early DISK_Begin calls we know will fail
    
    Currently, we can start a write transaction on a site immediately after
    it is elected as the sync site. However, after commit d47beca1,
    SDISK_Begin on remote sites will fail right after an election occurs
    (since lastYesState is not set, and so urecovery_AllBetter will fail).
    And after commit fac0b742, this error is always noticed and propagated
    back to the application.
    
    As a result, when we try to write immediately after a sync site is
    elected, the transaction will fail with UNOQUORUM, the remote sites will
    be marked as down, and we may lose quorum and require another election
    to be performed. This can easily happen repeatedly for a site that
    frequently tries to make changes to a ubik database.
    
    To avoid marking other sites down and going through another election
    process, do not allow write transactions until we know that lastYesState
    is set on the remote sites. We do this by waiting until the next wave of
    beacons are sent, which tell the remote sites that we are the sync site.
    In other words, only allow write transactions after the sync site knows
    that the remote sites also know that the sync site has been elected.
    
    With this commit, a write transaction immediately after an election
    will still fail with UNOQUORUM, but we avoid triggering an error on the
    remote sites, and avoid losing quorum in this situation.
    
    Change-Id: I9e1a76b4022e6d734af1165d94c12e90af04974d
    Reviewed-on: https://gerrit.openafs.org/12592
    Reviewed-by: Andrew Deason <adeason@dson.org>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: Benjamin Kaduk <kaduk@mit.edu>

commit 8f46ca082653116c9c42a69e2535be1bb2f0a2a9
Author: Marcio Barbosa <mbarbosa@sinenomine.net>
Date:   Wed Jun 21 17:42:37 2017 -0300

    ubik: allow remote dbase relabel if up to date
    
    When a site is elected the sync-site, its database is not immediately
    relabeled. The database in question will be relabeled at the end of the
    first write transaction (in udisk_commit). To do so, the dbase->version
    is updated on the sync-site first (1) and then the versions of the
    remote sites are updated through SDISK_SetVersion() (2).
    
    In order to make sure that the remote site holds the same database as
    the sync-site, the SDISK_SetVersion() function checks if the current
    version held by the remote site (ubik_dbVersion) is equal to the
    original version stored by the sync-site (oldversionp). If
    ubik_dbVersion is not equal to oldversionp, SDISK_SetVersion() will
    fail with USYNC.
    
    However, ubik_dbVersion can be updated by the vote thread at any time.
    That is, if the sync site calls VOTE_Beacon() on the remote site between
    events (1) and (2), the remote site will set ubik_dbVersion to the new
    version, while ubik_dbase->version is still set to the old version. As
    a result, ubik_dbVersion will not be equal to oldversionp and
    SDISK_SetVersion() will fail with USYNC. This failure may cause a loss
    of quorum until another election is completed.
    
    To fix this problem, let SDISK_SetVersion() relabel the database when
    ubik_dbase->version is equal to oldversionp. In order to try to only
    affect the scenario described above, also check if ubik_dbVersion is
    equal to newversionp.
    
    Change-Id: I97e6f8cacd1c9bca0b4c72374c058c5fe5b638b3
    Reviewed-on: https://gerrit.openafs.org/12613
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 3c12ff9fbb2724b6e430f3eeeb2c2a1d2ae3f884
Author: Joe Gorse <jhgorse@gmail.com>
Date:   Wed May 10 11:38:25 2017 -0400

    afs: fix repeated BulkStatus calls for directories.
    
    There is a filetype comparison check in afs_DoBulkStat just after
    BulkFetch RPC. This check will fail for directories even though
    bulkStatus was done for directories.
    
    This code is apparently necessary for Darwin, but it causes this problem
    otherwise. Thus it is removed from the rest of the builds using the
    AFS_DARWIN_ENV preprocessor variable.
    
    Credit: Yadav Yadavendra for identifying and analysing this issue.
    
    Change-Id: I9645f0e7a3327cb5f20cdf3ba2bf1cc5b1509bb5
    Reviewed-on: https://gerrit.openafs.org/12610
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit 90acda692a589eb177dc5dee99490947106f8141
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Thu Jul 20 00:12:05 2017 -0400

    relocate old afs docs to doc/txt
    
    Move the afs/DOC files to the top-leve doc/txt directory, since this has
    become the home for developer oriented documentation.
    
    Change-Id: I128d338c69534b4ee6043105a7cfd390b280afe3
    Reviewed-on: https://gerrit.openafs.org/12662
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 5a88209a0ff0cefb7ec1a810e25011ee9795d2fe
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Wed Jul 19 23:48:42 2017 -0400

    Incorporate old release notes into NEWS
    
    Cleanup the doc/txt directory by incorporating the old release
    notes into the NEWS file.
    
    Change-Id: I63911fc5cb0b476e201148c6d3fa3441f4746ab7
    Reviewed-on: https://gerrit.openafs.org/12661
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 3629ae4a682d648d6830bf551ed78faaa4cfc477
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Wed Jul 19 22:39:51 2017 -0400

    Update NEWS for 1.8.0pre2
    
    Change-Id: I5f83e81f25177bde1ea691e756359563e80ee3f2
    Reviewed-on: https://gerrit.openafs.org/12660
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 1d5b255ff68af03da891a0babefdadd85f48def0
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Wed Jul 19 23:09:01 2017 -0400

    Import NEWS from openafs-stable-1_6_x
    
    Import change descriptions for 1.6.20.1, 1.6.20.2, 1.6.21.
    
    Change-Id: Ib4f06c7046eb6e1bb0a1ccfb9f6c45191154fe0e
    Reviewed-on: https://gerrit.openafs.org/12659
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 77c5e4f3fba57c85fd664f64dba2c44a44a4fb5c
Author: Stephan Wiesand <stephan.wiesand@desy.de>
Date:   Wed Jul 26 15:18:08 2017 +0200

    Linux: fix whitespace in osi_sysctl.c
    
    Remove dozens of trailing spaces and make consistent use of tabs
    for indentation throughout the file.
    
    Change-Id: Ibbd17d2b9828590ffd84b76aac70646e9fe9cb2c
    Reviewed-on: https://gerrit.openafs.org/12665
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit b0461f2def17fe3d3f49e51e3c4a1df81a921eee
Author: Andrew Deason <adeason@sinenomine.net>
Date:   Thu Jun 15 15:32:41 2017 -0500

    LINUX: Workaround d_splice_alias/d_lookup race
    
    Before Linux kernel commit 4919c5e45a91b5db5a41695fe0357fbdff0d5767,
    d_splice_alias in some cases can d_rehash the given dentry without
    attaching it to the given inode, right before the dentry is unhashed
    again. This means that for a few moments, that negative dentry is
    visible to __d_lookup, and thus is visible to path lookup and can be
    given to afs_linux_dentry_revalidate.
    
    Currently, afs_linux_dentry_revalidate will say that the dentry is
    valid, because d_time and other fields are set; it's just not attached
    to an inode. This causes an ENOENT error on lookup, even though the
    file is there (and no OpenAFS code said otherwise).
    
    Normally this race is rare, but it can be frequently exercised if
    we access the same directory via different names at the same time.
    This can happen with multiple mountpoints to the same volume, or by
    accessing an @sys directory via its abbreviated and expanded forms.
    
    To get around this, make afs_linux_dentry_revalidate check negative
    'dentry's to see if they are unhashed. We also lock the parent inode,
    in order to guarantee that a problematic d_splice_alias call isn't
    running at the same time (and thus, we know the dentry will not be
    unhashed immediately afterwards). This slows down
    afs_linux_dentry_revalidate for valid negative 'dentry's a little, but
    it allows us to use negative dentry's at all.
    
    Linux kernel commit 4919c5e45a91b5db5a41695fe0357fbdff0d5767 fixes
    this issue, which was included in 2.6.34, so don't do this workaround
    for 2.6.34 and on.
    
    Change-Id: I8e58ebed4441151832054b1ef3f1aa5af1c4a9b5
    Reviewed-on: https://gerrit.openafs.org/12638
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit d55b41072ce873210481baa4cae5c7143011869b
Author: Stephan Wiesand <stephan.wiesand@desy.de>
Date:   Mon Jul 24 11:37:54 2017 +0200

    Linux 4.13: use designated initializers where required
    
    struct path is declared with the "designated_init" attribute,
    and module builds now use -Werror=designated-init. Cope.
    
    And as pointed out by Michael Meffie, struct ctl_table has
    the same requirement now, so use a designated initializer
    for the final element of the sysctl table too.
    
    Change-Id: I0ec45aac961dcefa0856a15ee218085626a357c7
    Reviewed-on: https://gerrit.openafs.org/12663
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: Benjamin Kaduk <kaduk@mit.edu>

commit 030a9849e22f443492342794f436e2c86c98a903
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Fri Jul 7 11:11:12 2017 -0400

    afs: fix afs_xserver deadlock in afsdb refresh
    
    When setting up a new volume, the cache manager calls afs_GetServer() to
    setup the server object for each fileserver associated with the volume.
    The afs_GetServer() function locks afs_xserver and then, among other
    things, calls afs_GetCell() to lookup the cell info by cell number.
    
    When the cache manager is running in afsdb mode, afs_GetCell() will
    attempt to refresh the cell info if the time-to-live has been exceeded
    since the last call to afs_GetCell(). During this refresh the AFSDB
    calls afs_GetServer() to update the vlserver information. The afsdb
    handler thread and the thread processing the volume setup become
    deadlocked since the afs_xserver lock is already held at this point.
    
    This bug will manifest when the DNS SRV record TTL is smaller than the
    time the fileservers respond to the GetCapabilities RPC within
    afs_GetServer() and there are multiple read-only servers for a volume.
    
    Avoid the deadlock by using the afs_GetCellStale() variant within
    afs_GetServer(). This variant returns the memory resident cell info
    without the afsdb upcall and the subsequent afs_GetServer() call.
    
    Change-Id: Iad57870f84c5e542a5ee20f00ea03b3fc87683a1
    Reviewed-on: https://gerrit.openafs.org/12652
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit a6ad67485bf23084c06e1de1a424b2e375ee70f3
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Tue Jul 11 08:51:08 2017 -0400

    afs: restore force_if_down check when getting connections
    
    Commit cb9e029255420608308127b0609179a46d9983ad removed the
    force_if_down check in afs_ConnBySA, which effictively turned on
    force_if_down flag for every call to afs_ConnBySA. This caused
    afs_ConnBySA to always return connections, even for server addresses
    marked down and force_if_down set to 0.
    
    One serious consequence of this bug is the cache manager will retry the
    preferred vlserver indefinitely when it is unreachable. This is because
    the loop in afs_ConnMHosts always tries hosts in preferred order and
    expects afs_ConnBySA to return a NULL if the server address has no
    connections because it is marked down.
    
    Restore the check for server addresses marked down to honor the
    force_if_down flag again so we do not get connections for down servers
    unless requested.
    
    Change-Id: Ia117354929a62b0cedc218040649e9e0b8d8ed23
    Reviewed-on: https://gerrit.openafs.org/12653
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit a1c072ac562ccf74e5afb8449db1bcef86aef362
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Mon Apr 10 14:23:12 2017 -0400

    redhat: fix rpmbuild command line option defaults
    
    Fix the handling of default values for the various rpmbuild options
    which can be given. These have been broken as code was shuffled around
    over the years.
    
    Remove obsolete comments about detecting what to build based on the
    architecture.
    
    Provide the '--without authlibs' option to disable the openafs-authlibs
    package.
    
    Change-Id: I6c8db1f3163ee241f9a4d1282345a0ddeabd284c
    Reviewed-on: https://gerrit.openafs.org/12596
    Reviewed-by: Stephan Wiesand <stephan.wiesand@desy.de>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: Benjamin Kaduk <kaduk@mit.edu>

commit a5bedda935c8147517bcbb56858dd88288fdf9da
Author: Christof Hanke <christof.hanke@rzg.mpg.de>
Date:   Tue Jul 18 12:04:11 2017 +0200

    mkvers: fix potential buffer overflow
    
    The space allocated for outputFileBuf is only 2 bytes larger than
    sizeof(VERS_FILE). But we add potentially 4 extra bytes like
    ".txt" or ".xml". Just allocate enough space for all file suffices.
    
    Change-Id: Ic0f97590be208deaf9c4a5c25e21056ea9d2cd6f
    Reviewed-on: https://gerrit.openafs.org/12657
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit d7211350eec18b30e9ccf30f5e95fb58162c637d
Author: Andrew Deason <adeason@sinenomine.net>
Date:   Thu Jun 15 15:29:17 2017 -0500

    afs_linux_lookup: Avoid d_add on afs_lookup error
    
    Currently, afs_linux_lookup looks roughly like this pseudocode:
    
    {
        code = afs_lookup(&vcp);
        if (!code) {
            ip = AFSTOV(vcp);
            error = process_ip(ip);
            if (error) {
                goto done;
            }
        }
        process_dp(dp);
        newdp = d_splice_alias(ip, dp);
     done:
        cleanup();
    }
    
    Note that if there is an error while processing the looked-up inode
    (ip), we jump over d_splice_alias. But if we encounter an error from
    afs_lookup itself, we do not jump over d_splice_alias. This means that
    if afs_lookup encounters any error, we initialize the given dentry
    (dp) as a negative entry, effectively telling the Linux kernel that
    the requested name does not exist.
    
    This is correct for ENOENT errors, of course, but is incorrect for any
    other error. For non-ENOENT errors we later return an error from the
    function, but this does not invalidate the generated dentry. The
    result is that when afs_lookup encounters an error, that error will be
    propagated to userspace, but subsequent lookups for the same name will
    yield an ENOENT error (until the dentry is invalidated). This can
    easily cause a file to seem to mysteriously disappear, if a transient
    error like network problems caused the afs_lookup call to fail.
    
    To fix this, treat ENOENT as a non-error, like the comments already
    suggest. In our case, ENOENT is not really an error; it just means we
    populate the given dentry differently. So if we get ENOENT from
    afs_lookup, set our vcache to NULL and clear the error, and continue.
    
    This also has the side effect of not treating ENOENT errors from
    afs_CreateAttr identically to ENOENT errors from afs_lookup. That
    shouldn't happen, but there have been abuses of the ENOENT error code
    in the past, so it is probably better to be cautious.
    
    Many thanks to Gaja Sophie Peters for assistance in tracking down and
    testing fixes for this issue, including providing access to test systems
    experiencing the buggy behavior.
    
    FIXES 133654
    
    Change-Id: Ia9aab289d5c041557ab6b00f1d41de2edfc97a89
    Reviewed-on: https://gerrit.openafs.org/12637
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Joe Gorse <jhgorse@gmail.com>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Tested-by: Michael Meffie <mmeffie@sinenomine.net>

commit 5dd2ce2043f53e80e1ded25abcfd565b4071a3ad
Author: Andrew Deason <adeason@sinenomine.net>
Date:   Thu Jun 15 15:29:48 2017 -0500

    LINUX: Rearrange afs_linux_lookup cleanup
    
    Currently, the cleanup and error handling in afs_linux_lookup is
    structured similar to this pseudocode:
    
        if (!code) {
            if (!IS_ERR(newdp)) {
                return no_error;
            } else {
                return newdp_error;
            }
        } else {
            return code_error;
        }
    
    The multiple different nested error cases make this a little complex.
    To make this easier to follow for subsequent changes, alter this
    structure to be more like this:
    
        if (IS_ERR(newdp)) {
            return newdp_error;
        }
    
        if (code) {
            return code_error;
        }
    
        return no_error;
    
    There should be no functional change in this commit; it is just code
    reorganization.
    
    Technically the ordering of these checks is changed, but there is no
    combination of conditions that actually results in different code
    being hit. That is, if 'code' is nonzero and IS_ERR(newdp) is true,
    then we would go through a different path. But that cannot happen,
    since if 'code' is nonzero, we have no inode and so IS_ERR(newdp)
    cannot be true (d_splice_alias cannot return an error for a NULL
    inode). So there is no functional change.
    
    Change-Id: I94a3aef5239358c3d13fe5314044dcc85914d0a4
    Reviewed-on: https://gerrit.openafs.org/12636
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Joe Gorse <jhgorse@gmail.com>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Tested-by: Michael Meffie <mmeffie@sinenomine.net>

commit d0b64a4a1b61b5e22f0e3fe509f8facd30bc2b74
Author: Stephan Wiesand <stephan.wiesand@desy.de>
Date:   Thu Jun 29 16:57:42 2017 +0200

    doc: Add introduction and credits to ubik.txt
    
    Credit where it's due. And the remainder of the introduction may
    provide some useful context too.
    
    Change-Id: I99c7e599363126c581ae1ac00da67c33acc3687f
    Reviewed-on: https://gerrit.openafs.org/12644
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit d1c4dbf28ae28bbfac3d8bc96d0fa5ae3d422bfd
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Sun Jun 25 13:56:04 2017 -0500

    Put jhutz's ubik analysis in doc/txt
    
    A file in the source tree is much easier to locate than an old
    mailing list post; it's quite handy to have this at hand as a
    reference.
    
    Change-Id: I5267a2f86b36e92b05249364085bdd33aeb28d1b
    Reviewed-on: https://gerrit.openafs.org/12642
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Stephan Wiesand <stephan.wiesand@desy.de>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 0327ead297e3cf395cced1e6690b901e445f074c
Author: Andrew Deason <adeason@sinenomine.net>
Date:   Fri Jun 23 17:20:11 2017 -0500

    afs: Improve "Corrupt directory" warning
    
    This warning is a bit confusing to see, since it doesn't say anything
    about AFS (making it unclear where it's coming from), and it lacks a
    trailing newline (making it ugly). Fix both of these.
    
    Change-Id: I92a3d07fd193bf99b545aef9b21f52d23c356a2d
    Reviewed-on: https://gerrit.openafs.org/12641
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit cdb92f94598e5b25fbcdfc6fb1650218ec05d63f
Author: Jeffrey Altman <jaltman@auristor.com>
Date:   Thu Jun 1 22:25:49 2017 -0400

    vol: modify volume updateDate upon salvage change
    
    If the salvager changed the volume, set the VolumeDiskData.updateDate
    field so that
    
      1. the change is visible via "vos examine"
    
      2. backup services will backup the corrected volume
    
    Teradactyl pointed out the problem which forces cell administrators
    to manually trigger a backup for each volume that has been salvaged.
    
    Change-Id: I9a35b92e8abbe3b54b08e64ac13de44442736c72
    Reviewed-on: https://gerrit.openafs.org/12629
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Stephan Wiesand <stephan.wiesand@desy.de>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit f5491119ff7d422b1c0c311a50e30bec1c15296c
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Fri Jun 2 15:19:26 2017 -0400

    bozo: do not fail silently on unknown bosserver options
    
    Instead of failing silently when the bosserver is started with an
    unknown option, print an error message and exit with a non-zero value.
    Continue to exit with 0 when the -help option is given to request the
    usage message.
    
    This change should help make bosserver startup failures more obvious
    when an unsupported option is specified. Example systemd status message:
    
       systemd[1]: Starting OpenAFS Server Service...
       bosserver[32308]: Unrecognized option: -bogus
       bosserver[32308]: Usage: bosserver [-noauth] ....
       systemd[1]: openafs-server.service: main process exited,
                   code=exited, status=1/FAILURE
    
    Change-Id: I8717fb4a788fbcc3d1e2d271dd03511c5b504f10
    Reviewed-on: https://gerrit.openafs.org/12630
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit aaa47dc1077f0dd5b0040006c831f64cc8a303b5
Author: Jeffrey Altman <jaltman@auristor.com>
Date:   Sat May 27 14:59:04 2017 -0400

    rx: wake up send after 'twind' has been updated
    
    Beginning in AFS 3.4 and 3.5 the ack trailer includes the size of the
    peer's receive window.  This value is used to update the sender's
    transmit window (twind).  When the twind is increased the application
    thread is signaled to indicate that more packets can be sent.
    
    This change wakes the application thread after twind is updated by
    the peer's receive window instead of beforehand.  Failure to do so
    can result in 100ms transmit delays when the receive window transitions
    from closed to open.
    
    Change-Id: Id129ea93e94612a4b8cce9f8cbddde9c779ff26b
    Reviewed-on: https://gerrit.openafs.org/12625
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit 63e530e7df0b8013bcc4421b0bba558d4f1d2d57
Author: Joe Gorse <jhgorse@gmail.com>
Date:   Tue May 16 07:29:30 2017 +0000

    LINUX: Switch to new bdi api for 4.12.
    
    super_setup_bdi() dynamically allocates backing_dev_info structures
    for filesystems and cleans them up on superblock destruction.
    
    Appears with Linux commit fca39346a55bb7196888ffc77d9e3557340d1d0b
    Author: Jan Kara <jack@suse.cz>
    Date:   Wed Apr 12 12:24:28 2017 +0200
    
    Change-Id: I67eed0fcb8c96733390579847db57fb8a4f0df3e
    Reviewed-on: https://gerrit.openafs.org/12614
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit b47dc5482da614742b01dcc62d5e11d766a9432f
Author: Joe Gorse <jhgorse@gmail.com>
Date:   Wed May 10 19:46:38 2017 +0000

    LINUX: CURRENT_TIME macro goes away.
    
    Check if the macro exists, define it if it does not.
    
    Change-Id: I9990579f94bfba0804e60fa6ddcc077984cc46c3
    Reviewed-on: https://gerrit.openafs.org/12611
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit 7af9554bed2d906615e0f5a94537d3d553ca2d1e
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Thu Apr 6 22:50:41 2017 -0400

    redhat: update rpm spec file
    
    Update the spec file to keep up with accumulated changes.
    
    * Correct installation location of db check programs.
    * Install afsd to the legacy location to avoid breaking
      init scrips and systemd configs.
    * Exclude yet another duplicated copy of kpwvalid.
    * libubik_pthread.a is gone.
    * Install the kpwvalid man page.
    * Continue to remove the obsolete kdb program.
    * Update the names of the pam_afs symlinks.
    * Add libkopenafs to authlibs.
    * Package dafssync-debug man pages.
    * Package opr/queue.h in devel.
    * Package akeyconvert and man page.
    * Do not package fuse version of afsd. A separate sub-package
      for afsd.fuse is warrented, since it adds new libfuse
      dependencies.
    * Package new server man pages, including dafsssync-* pages.
    * Package libafsrfc3961.a as a devel lib.
    * Continue to package kauth programs.
    
    Change-Id: I875c3b8dee53abbc67b0f05f8b291bb58abf41a5
    Reviewed-on: https://gerrit.openafs.org/12595
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Stephan Wiesand <stephan.wiesand@desy.de>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: Benjamin Kaduk <kaduk@mit.edu>

commit dd80f081663c50f93618da7a309b390f2fbdbc59
Author: Tim Creech <tcreech@tcreech.com>
Date:   Sun Mar 5 18:13:45 2017 -0500

    FBSD: build fix for FreeBSD 11
    
    r285819 eliminated b_saveaddr from struct buf, while r292373 changed the
    arguments to VOP_GETPAGES. The approach used by this patch to address
    these changes was inspired by FreeBSD's nfs and samba clients.
    
    Change-Id: Ibcf6b6fde6c86f96aa814af2bca08f1a8b286740
    Reviewed-on: https://gerrit.openafs.org/12575
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit dcfebc7ca2923c1f93df9105e493bd4228ea8a0e
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Wed Apr 5 16:48:36 2017 -0400

    redhat: convert rpm spec file to make install
    
    Convert the build and install from the deprecated 'make dest' to the
    modern 'make install' method.
    
    * Clarify the install section by unrolling the shell scripts,
      reorganizing, and improving the comments.
    * Remove the gzip glob of the man pages; rpmbuild automatically
      compresses the man pages and will handle symlinks correctly.
    * Remove the generated temporary list file and specify files directly.
    * Remove the extra tar commands to install the man pages out of the doc
      directory; 'make install..' installs the man pagess.
    * Remove code in the install section which determines the sysname. This is
      no longer needed during the install.
    * Update the kernel module install commands to accommodate the
      conversion from 'make dest'.
    
    Change-Id: I97ec80185a2b11704b27ea74941b50ff4a5aca8c
    Reviewed-on: https://gerrit.openafs.org/12594
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: Benjamin Kaduk <kaduk@mit.edu>

commit bd8bec5b474315cd28df5a4741c1e07d48c7250a
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Tue Apr 25 18:34:47 2017 -0400

    redhat: fix whitespace errors in the rpm spec file
    
    Remove trailing whitespace characters that have crept into
    the rpm spec file over the years.
    
    Change-Id: I08c7ad926ddb524d6938b26513963c28c70b4195
    Reviewed-on: https://gerrit.openafs.org/12606
    Reviewed-by: Stephan Wiesand <stephan.wiesand@desy.de>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: Benjamin Kaduk <kaduk@mit.edu>

commit 6b7b4239ab22fbb301e3b50e2ca4072445ba4e9e
Author: Stephan Wiesand <stephan.wiesand@desy.de>
Date:   Tue Apr 11 11:58:55 2017 +0200

    Linux: only include cred.h if it exists
    
    Commit c89fd17df1032ec2eacc0d0c9b73e19c5e8db7d2 introduced an explicit
    include of linux/cred.h since the latest kernel no longer includes it
    implicitly in sched.h. Alas, older kernels (like 2.6.18) don't have this
    file. Add a configure test for the existence of cred.h and only include
    it if actually present.
    
    Change-Id: Ia7e38160492b1e03cdb257e4b2bef4d18c4a28fb
    Reviewed-on: https://gerrit.openafs.org/12593
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit c89fd17df1032ec2eacc0d0c9b73e19c5e8db7d2
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Thu Mar 23 18:36:44 2017 -0700

    Linux v4.11: cred.h is no longer included in sched.h
    
    With Linux commit e26512fea5bcd6602dbf02a551ed073cd4529449, cred.h is no
    longer included in sched.h.
    
    Several components of libafs which require cred.h were picking it by
    including sched.h.
    
    Instead, explicitly add an include for cred.h. cred.h begins with a
    customary one-shot to prevent multiple loads:
    
     #ifndef _LINUX_CRED_H
     #define _LINUX_CRED_H
    
    Therefore we don't need a new autoconf test or preprocessor conditional
    to prevent redundant includes on older Linux releases.
    
    Change-Id: Ifc496c83141d2cfbd417133feb6d87c1146e5014
    Reviewed-on: https://gerrit.openafs.org/12574
    Tested-by: Mark Vitale <mvitale@sinenomine.net>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Joe Gorse <jhgorse@gmail.com>
    Tested-by: Joe Gorse <jhgorse@gmail.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>

commit ad001550949b612ff6b4899fa8da50ee58f87533
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Thu Mar 23 15:10:03 2017 -0700

    Linux v4.11: signal stuff moved to sched/signal.h
    
    In Linux commit c3edc4010e9d102eb7b8f17d15c2ebc425fed63c, signal_struct
    and other signal handling declarations were moved from sched.h to
    sched/signal.h.
    
    This breaks existing OpenAFS autoconf tests for recalc_sigpending() and
    task_struct.signal->rlim, so that the OpenAFS kernel module can no
    longer build.
    
    Modify OpenAFS autoconfig tests to cope.
    
    Change-Id: Ic9f174b92704eabcbd374feffe5fbeb92c8987ce
    Reviewed-on: https://gerrit.openafs.org/12573
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Joe Gorse <jhgorse@gmail.com>
    Tested-by: Joe Gorse <jhgorse@gmail.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>

commit de5ee1a67d1c3284d65dc69bbbf89664af70b357
Author: Joe Gorse <jhgorse@gmail.com>
Date:   Mon Mar 20 14:30:46 2017 +0000

    Linux v4.11: getattr takes struct path
    
    With Linux commit a528d35e8bfcc521d7cb70aaf03e1bd296c8493f
    
        statx: Add a system call to make enhanced file info available
    
    The Linux getattr inode operation is altered to take two additional
    arguments: a u32 request_mask and an unsigned int flags that indicate
    the synchronisation mode.  This change is propagated to the
    vfs_getattr*() function.
    
    -   int (*getattr) (struct vfsmount *, struct dentry *, struct kstat *);
    +   int (*getattr) (const struct path *, struct kstat *,
    +                     u32 request_mask, unsigned int sync_mode);
    
    The first argument, request_mask, indicates which fields of the statx
    structure are of interest to the userland call. The second argument,
    flags, currently may take the values defined in
    include/uapi/linux/fcntl.h and are optionally used for cache coherence:
    
     (1) AT_STATX_SYNC_AS_STAT tells statx() to behave as stat() does.
    
     (2) AT_STATX_FORCE_SYNC will require a network filesystem to
         synchronise its attributes with the server - which might require
         data writeback to occur to get the timestamps correct.
    
     (3) AT_STATX_DONT_SYNC will suppress synchronisation with the server in
         a network filesystem.  The resulting values should be considered
         approximate.
    
    This patch provides a new autoconf test and conditional compilation to
    cope with the changes in our getattr implementation.
    
    Change-Id: Ie4206140ae249c00a8906331c57da359c4a372c4
    Reviewed-on: https://gerrit.openafs.org/12572
    Reviewed-by: Joe Gorse <jhgorse@gmail.com>
    Tested-by: Joe Gorse <jhgorse@gmail.com>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit c666bfee8848183ccbc566c9e0fa019088e56505
Author: Jonathon Weiss <jweiss@mit.edu>
Date:   Thu Nov 10 17:06:18 2016 -0500

    Prevent double-starting client on RHEL7
    
    On RHEL7 if the AFS client is stopped with 'service openafs-client
    stop', but that fails for some reason (most commonly because some
    process has a file or directory in AFS open) systemd will decide that
    the openafs-client is in a failed state when it is actually running.
    If one then runs 'service openafs-client start' systemd will start a
    new AFS client.  At this point AFS access will continue to work until
    the functional AFS client is (successfully) stopped, at which point a
    reboot is required to recover.
    
    Have systemd check the status of 'fs sysname' before starting the
    AFS client, so we avoid getting into a state that requires a reboot.
    
    Change-Id: I28a5cca746823d69183ea5ce65c10e1725009c5c
    Reviewed-on: https://gerrit.openafs.org/12443
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit d2721be299c124d76b611ab2980c51be148fa1a7
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Mon Feb 20 22:18:09 2017 -0600

    XBSD: do not claim AFS_VM_RDWR_ENV
    
    The AFS_VM_RDWR_ENV configuration parameter (defined or not defined
    in each platform's param.h) is undocumented, but appears to be an
    indication of a property of the platform OS's VFS layer, or perhaps just
    of the complexity of the read/write vnops that we implement for it.
    That is, AFS_VM_RDWR_ENV is defined when the read/write vnops implement
    partial write logic (and presumably when they interact with the OS VM
    layer in ways not expressed by the afs_write() abstraction); systems
    that do not define AFS_VM_RDWR_ENV can use the afs_write() function
    fairly directly as the vnode operation.  Use of AFS_VM_RDWR_ENV
    evolved over time, with the original (AFS 3.2/3.3-era) code using a
    simple scheme that handled partial writes directly in afs_write()
    and avoided complexity in callers. In AFS 3.4, sunos and solaris
    gained a more complicated read/write vnop that incorporated the
    afs_DoPartialWrite() call itself, and eventually in 3.6 we see the
    behavior established at the original IBM import, with all the (Unix)
    OSes supported at that time defining AFS_VM_RDWR_ENV.
    
    When DARWIN support was brought in in commit
    a41175cfbbf4d06ccfe14ae54bef8b7464ecd80b, its param.h properly did
    not define AFS_VM_RDWR_ENV, as OS X uses a VFS interface that shares
    some level of abstraction with the traditional BSD VFS and its
    read/write/getpages/putpages operations, so the afs_write() behavior
    was natural and no extra complications needed for integration with the
    VM layer or other optimizations.
    
    However, when the initial FreeBSD support came in a few months later,
    it seems to have taken inspiration from the OSes that were supported
    in the initial IBM import, and kept the AFS_VM_RDWR_ENV definition.
    This was then propagated to all the later BSDs as they were added.
    
    Perhaps the most noticeable consequence of this definition is that
    the calls to afs_DoPartialWrite() from afs_write() are bypassed, with
    a comment that "[i]f write is implemented via VM, afs_DoPartialWrite()
    is called from the high-level write op" (and calls to afs_FakeOpen()
    and afs_FakeClose() are similarly skipped).  This means that attempting
    to write a file larger than the local cache will hang waiting for
    more space to be freed, which will never happen as the vcache remains
    locked and will not be written out in the background.
    
    In the absence of a documented meaning for AFS_VM_RDWR_ENV, this
    also gives us a proxy that can be used to indicate whether a given
    OS's support intended to claim the AFS_VM_RDWR_ENV -- such platforms
    will actually contain the call to afs_DoPartialWrite() in the
    appropriate vnode operation.  This can be used to sanity-check the
    places where AFS_VM_RDWR_ENV is removed by this commit.  Interestingly,
    HP-UX does not call afs_DoPartialWrite() but also is clearly in a VFS
    that uses a rdwr()-based approach, as the corresponding vnode operation
    is implemented by mp_afs_rdwr(), so leave it unchanged for now.
    
    Tim Creech is responsible for noting the lack of calls to
    afs_DoPartialWrite() on FreeBSD, and Chaskiel Grundman for the
    historical research into pre-OpenAFS AFS behavior.
    
    Designing and implementing more complicated BSD read/write vnops that
    incorporate afs_DoPartialWrite() and other improvements is left for
    future work.
    
    
    Change-Id: I8e89855ac31303934f97d0753b64899fb7e3867c
    Reviewed-on: https://gerrit.openafs.org/12520
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Antoine Verheijen <apv@ualberta.ca>
    Reviewed-by: Tim Creech <tcreech@tcreech.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 2421da2bf327525216ec7e79b9aa81fa2c4f77d5
Author: Marcio Barbosa <mbarbosa@sinenomine.net>
Date:   Tue Jan 31 11:43:18 2017 -0300

    vol: detach offline volumes on dafs
    
    Taking a volume offline always clears the inService bit. Taking a
    volume out of service also takes it offline. Therefore, if the
    inService flag is false, the volume in question should be offline.
    On dafs, an offline volume should be unattached.
    
    The attach2() function does not change the state of the volume received
    as an argument to unattached when the inService flag is false. Instead,
    this function changes the state of the volume in question to
    pre-attached and returns VNOVOL to the client. As result, subsequent
    accesses to this volume will make the server try and fail to attach
    this offline volume over and over again, writing to the FileLog each
    time.
    
    To fix this problem, detach the volume received as an argument if the
    inService flag is false. Since the new state of this volume will be
    unattached, subsequent accesses will not hit attach2().
    
    This situation where a volume is not offline but is also not in service
    can occur if a volume is taken offline with vos offline and some time
    later the DAFS fileserver is shutdown and restarted; the volume is
    placed into the preattach state by default when the server restarts.
    Each access to the volume by clients then causes the fileserver to
    attempt to attach the volume, which fails, since the in-service flag in
    the volume header is false from the previous vos offline.  The
    fileserver will log a warning to the FileLog on each attempt to attach
    the volume, and this will fill the FileLog with duplicate messages
    corresponding to the number of attempted accesses.
    
    Change-Id: Ifce07c83c1e8dbf250b88b847d331234bdaa9df5
    Reviewed-on: https://gerrit.openafs.org/12515
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 22d841a45fff7026318b529a41dd957ce8bb0ddf
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Tue Feb 28 18:02:39 2017 -0500

    SOLARIS: prevent BAD TRAP panic with Studio 12.5
    
    Starting with Solaris Studio 12.3, it is documented that Solaris kernel
    modules (such as libafs) must not use any floating point, vector, or
    SIMD/SSE instructions on x86 hardware.  However, each new Studio
    compiler release (12.4 and especially 12.5) is more likely to use these
    types of instructions by default.
    
    If the libafs kernel module includes any forbidden kernel instructions,
    Solaris will panic the system with:
      BAD TRAP:  type=7 (#nm Device not available)
    
    Provide a new autoconfig test to specify the required compiler options
    (-xvector=%none -xregs=no%float) when building the OpenAFS kernel module
    for Solaris, so that no invalid x86 instructions are used.
    
    In addition, reinstate default kernel module optimization for Solaris.
    It had been disabled in commit 80592c53cbb0bce782eb39a5e64860786654be9f
    to address this same issue in Studio 12.3 and 12.4.  However, Studio
    12.5 started using some SSE instructions even with no optimization.
    
    This commit has been tested with OpenAFS master and Studio 12.5 at all
    optimization levels (none, -xO1 through -xO5) and verified to contain no
    XMM register instructions via the following command:
      $ gobjdump -dlr libafs64.o | grep xmm | wc -l
    
    Change-Id: Ic3c7860f7d524162fd9178a1dab5dd223722ee43
    Reviewed-on: https://gerrit.openafs.org/12558
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 38a3f51fb8b3910ecdd7cacb06f35ec681990aea
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Mon Feb 20 20:16:47 2017 -0500

    DAFS: do not save or restore host state if CPS in progress
    
    If a fileserver is shutdown while one or more PR_GetHostCPS calls
    are in progress, this state is saved in the fsstate.dat file as
    hostFlags HCPS_WAITING, HCPS_INPROGRESS.  Other hosts that are
    merely waiting will have HCPS_WAITING recorded.
    
    However, it makes no sense to restore host structs in this state,
    because the GetCPS calls will no longer be in progress.  Once these
    hosts become active, they will block server threads and quickly cause
    all server threads to be exhausted as other CPS requests are blocked
    behind them.
    
    Instead, exclude these states from both save and restore.
    
    Change-Id: I3fad67b70c96dc967d6f8e3a7b393cfda076c91d
    Reviewed-on: https://gerrit.openafs.org/12561
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit bd15a5f56fde98983464acf5fd4cdd731d206d9f
Author: Stephan Wiesand <stephan.wiesand@desy.de>
Date:   Thu Mar 2 12:52:10 2017 +0100

    doc: clarify the fs wscell manpage
    
    What's displayed by fs wscell is not necessarily the current content
    of ThisCell, but that at the time of starting the client. Say so.
    
    FIXES 133339
    
    Change-Id: Id3351f1236e5061340eb07041d4ce3e4de69a1a1
    Reviewed-on: https://gerrit.openafs.org/12537
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit d39e7c7af77b4e1b043611e1a6e78267f5f956ef
Author: Marcio Barbosa <mbarbosa@sinenomine.net>
Date:   Thu Mar 2 18:01:48 2017 -0300

    osx: build afscell only for active architecture
    
    The InstallerPlugins framework provided by the MacOSX10.12.sdk does not
    define symbols for architecture i386. As a result, the OpenAFS code
    cannot be built on OS X 10.12.
    
    To fix this problem, build the afscell xcode project only for active
    architecture.
    
    Change-Id: I2a2bd5694826b668fceb7402567fba1d0f128479
    Reviewed-on: https://gerrit.openafs.org/12531
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit 2a13973985bc7e190364d208c590ec42dbccf81b
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Thu Jun 11 13:14:27 2015 -0400

    libafs: vldb cache timeout option (-volume-ttl)
    
    The unix cache manager caches VLDB information for read-only volumes as
    long as a volume callback is held for a read-only volume.  The volume
    callback may be held as long as files in the read-only volume are being
    accessed.  The cache manager caches VLDB information for read/write
    volumes as long as volume level errors (such as VMOVED) are not returned
    by a fileserver while accessing files within the volume.
    
    Add a new option to set the maximum amount of time VLDB information will
    be cached, even if a callback is still held for a read-only volume, or
    no volume errors have been encounted while accessing files in read/write
    volumes.
    
    This avoids situations where the vldb information is cached indefinitely
    for read-only and read/write volumes.  Instead, the VL servers will be
    periodically probed for volume information.
    
    Change-Id: I5f2a57cdaf5cbe7b1bc0440ed6408226cc988fed
    Reviewed-on: https://gerrit.openafs.org/11898
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 3893ed397283b0c3605def102004a645a325d476
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Mon Feb 27 01:40:51 2017 -0500

    SOLARIS: update convert from ancient _depends_on
    
    Commit 37db7985fde9e6a5e71ae628d0b7124a27bf31c3 modernized how we
    declare module dependencies on Solaris 10 and newer.
    
    Instead of explicitly specifying recent Solaris version numbers, specify
    old versions for the old method.  This should be more future proof.
    
    Thanks to Ben Kaduk for the suggestion.
    
    Change-Id: I7b3c90803825e2c0736548b56deb354183e81b15
    Reviewed-on: https://gerrit.openafs.org/12529
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 69aadea298825f1f224406064b83d1a947abf96b
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Sat Feb 25 20:33:00 2017 -0500

    build: update search paths for solaris cc
    
    Move the macros to search for the solaris cc to a separate macro and
    update the search paths to keep up with released versions.
    
    Change-Id: Iaba816f1acf5f45d4e147ae517e73949eb8fe949
    Reviewed-on: https://gerrit.openafs.org/12528
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit 6ea6c182c7fb6c22dafbbf203abcc23726e06cba
Author: Sergio Gelato <Sergio.Gelato@astro.su.se>
Date:   Wed Feb 22 13:55:33 2017 -0800

    LINUX: Debian/Ubuntu build regression on kernel 3.16.39
    
    Now that kernel 4.9 has hit jessie-backports, it becomes desirable to
    also backport the associated openafs patches.
    
    Unfortunately, Linux-4.9-inode_change_ok-becomes-setattr_prepare.patch
    causes a build failure against jessie's current default kernel,
    3.16.39-1, due to the fact that setattr_prepare() is available (it was
    cherrypicked to address CVE-2015-1350) but file_dentry() is not (it was
    introduced in kernel 4.6).
    
    This makes it difficult to have a version of openafs for jessie that
    supports both kernels.
    
    To deal with this, follow the implementation of file_dentry() in 4.6,
    and simplify it to account for the lack of d_real() support in older
    kernels.
    
    Note that inode_change_ok() has been added back to 3.16.39-1 to avoid
    ABI changes. That means the current openafs packages in jessie continue
    to work with kernel 3.16.39-1 since they do not include
    Linux-4.9-inode_change_ok-becomes-setattr_prepare.patch.
    
    Originally reported at
    https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=855366
    
    FIXES RT134158
    
    Change-Id: I157aa2ff25945c1c6e3b8e4a600557125711a681
    Reviewed-on: https://gerrit.openafs.org/12523
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 789319bf0f2b26ad67995f8cbe88cee87a1bbdc0
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Wed Dec 7 11:11:45 2016 -0500

    Linux 4.10: have_submounts is gone
    
    Linux commit f74e7b33c37e vfs: remove unused have_submounts() function
    (v4.10-rc2) removes have_submounts from the tree after providing a
    replacement (path_has_submounts) for its last in-tree caller, autofs.
    
    However, it turns out that OpenAFS is better off not using the new
    path_has_submounts.  Instead, OpenAFS could/should have stopped using
    have_submounts() much earlier, back in Linux v3.18 when d_invalidate
    became void.  At that time, most in-tree callers of have_submounts had
    already been converted to use check_submounts_and_drop back in v3.12.
    At v3.18, a series of commits modified check_submounts_and_drop to
    automatically remove child submounts (instead of returning -EBUSY if a
    submount was detected), then subsumed it into d_invalidate.  The end
    result was that VFS now implicitly handles much of the housekeeping
    previously called explicitly by the various filesystem d_revalidate
    routines:
    - shrink_dcache_parent
    - check_submounts_and_drop
    - d_drop
    - d_invalidate
    All in-tree filesystem d_revalidate routines were updated to take
    advantage of this new VFS support.
    
    Modify afs_linux_dentry_revalidate to no longer perform any special
    handling for invalid dentries when D_INVALIDATE_IS_VOID.  Instead, allow
    our VFS caller to properly clean up any invalid dentry when we return 0.
    
    Change-Id: I0c4d777e6d445857c395a7b5f9a43c9024b098e9
    Reviewed-on: https://gerrit.openafs.org/12506
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 961cee00b8f5c302de5f66beb81caa33242c7971
Author: Joe Gorse <jhgorse@gmail.com>
Date:   Thu Feb 16 18:01:50 2017 -0500

    LINUX: Bring debug symbols back to the Linux kernel module.
    
    Starting with 4.8 Linux kernels our existing build script
    generator, make_kbuild_makefile.pl, does not pass the debugging
    symbols CFLAGS that were present when building for previous kernels.
    
    This fix appends the $(KERN_DBG) variable which will only be defined
    when the configuration includes the --enable-debug-kernel option.
    
    Change-Id: I9a85dc0311a3a706239bc9e471b2d7197ebe1946
    Reviewed-on: https://gerrit.openafs.org/12519
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: Benjamin Kaduk <kaduk@mit.edu>

commit 9bc6fd9312a2be591cc831d9b0afd91e53eec6fc
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Fri Feb 10 10:39:09 2017 -0500

    build: add --without-swig to override swig check
    
    Add the --without-swig option to disable the automatic swig detection
    and disable the optional features which depend on swig.  This allows
    builders to avoid swig even if present on the build system.
    
    Also, add the --with-swig option to force the check and fail if not
    detected.  This allows builders to declare the swig features are
    mandatory.
    
    The default continues to be to check for swig, and if present, build the
    optional features which require swig.
    
    To disable the automatic check for swig and disable the features which
    depend on swig:
    
        ./configure --without-swig     # or --with-swig=no
    
    To force the check and fail if swig is not present on the system:
    
        ./configure --with-swig        # or --with-swig=yes
    
    If --with-swig is given and swig is not detected, then configure will
    fail with the message:
    
        configure: error: swig requested but not found
    
    The Perl 5 bindings for libuafs is the only feature which requires swig
    at this time.
    
    Change-Id: I0726658a9cc7b1b2a9d5e5d306adb6e36ad3c0f6
    Reviewed-on: https://gerrit.openafs.org/12518
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit dd97cb7a7447313dbc1da65104786fe03ede7c8d
Author: Andrew Deason <adeason@sinenomine.net>
Date:   Fri Feb 10 01:29:28 2017 -0600

    PERLUAFS: Modernize lang-specific swig typemaps
    
    Currently, our swig bindings for PERLUAFS define a couple of typemaps
    like so:
    
        %typemap(in, numinputs=1, perl5) (char *READBUF, int LENGTH) {
            [...]
        }
    
    Embedding the target language name in the typemap arguments is a very
    old way of specifying what language the typemap is for; they were
    removed after swig 1.1. With swig 3.0.x releases (and possibly
    others), the specific combination of this deprecated syntax and some
    other features we're using causes a segfault. That's clearly a bug in
    swig, but we shouldn't be using the deprecated syntax anyway.
    
    Update this to instead use preprocessor symbols to specify
    language-specific typemaps (#ifdef SWIGPERL). We only actually define
    these for perl right now, so make sure to throw an error if we're not
    running for perl.
    
    FIXES 134103
    
    Change-Id: I14264a2dfada53d99413808ed5d60b79b1ee44f3
    Reviewed-on: https://gerrit.openafs.org/12517
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 5dc53812df9e5a42fa822c9b890c1b8a442bed64
Author: Anders Kaseorg <andersk@mit.edu>
Date:   Tue Dec 6 10:48:31 2016 -0500

    AFS_component_version_number.c: Respect SOURCE_DATE_EPOCH if set
    
    To improve build reproducibility, if the SOURCE_DATE_EPOCH environment
    variable is set, use it to deterministically replace the embedded build
    date, and do not include the username or hostname in this case.
    
    https://wiki.debian.org/ReproducibleBuilds/TimestampsProposal
    
    Change-Id: I9ba951f1836385ffd14aad95f071bf8c672a01bb
    Reviewed-on: https://gerrit.openafs.org/12471
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 872a63bbfb04addbdc17dc5c09ec018bb9ddf515
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Mon Jan 9 23:55:32 2017 -0500

    redhat: move the klog.krb5 man page to openafs-krb5
    
    Move the klog.krb5 man page to the openafs-krb5 package, which
    distributes the klog.krb5 binary, instead of the general openafs
    package.
    
    Change-Id: I6dc3896f330bb0c639cc75155f611ddaf11b9b75
    Reviewed-on: https://gerrit.openafs.org/12509
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit b146c2d54ff3bd99f2c4674eb88d5af417a194d7
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Thu Jan 12 12:27:36 2017 -0500

    SOLARIS: fix for AFS_PAG_ONEGROUP_ENV for Solaris 11
    
    Fix a bug introduced in commit aab1e71628e6a4ce68c5e59e2f815867438280d1
    in which a pointer was incorrectly checked for a NULL value.
    
    Fixes a crash when a PAG is set on Solaris.
    
        # mdb unix.1 vmcore.1
        > ::status
        ...
        panic message:
        BAD TRAP: type=e (#pf Page fault) rp=fffffffc802ba8f0 addr=0 occurred in
          module "afs" due to a NULL pointer dereference
        > ::stack
        pag_to_gidset+0x145()
        setpag+0xcc()
        AddPag+0x3a()
        afs_setpag+0x58()
        Afs_syscall+0x115()
    
    The crash occurs since gidslot is NULL during the assignment:
    
        *gidslot = pagvalue;
    
    Change-Id: Ic4d50c6b046d10faa49cd4363692e0302707583d
    Reviewed-on: https://gerrit.openafs.org/12508
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit a92a3a0675d941536103b60d708a6b3305b9b8fa
Author: Marcio Barbosa <mbarbosa@sinenomine.net>
Date:   Wed Jan 11 06:05:04 2017 -0800

    osx: let prefpane knows where binaries can be found
    
    Starting from OS X 10.11, the OpenAFS binaries were moved to the
    following directories: /opt/openafs/bin and /opt/openafs/sbin. However,
    the OpenAFS prefpane is not aware of the change mentioned above. As a
    result, some functionalities provided by the OpenAFS prefpane are not
    working properly.
    
    To fix this problem, add the new paths to the proper environment
    variable.
    
    Change-Id: Idaa2f0329af2092cf9ad1d63f1a01300b150227a
    Reviewed-on: https://gerrit.openafs.org/12507
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 19599b5ef5f7dff2741e13974692fe4a84721b59
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Sat Jan 7 06:22:47 2017 -0500

    LINUX: eliminate unused variable warning
    
    Commit c3bbf0b4444db88192eea4580ac9e9ca3de0d286 added routine
    osi_TryEvictDentries and included new logic for D_INVALIDATE_IS_VOID.
    Unfortunately, this new code path no longer uses dentry; it also should
    have been made conditional at that time.
    
    Wrap the declaration of dentry in #ifndef D_INVALIDATE_IS_VOID to
    eliminate the unused variable warning.
    
    Change-Id: I89c1430ba984539ca775da2540ea966030de0701
    Reviewed-on: https://gerrit.openafs.org/12505
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 2207dcdaad40beed29b0326153dbb76bdf91564d
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Tue Jan 3 14:41:36 2017 -0500

    cleanup afs_args.h
    
    Collect the syscall op code (AFSOP_) defines in one section and cleanup
    the use of whitespace and tabs.
    
    This should be a non-functional change.
    
    Change-Id: I1ba763a445b938fcb3677a388a703e1405ee166e
    Reviewed-on: https://gerrit.openafs.org/12501
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit aab1e71628e6a4ce68c5e59e2f815867438280d1
Author: Andrew Deason <adeason@dson.org>
Date:   Sat Aug 8 16:49:50 2015 -0500

    SOLARIS: Use AFS_PAG_ONEGROUP_ENV for Solaris 11
    
    On Solaris 11 (specifically, Solaris 11.1+), the supplemental group
    list for a process is supposed to be sorted. Starting with Solaris
    11.2, more authorization checks are done that assume the list is
    sorted (e.g., to do a binary search), so having them out of order
    can cause incorrect behavior. For example:
    
      $ echo foo > /tmp/testfile
      $ chmod 660 /tmp/testfile
      $ sudo chown root:daemon /tmp/testfile
      $ cat /tmp/testfile
      foo
      $ id -a
      uid=100(adeason) gid=10(staff) groups=10(staff),12(daemon),20(games),21(ftp),50(gdm),60(xvm),90(postgres)
      $ pagsh
      $ cat /tmp/testfile
      cat: cannot open /tmp/testfile: Permission denied
      $ id -a
      uid=100(adeason) gid=10(staff) groups=33536,32514,10(staff),12(daemon),20(games),21(ftp),50(gdm),60(xvm),90(postgres)
    
    Solaris sorts the groups given to crsetgroups() on versions which
    required the group ids to be sorted, but we currently manually put our
    PAG groups in our own order in afs_setgroups(). This is currently
    required, since various places in the code assume that PAG groups are
    the first two groups in a process's group list.
    
    To get around this, do not require the PAG gids to be the first two
    gids anymore. To more easily identify PAG gids in group processes, use
    a single gid instead of two gids to identify a PAG, like modern Linux
    currently uses (under the AFS_PAG_ONEGROUP_ENV). High-numbered groups
    have been possible for quite a long time on Solaris, allegedly further
    back than Solaris 8. Only do this for Solaris 11, though, to reduce
    the platforms we affect.
    
    [mmeffie@sinenomine.net: Define AFS_PAG_ONEGROUP_ENV in param.h.]
    
    Change-Id: I44023ee8aa42f3f69bb0c8a8e9178abd513951a1
    Reviewed-on: https://gerrit.openafs.org/11979
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit 97fec642e591762391e6d453874ff9b5c9ba0c1e
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Mon Dec 26 12:15:35 2016 -0600

    afsd_kernel: remove gratuitous OS dependence
    
    Commit 94c15f62 in 2010 gave NetBSD and only NetBSD the debug
    printing of errno and the strerror() output, with no justification
    in the commit message.  In the interest of unifying behavior and
    avoiding unnecessary OS dependence, give all platforms the errno
    and strerror() behavior.
    
    [mmeffie@sinenomine.net: print errno iff syscall returns -1.]
    
    Change-Id: If3c4e0ded54bbd4d5c2573f7d7ee1c82ee3e7223
    Reviewed-on: https://gerrit.openafs.org/12500
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 481047d2a2660609091dc04253d136f527469ceb
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Mon Sep 12 22:21:59 2016 -0400

    afsd: print syscalls on separate lines with afsd -debug
    
    afsd prints information to standard out for testing and debugging when the
    -debug option is given. However, syscall tracing is emitted without trailing
    newlines on all platforms except netbsd, creating an unreadable wall of text.
    
        # afsd -debug
        ...
        afsd: Forking 4 background daemons.
        SScall(183, 28, 0)=0 183, 28, 6583200)=0 SScall(183, 28, 6583
        200)=0 SScall(183, 28, 6583200)=0 SScall(183, 28, 6583200)=0 S
        Scall(183, 28, 6583200)=0 SScall(183, 28, 6583200)=0 SScall(18
        ...
    
    Make the syscall call tracing usable by printing each one on a separate line.
    
        # afsd -deubg
        ...
        afsd: Forking 4 background daemons.
        SScall(183, 28, 0)=0 183, 28, 6583200)=0
        SScall(183, 28, 6583200)=0
        SScall(183, 28, 6583200)=0
        ...
    
    Change-Id: Ic9208243c1e05352744fb6f575384e00d0e3e59c
    Reviewed-on: https://gerrit.openafs.org/12385
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 9c0db059b6585959e151f7acce845de280952c55
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Mon Sep 26 11:19:13 2016 -0400

    vol: convert vnode macros to inline functions
    
    Convert the vnode macros to inline functions to fix integer overflows
    for very large vnode numbers (and generally improve the code robustness
    and readability).
    
    The macro version of vnodeIndexOffset() will evaluate to an incorrect
    offset for very large vnode numbers due to 32-bit integer overflow. The
    vnode index file will then be corrupted when writing to the incorrect
    offset.
    
    In code paths where the vnode number incorrectly defined as a signed
    32-bit integer, this change prevents vnodeIndexOffset() from evaluating
    to a negative result when a vnode number is larger than 2^31.
    
    Thanks to Mark Vitale for reporting and providing analysis.
    
    Change-Id: Ia6e0f2d2f97fa1091e0b5a4029d40098692ee681
    Reviewed-on: https://gerrit.openafs.org/12397
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 0ae62bfa99df8ef5d85b4848783f59a041f82828
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Fri Jun 3 15:33:19 2016 -0400

    doc: add the PtLog man page
    
    Clone the VLLog man page to create a man page for ptserver log as well.
    
    Fix the spelling of the PtLog file and add a link to the new PtLog man
    page in the ptserver man page.
    
    Add the missing PtLog log file name to the bos getlog man page.
    
    Change-Id: I95ad4a2cf380077780160ec78fd1f9bdec132ba7
    Reviewed-on: https://gerrit.openafs.org/12294
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 9ec765d8b4a327ae36c26e38a84dae215d3a2664
Author: Anders Kaseorg <andersk@mit.edu>
Date:   Fri Dec 16 02:43:48 2016 -0500

    opr: Make opr_uuid_hash endian-independent
    
    And also make sure it doesn’t use unaligned accesses.  Fixes a ‘make
    check’ failure on big-endian architectures.
    
    Change-Id: I490174f8d1eecb5f20969b4ef12ff16d0dd3806a
    Reviewed-on: https://gerrit.openafs.org/12495
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Tested-by: Michael Meffie <mmeffie@sinenomine.net>

commit 5151c03351e8a4d2bd1e212720d7ec9144bf23f0
Author: Anders Kaseorg <andersk@mit.edu>
Date:   Fri Dec 16 03:04:18 2016 -0500

    opr: Make opr_jhash_opaque consistent with opr_jhash
    
    Change-Id: I42e1030f8c841dcb974476012a774b91c87d3fb0
    Reviewed-on: https://gerrit.openafs.org/12494
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Tested-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 958120b89d62c8567ab00bc697c4fabdfecd46b4
Author: Anders Kaseorg <andersk@mit.edu>
Date:   Fri Dec 16 02:16:20 2016 -0500

    opr: Make opr_jhash_opaque endian-independent
    
    gcc -O2 produces exactly the same code for this on little-endian
    systems, but now big-endian systems have a chance of passing ‘make
    check’.
    
    Change-Id: Ifc6350648355a0a9f79184439e3f9522cd6f2ffa
    Reviewed-on: https://gerrit.openafs.org/12493
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Tested-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit eb7d3ac4bbd30fc31741cea74fe2b23577deb61e
Author: Anders Kaseorg <andersk@mit.edu>
Date:   Wed Dec 14 17:52:35 2016 -0500

    opr: ExitHandler: re-raise the signal instead of exiting with that code
    
    This fixes a ‘make check’ failure introduced by commit
    803d15b6aa1e65b259ba11ca30aa1afd2e12accb “vlserver: convert the vlserver
    to opr softsig”:
    
        $ make check
        …
        volser/vos..............FAILED 6
        …
        $ cd tests
        $ ./libwrap ../lib ./runtests -o volser/vos
        1..6
        ok 1 - Successfully got security class
        ok 2 - Successfully built ubik client structure
        ok 3 - First address registration succeeds
        ok 4 - Second address registration succeeds
        ok 5 - vos output matches
        Server exited with code 15
        # wanted: 0
        #   seen: -1
        not ok 6 - Server exited cleanly
        # Looks like you failed 1 test of 6
    
    afstest_StopServer has a check for the process terminating with signal
    15 (SIGTERM), but not for the process exiting with code 15.
    
    Change-Id: I022965ea2b5440486ea1cf562551d3bbd0516104
    Reviewed-on: https://gerrit.openafs.org/12489
    Tested-by: Anders Kaseorg <andersk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit eee532ac13a680bfb4cc857485cbaf5e454ab492
Author: Anders Kaseorg <andersk@mit.edu>
Date:   Fri Dec 16 00:29:21 2016 -0500

    doc/man-pages/Makefile.in: mkdir man[158] in case we did regen.sh -q
    
    Fixes this error:
    
    $ git clean -xdf
    $ ./regen.sh -q
    $ ./configure
    $ make
    […]
    make[3]: Entering directory '/…/openafs/doc/man-pages'
    rm -f man*/*.noinstall
    if [ "no" = "no" ] ; then \
            for M in man1/klog.1 man1/knfs.1 […] man8/kpwvalid.8 man1/klog.krb.1; do \
                    touch $M.noinstall; \
            done; \
    fi
    touch: cannot touch 'man1/klog.1.noinstall': No such file or directory
    touch: cannot touch 'man1/knfs.1.noinstall': No such file or directory
    […]
    touch: cannot touch 'man8/kpwvalid.8.noinstall': No such file or directory
    touch: cannot touch 'man1/klog.krb.1.noinstall': No such file or directory
    Makefile:34: recipe for target 'prep-noinstall' failed
    make[3]: *** [prep-noinstall] Error 1
    make[3]: Leaving directory '/…/openafs/doc/man-pages'
    
    Change-Id: I95098fb2b27f1d87fc9769497b225e9f91f72266
    Reviewed-on: https://gerrit.openafs.org/12492
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 93a7e754a44c333140e75e93cac09f61320f7cc9
Author: Anders Kaseorg <andersk@mit.edu>
Date:   Wed Dec 14 15:47:21 2016 -0500

    tests/opr/softsig-t: Avoid hanging due to intermediate sh -c
    
    If the build directory happened to contain shell metacharacters, like
    the ~ in /build/openafs-vb8tid/openafs-1.8.0~pre1 used by the Debian
    builders, Perl was running softsig-helper via an intermediate sh -c,
    which would then intercept the signals we tried to send to
    softsig-helper.  Use the list syntax to avoid this sh -c.
    
    Change-Id: I054b9c8f606e197accb414bfe3f89719255c62c4
    Reviewed-on: https://gerrit.openafs.org/12488
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 9fd396adabaa1868517fdb3d7cfcbe9412c35b0b
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Thu Dec 15 22:12:01 2016 -0600

    tests: use exec to call libwrap'd executables
    
    No need to leave the shell process hanging around.
    
    In particular, if we are manually running softsig-helper under
    libwrap to debug test failures, the child process of the shell is
    another shell, which interprets some signals that we wanted to
    be passed through, like SIGTERM.  On the other hand, once the
    softsig-helper is exec()'d, you basically need another shell to
    terminate it, which is a different problem....
    
    Change-Id: Iff7c519886a018cb68e692746d40c427b6299457
    Reviewed-on: https://gerrit.openafs.org/12490
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Anders Kaseorg <andersk@mit.edu>
    Tested-by: Anders Kaseorg <andersk@mit.edu>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 8b2c4665aabece187759157bda0e26c4b566dd2f
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Tue Aug 16 12:56:47 2016 -0400

    tests: fix signo to signame lookup in opr/softsig tests
    
    Fix the loop condition when scanning the signal number to name table to
    convert a signal number to a name.  Instead of looping sizeof(size_t)
    times, loop for the number of elements in the table.
    
    This bug was masked on 64 bit-platforms, since the signal number to name
    table table currently has 8 elements, which is coincidently the same as
    sizeof(size_t) on 64-bit platforms.  The bug becomes apparent on 32-bit
    systems; only the first 4 elements of the table are checked.
    
    Example error output before this fix:
    
        $ cd tests
        $ ./libwrap ../lib ./runtests -o opr/softsig
        1..11
        ok 1
        ok 2
        ok 3
        ok 4
        ok 5
        not ok 6
        # Failed test in ./opr/softsig-t at line 57.
        # got: 'Received UNK
        # '
        # expected: 'Received TERM
        # '
        not ok 7
        # Failed test in ./opr/softsig-t at line 60.
        # got: 'Received UNK
        # '
        # expected: 'Received USR1
        # '
        not ok 8
        # Failed test in ./opr/softsig-t at line 63.
        # got: 'Received UNK
        # '
        # expected: 'Received USR2
        # '
        ok 9 - Helper exited on KILL signal.
        ok 10 - Helper exited on SEGV signal.
        ok 11 # skip Skipping buserror test; SIGBUS constant is not defined.
        # Looks like you failed 3 tests of 11.
    
    Change-Id: I863cc9f3650c4a5e9ac9159d90e063b986a8460a
    Reviewed-on: https://gerrit.openafs.org/12367
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 1d8cb56999a4ab25ae4cbc8e8a688b8100aedd3b
Author: Neale Ferguson <neale@sinenomine.net>
Date:   Thu Dec 8 11:47:09 2016 -0500

    s390: desupport 32-bit Linux kernels on s390/s390x
    
    Remove the obsolete and custom lwp assembler for the s390 and s390x
    architectures.  That assembler is no longer needed since 32-bit
    mainframe Linux distributions are no longer supported and are very
    unlikely to be in use.
    
    The generic process.default.s is sufficient for modern 64-bit Linux
    distributions on s390/s390x.
    
    [mmeffie@sinenomine.net: commit message wording]
    
    Change-Id: I654b10dfc257e7de90c9a50048982427276f4d61
    Reviewed-on: https://gerrit.openafs.org/12475
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit b5e4e8c14130f601bbf43dee5927222ebf7613fa
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Tue Jan 12 18:06:51 2016 -0500

    afs: fs getcacheparms miscounts dcaches for large files
    
    fs getcacheparms issued with the -excessive option tabulates in-memory
    dcaches ("DCentries") by size.  However, any dcache with validPos > 2^31
    is miscounted in the 4k-16k bucket.  This is caused by a type mismatch
    between 'validPos' (afs_size_t) and 'size' (int) which leads to a
    negative value for size by sign-extension.  The size comparison "sieve"
    fails for negative numbers; it skips the first bucket (0-4K) and dumps
    them in the second one (4k-16k).
    
    Move the declaration of 'size' closer to its use, and declare it with
    the same type as 'validPos' (afs_size_t) so the comparison sieve
    correctly places these dcaches in the last (>=1M) bucket.
    
    Change-Id: Ib0d973da92865043a4f1c068de5e9b81bcde2b9a
    Reviewed-on: https://gerrit.openafs.org/12347
    Reviewed-by: Stephan Wiesand <stephan.wiesand@desy.de>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit c966c0b8414ef0a041b1a8d5261c9eccd4d39d99
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Tue Jan 12 17:50:36 2016 -0500

    afs: fs getcacheparms miscounts zero-length dcaches
    
    When fs getcacheparms is issued with the -excessive option, it
    tabulates all in-memory dcaches ("DCentries") by size.
    
    dcaches with validPos == 0 were being tabulated in the 4k-16k bucket.
    
    Fix the first comparison in the 'sieve' so these dcaches will be counted
    in the correct 0-4k bucket instead.
    
    Introduced by commit 176c2fddb95ced6c13e04e7492fc09b5551f273c
    
    Change-Id: I60acb0f115dad9f7951f0b17e5b3e37dc94321b9
    Reviewed-on: https://gerrit.openafs.org/12346
    Reviewed-by: Stephan Wiesand <stephan.wiesand@desy.de>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit 7442752ba6ad618bcdf2185f699d90c56838e89e
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Mon Dec 5 18:11:22 2016 -0600

    Make OpenAFS 1.8.0pre1
    
    Update version strings for the first 1.8.0 prerelease.
    
    Change-Id: I4f534c9934f6eb1baac9a784fb7c357b19924fb0
    Reviewed-on: https://gerrit.openafs.org/12470
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Stephan Wiesand <stephan.wiesand@desy.de>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit edcafa93b6c4744e0747842a2e115df27e20fd93
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Fri Sep 23 00:22:22 2016 -0500

    Update NEWS for 1.8
    
    [kaduk@mit.edu: adjust sorting, rewrap, reword a few entries and
    remove some entries that will not be applicable]
    
    Change-Id: Ifbadc31e3f201e05617a26c12e5e725a5f3c9195
    Reviewed-on: https://gerrit.openafs.org/12393
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: Benjamin Kaduk <kaduk@mit.edu>

commit 37c47e5da1cfcceb3b14e5a0c4064a6ca5806bd0
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Fri Sep 23 00:14:09 2016 -0500

    Import NEWS from openafs-stable-1_6_x
    
    The 1.6.x changelog entries have been going directly on the
    openafs-stable-1_6_x branch for ease of maintenance.
    
    However, we don't want to skip those changes when mentioning changes
    in OpenAFS 1.8, so pull back a copy onto master before adding
    things for 1.8.
    
    Change-Id: I545c19db9854300a84295d3ca8b1f301756c38b0
    Reviewed-on: https://gerrit.openafs.org/12392
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Stephan Wiesand <stephan.wiesand@desy.de>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 35f2b8cd49477b10cf358d853f5864b8ad24ba03
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Tue Dec 6 17:07:40 2016 -0500

    Update libafsdep files for in-kernel fortuna
    
    Commit 0d67b00ff9db added heimdal's rand-fortuna PRNG to the kernel
    module on all architectures, even though it is only needed on the small
    subset that do not provide a cryptographically strong random number
    generator to kernel module consumers.  This was done to ensure that
    the build infrastructure for it gets regularly exercised by developers.
    However, not all build infrastructure was exercised at the time of
    that submission; in particular, the make_libafs_tree.pl script was
    not tested.  This led to a situation where the libafs tree generated
    by that script omitted several files that were now referenced by
    the kernel build due to the fortuna import.
    
    To remedy the situation, list the additional files that are needed,
    so that they will be copied into the build area for this class of
    kernel module builds.
    
    Since the libafs-tree functionality is used to build the Debian
    kernel-module source packages, this fix is needed in order to have
    a tree that can be built into debian packages without patching.
    
    Change-Id: I81502fb61d7fc718d337c5f73a51b88f6a433d6a
    Reviewed-on: https://gerrit.openafs.org/12473
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 85c7d31cf2dacdbcd8a053fdc3f66952e7126528
Author: Anders Kaseorg <andersk@mit.edu>
Date:   Tue Dec 6 10:53:40 2016 -0500

    src/cf/roken.m4: Escape buildtool_roken correctly
    
    Fixes these errors from configure:
    
    ./configure: line 32154: LDFLAGS_roken: command not found
    ./configure: line 32154: LIB_roken: command not found
    
    Change-Id: I63b9ade5c8f55948ea2a3f7ae023de4ed9f62341
    Reviewed-on: https://gerrit.openafs.org/12472
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 4c03e42f91b36a0bf59398b0f649aa0b31b02975
Author: Andrew Deason <adeason@dson.org>
Date:   Wed Oct 26 16:04:51 2016 -0500

    rx: Add rxi_FlushWriteLocked
    
    Currently, a couple of places in Rx do this:
    
        MUTEX_EXIT(&call->lock);
        rxi_FlushWrite(call);
        MUTEX_ENTER(&call->lock);
    
    This is a little silly, because if rxi_FlushWrite has anything to do,
    it just acquires/drops call->lock again.
    
    This seems like a very minor performance penalty, but in the right
    situation it can become more noticeable. Specifically, when an Rx call
    on the server ends successfully, rx_EndCall will rxi_FlushWrite (to
    send out the last Rx packet to the client) before marking the call as
    finished. If the client receives the last Rx packet and starts a new
    Rx call on the same channel before the server locks the call again,
    the client can receive a BUSY packet (because it looks like the
    previous call on the server hasn't finished yet). Nothing breaks, but
    this means the client waits 3 seconds to retry.
    
    This situation can probably happen with various rates of success in
    almost any situation, but I can see it consistently happen with 'vos
    move' when running 'vos' on the same machine as the source fileserver.
    It is most noticeable when moving a large number of small volumes
    (since you must wait an extra 3+ seconds per volume, where nothing is
    happening).
    
    To avoid this, create a new variant of rxi_FlushWrite, called
    rxi_FlushWriteLocked. This just assumes the call lock is already held
    by the caller, and avoids one extra lock/unlock pair. This is not the
    only place where we unlock/lock the call during the rx_EndCall
    situation described above, but it seems to be easiest to solve, and
    it's enough (for me) to avoid the 3-second delay in the 'vos move'
    scenario. Ideally, Rx should be able to atomically 'end' a call while
    sending out this last packet, but for now, this commit is easy to do.
    
    Note that rxi_FlushWrite previously didn't do much of note before
    locking the call. It did call rxi_FreePackets without the call lock,
    but calling that with the call lock is also fine; other callers do
    that.
    
    Change-Id: I8f71e86f6c1f6019abea21c205d2b26b7da0d808
    Reviewed-on: https://gerrit.openafs.org/12421
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit f413fd927af14a9a87034e47125a78eec63e599e
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Tue Jan 13 21:39:57 2015 -0500

    pts: add some sanity checks in ptuser.c
    
    Double-check that when we're expecting two entries back, we
    actually got two entries, in addition to the RPC return value.
    
    Change-Id: I34631ac542667c337ed3268153eb61c70e3fa87e
    Reviewed-on: https://gerrit.openafs.org/11668
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 32901c58b29ba4ac666f1dba9915cae2c1f03b52
Author: Andrew Deason <adeason@sinenomine.net>
Date:   Mon Mar 9 18:01:29 2015 -0500

    LINUX: Don't compile syscall code with keyrings
    
    osi_syscall_init() is not currently called if we have kernel keyrings
    support, since we don't need to set up or alter any syscalls if we
    have kernel keyrings (we track PAGs by keyrings, and we use ioctls
    instead of the AFS syscall now).
    
    Since we don't call it, this commit makes us also not compile the
    relevant syscall-related code. This allows new platforms to be added
    without needing to deal with any platform-specific code for handling
    32-bit compat processes and such, since usually we don't need to deal
    with intercepting syscalls.
    
    To do this, we just define osi_syscall_init and osi_syscall_cleanup as
    noops if we have keyrings support. This allows us to reduce the #ifdef
    clutter in the actual callers.
    
    Note that the 'afspag' module does currently call osi_syscall_init
    unconditionally, but this seems like an oversight. With this change,
    the afspag module will no longer alter syscalls when we have linux
    keyrings support.
    
    Change-Id: I219b92d89303975765743712587ff897b55a2631
    Reviewed-on: https://gerrit.openafs.org/11936
    Reviewed-by: Chas Williams <3chas3@gmail.com>
    Reviewed-by: Perry Ruiter <pruiter@sinenomine.net>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit a6e96a8f10df738eb9b69227d344a72eb830e02e
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Wed Nov 30 08:48:06 2016 -0500

    vos: fix vos release -verbose output
    
    Fix incorrect vos release -verbose messages introduced by commit
    9f4684cd5fac5eacf571b882e965150943383170.
    
    The commit 9f4684cd5fac5eacf571b882e965150943383170 did not take into
    account the change from commit 3fc800be9c702c1a40869908831a9895602909cb
    in which a partial commit is performed when just new sites are added and
    the read-write volume was not changed since the previous release.
    
    Change-Id: If4b3ab81cd810df2e866d6eca0152f475c5448d6
    Reviewed-on: https://gerrit.openafs.org/12455
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 5b28061fb593f5f48df549b07f0ccd848348b93c
Author: Marcio Barbosa <mbarbosa@sinenomine.net>
Date:   Mon Nov 28 09:42:44 2016 -0500

    afs: release the packets used by rx on shutdown
    
    When the OpenAFS client is unmounted on DARWIN, the blocks of packets
    allocated by RX are released. Historically, the memory used by those
    packets was never properly released.
    
    Before 230dcebcd61064cc9aab6d20d34ff866a5c575ea, only the last block of
    packets used to be released:
    
    ...
    struct rx_packet *rx_mallocedP = 0;
    ...
    void
    rxi_MorePackets(int apackets)
    {
        ...
        getme = apackets * sizeof(struct rx_packet);
        p = rx_mallocedP = (struct rx_packet *)osi_Alloc(getme);
        ...
    }
    ...
    void
    rxi_FreeAllPackets(void)
    {
        ...
        osi_Free(rx_mallocedP, ...);
        ...
    }
    ...
    
    As we can see, ‘rx_mallocedP’ is a global pointer that stores the
    first address of the last allocated block of packets. As a result, when
    ‘rxi_FreeAllPackets’ is called, only the last block is released.
    
    However, 230dcebcd61064cc9aab6d20d34ff866a5c575ea moved the global
    pointer in question to the end of the last block. As a result, when the
    OpenAFS client is unmounted on DARWIN, the ‘rxi_FreeAllPackets’
    function releases the wrong block of memory. This problem was exposed
    on OS X 10.12 Sierra where the system crashes when the OpenAFS client
    is unmounted.
    
    To fix this problem, store the address of every single block of packets
    in a queue and release one by one when the OpenAFS client is unmounted.
    
    Change-Id: Ibd6bd1a8bc45bb4802f9381a8e600c20ee85a59e
    Reviewed-on: https://gerrit.openafs.org/12427
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit f591f6fae3d8b8d44140ca64e53bad840aeeeba0
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Mon Nov 7 14:16:50 2016 -0500

    dir: do not leak contents of deleted directory entries
    
    Deleting an AFS directory entry (afs_dir_Delete) merely removes the
    entry logically by updating the allocation map and hash table.  However,
    the entry itself remains on disk - that is, both the cache manager's
    cache partition and the fileserver's vice partitions.
    
    This constitutes a leak of directory entry information, including the
    object's name and MKfid (vnode and uniqueid).  This leaked information
    is also visible on the wire during FetchData requests and volume
    operations.
    
    Modify afs_dir_Delete to clear the contents of deleted directory
    entries.
    
    Patchset notes:
    This commit only prevents leaks for newly deleted entries.  Another
    commit in this patchset prevents leaks of partial object names upon
    reuse of pre-existing deleted entries.  A third commit in this
    patchset prevents yet another kind of directory entry leak, when
    internal buffers are reused to create or enlarge existing directories.
    All three patches are required to prevent new leaks.  Two additional
    salvager patches are also included to assist administrators in the
    cleanup of pre-existing leaks.
    
    [kaduk@mit.edu: style nit for sizeof() argument]
    
    Change-Id: Iabaafeed09a2eb648107b7068eb3dbf767aa2fe9
    Reviewed-on: https://gerrit.openafs.org/12460
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Tested-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit a26c5054ee501ec65db3104f6a6a0fef634d9ea7
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Sun Nov 6 23:29:22 2016 -0600

    afs: do not leak stale data in buffers
    
    Similar to the previous commit, zero out the buffer when fetching
    a new slot, to avoid the possibility of leaving stale data in
    a reused buffer.
    
    We are not supposed to write such stale data back to a fileserver,
    but this is an extra precaution in case of bugs elsewhere -- memset
    is not as expensive as it was in the 1980s.
    
    Change-Id: I344e772e9ec3d909e8b578933dd9c6c66f0a8cf6
    Reviewed-on: https://gerrit.openafs.org/12459
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Tested-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 70065cb1831dbcfd698c8fee216e33511a314904
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Fri May 13 00:01:31 2016 -0400

    dir: fileserver leaks names of file and directories
    
    Summary:
    Due to incomplete initialization or clearing of reused memory,
    fileserver directory objects are likely to contain "dead" directory
    entry information.  These extraneous entries are not active - that is,
    they are logically invisible to the fileserver and client.  However,
    they are physically visible on the fileserver vice partition, on the
    wire in FetchData replies, and on the client cache partition.  This
    constitutes a leak of directory information.
    
    Characterization:
    There are three different kinds of "dead" residual directory entry
    leaks, each with a different cause:
    
    1. There may be partial name data after the null terminator in a live
    directory entry.   This happens when a previously used directory entry
    becomes free, then is reused for a directory entry with a shorter name.
    This may be addressed in a future commit.
    
    2. "Dead" directory entries are left uncleared after an object is
    deleted or renamed.  This may be addressed in a future commit.
    
    3. Residual directory entries may be inadvertently picked up when a new
    directory is created or an existing directory is extended by a 2kiBi
    page.  This is the most severe problem and is addressed by this commit.
    
    This third kind of leak is the most severe because the leaked
    directory information may be from _any_ other directory residing on the
    fileserver, even if the current user is not authorized to see that
    directory.
    
    Root cause:
    The fileserver's directory/buffer package shares a pool of directory
    page buffers among all fileserver threads for both directory reads and
    directory writes.  When the fileserver creates a new directory or
    extends an existing one, it uses any available unlocked buffer in the
    pool.  This buffer is likely to contain another directory page recently
    read or written by the fileserver.  Unfortunately the fileserver only
    initializes the page header fields (and the first two "dot" and "dotdot"
    entries in the case of a new directory).  Any residual entries in the
    rest of the directory page are now logically "dead", but still
    physically present in the directory.  They can easily be seen on the
    vice partition, on the wire in a FetchData reply, and on the cache
    partition.
    
    Note:
    The directory/buffer package used by the fileserver is also used by the
    salvager and the volserver.  Therefore, salvager activity may also leak
    directory information to a certain extent.   The volserver vos split
    command may also contribute to leaks.  Any volserver operation that
    creates volumes (create, move, copy, restore, release) may also have
    insignificant leaks.  These less significant leaks are addressed by this
    commit as well.
    
    Exploits:
    Any AFS user authorized to read directories may passively exploit this
    leak by capturing wire traffic or examining his local cache as he/she
    performs authorized reads on existing directories.  Any leaked data will
    be for other directories the fileserver had in the buffer pool at the
    time the authorized directories were created or extended.
    
    Any AFS user authorized to write a new directory may actively exploit
    this leak by creating a new directory, flushing cache, then re-reading
    the newly created directory.  Any leaked data will be for other
    directories the fileserver had in the buffer pool within the last few
    seconds.  In this way an authorized user may sample current fileserver
    directory buffer contents for as long as he/she desires, without being
    detected.
    
    Directories already containing leaked data may themselves be leaked,
    leading to multiple layers of leaked data propagating with every new or
    extended directory.
    
    The names of files and directories are the most obvious source of
    information in this leak, but the FID vnode and uniqueid are leaked as
    well.  Careful examination of the sequences of leaked vnode numbers and
    uniqueids may allow an attacker to:
    - Discern each layer of old directories by observing breaks in
      consecutive runs of vnode and/or uniqueid numbers.
    - Infer which objects may reside on the same volume.
    - Discover the order in which objects were created (vnode) or modified
      (uniqueid).
    - Know whether an object is a file (even vnode) or a directory (odd
      vnode).
    
    Prevent new leaks by always clearing a pool buffer before using it to
    create or extend a directory.
    
    Existing leaks on the fileserver vice partitions may be addressed in a
    future commit.
    
    Change-Id: Ia980ada6a2b1b2fd473ffc71e9fd38255393b352
    Reviewed-on: https://gerrit.openafs.org/12458
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Tested-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 1637c4d7c1ce407390f65509a3a1c764a0c06aa6
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Sun Nov 6 15:06:02 2016 -0600

    bos: re-add -salvagedirs for use with -all
    
    The MR-AFS support code had a -salvagedirs option that was passed
    through to the salvager (when running, and when -all was used),
    that was removed in commit a9301cd2dc1a875337f04751e38bba6f1da7ed32
    along with the rest of the MR-AFS commands and options.
    
    However, it is useful in its own right, so add it back and allow
    the use of -salvagedirs -all to rebuild every directory on the server.
    
    Change-Id: Ifc9c0e4046bf049fe04106aec5cad57d335475e3
    Reviewed-on: https://gerrit.openafs.org/12457
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Tested-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 9e66234951cca3ca77e94ab431f739e85017a23a
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Sun Nov 6 14:31:22 2016 -0600

    dafs: honor salvageserver -salvagedirs
    
    Do not ignore the -salvagedirs option when given to the salvageserver.
    When the salvageserver is running with this option, all directories will
    be rebuilt by salvages spawned by the dafs salvageserver, including all
    demand attach salvages and salvages of individual volumes initiated by
    bos salvage.
    
    This does not affect the whole partition salvages initiated by bos
    salvage -all.
    
    Change-Id: I4dd515ffa8f962c61e922217bee20bbd88bcd534
    Reviewed-on: https://gerrit.openafs.org/12456
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Tested-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 3704fc6f2e6716d95446cd10aa2ec798be13472c
Author: Anders Kaseorg <andersk@mit.edu>
Date:   Fri Nov 4 20:17:32 2016 -0400

    Remove NULL checks for AFS_NONNULL parameters
    
    Recent GCC warns about opr_Assert(p != NULL), where p is an
    __attribute__((__nonnull__)) parameter, just like clang did before those
    clang warnings were silenced by 11852, 11853.
    
    Now, we could go and add more autoconf tests and pragmas to silence the
    GCC versions of these warnings.  However, I maintain that silencing the
    warnings is the wrong approach.  The asserts in question have no
    purpose.  They do not add any safety, because GCC and clang are
    optimizing them away at compile time (without proof!—they take the
    declaration at its word that NULL will never be passed).  Just remove
    them.
    
    Fixes these warnings (errors with --enable-checking) from GCC 6.2:
    
    In file included from casestrcpy.c:17:0:
    casestrcpy.c: In function ‘opr_lcstring’:
    casestrcpy.c:26:31: error: nonnull argument ‘d’ compared to NULL [-Werror=nonnull-compare]
         opr_Assert(s != NULL && d != NULL);
                                   ^
    /…/openafs/include/afs/opr.h:28:15: note: in definition of macro ‘__opr_Assert’
         do {if (!(ex)) opr_AssertionFailed(__FILE__, __LINE__);} while(0)
                   ^~
    casestrcpy.c:26:5: note: in expansion of macro ‘opr_Assert’
         opr_Assert(s != NULL && d != NULL);
         ^~~~~~~~~~
    casestrcpy.c:26:18: error: nonnull argument ‘s’ compared to NULL [-Werror=nonnull-compare]
         opr_Assert(s != NULL && d != NULL);
                      ^
    /…/openafs/include/afs/opr.h:28:15: note: in definition of macro ‘__opr_Assert’
         do {if (!(ex)) opr_AssertionFailed(__FILE__, __LINE__);} while(0)
                   ^~
    casestrcpy.c:26:5: note: in expansion of macro ‘opr_Assert’
         opr_Assert(s != NULL && d != NULL);
         ^~~~~~~~~~
    casestrcpy.c: In function ‘opr_ucstring’:
    casestrcpy.c:46:31: error: nonnull argument ‘d’ compared to NULL [-Werror=nonnull-compare]
         opr_Assert(s != NULL && d != NULL);
                                   ^
    /…/openafs/include/afs/opr.h:28:15: note: in definition of macro ‘__opr_Assert’
         do {if (!(ex)) opr_AssertionFailed(__FILE__, __LINE__);} while(0)
                   ^~
    casestrcpy.c:46:5: note: in expansion of macro ‘opr_Assert’
         opr_Assert(s != NULL && d != NULL);
         ^~~~~~~~~~
    casestrcpy.c:46:18: error: nonnull argument ‘s’ compared to NULL [-Werror=nonnull-compare]
         opr_Assert(s != NULL && d != NULL);
                      ^
    /…/openafs/include/afs/opr.h:28:15: note: in definition of macro ‘__opr_Assert’
         do {if (!(ex)) opr_AssertionFailed(__FILE__, __LINE__);} while(0)
                   ^~
    casestrcpy.c:46:5: note: in expansion of macro ‘opr_Assert’
         opr_Assert(s != NULL && d != NULL);
         ^~~~~~~~~~
    casestrcpy.c: In function ‘opr_strcompose’:
    /…/openafs/include/afs/opr.h:28:12: error: nonnull argument ‘buf’ compared to NULL [-Werror=nonnull-compare]
         do {if (!(ex)) opr_AssertionFailed(__FILE__, __LINE__);} while(0)
                ^
    /…/openafs/include/afs/opr.h:37:25: note: in expansion of macro ‘__opr_Assert’
     # define opr_Assert(ex) __opr_Assert(ex)
                             ^~~~~~~~~~~~
    casestrcpy.c:98:5: note: in expansion of macro ‘opr_Assert’
         opr_Assert(buf != NULL);
         ^~~~~~~~~~
    kalocalcell.c: In function ‘ka_CellToRealm’:
    /…/openafs/include/afs/opr.h:28:12: error: nonnull argument ‘realm’ compared to NULL [-Werror=nonnull-compare]
         do {if (!(ex)) opr_AssertionFailed(__FILE__, __LINE__);} while(0)
                ^
    /…/openafs/include/afs/opr.h:37:25: note: in expansion of macro ‘__opr_Assert’
     # define opr_Assert(ex) __opr_Assert(ex)
                             ^~~~~~~~~~~~
    kalocalcell.c:117:5: note: in expansion of macro ‘opr_Assert’
         opr_Assert(realm != NULL);
         ^~~~~~~~~~
    
    Change-Id: I6fd618ed49255d7b3de2f8f3424d9659890829c0
    Reviewed-on: https://gerrit.openafs.org/12442
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 822ca15a0e760ad9f2c04cd177ca5634f85ee8d6
Author: Dave Botsch <botsch@cnf.cornell.edu>
Date:   Thu Nov 17 13:22:17 2016 -0500

    Mac OS Sierra deprecates syscall()
    
    The syscall() function has been deprecated in MacOS 10.12 - Sierra. After
    discussions with developers, it would appear that syscall() isn't really
    needed, anymore, so we can just do away with it.
    
    Change-Id: I60e4220168b097bbae7a5ebaceb2d32276aad3e5
    Reviewed-on: https://gerrit.openafs.org/12452
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 74f837fd943ddfa20d349a83d6286a0183cb4663
Author: Dave Botsch <botsch@cnf.cornell.edu>
Date:   Thu Nov 3 12:22:21 2016 -0400

    Define OSATOMIC_USE_INLINED to get usable atomics on DARWIN
    
    In Mac OS 10.12, legacy interfaces for atomic operations have been
    deprecated. Defining OSATOMIC_USE_INLINED gets us inline implementations
    of the OSAtomic interfaces in terms of the <stdatomic.h> primitives.
    This is a transition convenience.
    
    Also indent preprocessor directives within the main DARWIN block to
    improve readability.
    
    Change-Id: Id10ae007d5427486f1b0a307a04a90f263201150
    Reviewed-on: https://gerrit.openafs.org/12433
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit f5f057ce8198480fb9c67f2a8c8eee906f8a7c4a
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Thu Jul 7 15:51:18 2016 -0400

    doc: update information about vlserver logging
    
    Mention the vlserver -d option can be used to set the initial logging
    level.
    
    Thanks to Mark Vitale for the suggestion.
    
    Change-Id: Ia17a2063432343c2cf78e1b01c5897751625aae8
    Reviewed-on: https://gerrit.openafs.org/12324
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 37db7985fde9e6a5e71ae628d0b7124a27bf31c3
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Sat Nov 5 12:42:19 2016 -0400

    SOLARIS: convert from ancient _depends_on to ELF dependencies
    
    The ancient way of declaring module dependencies with _depends_on has
    been deprecated since SunOS 2.6 (circa 1996). The presence of the old
    _depends_on symbol triggers a warning message on the console starting
    with Solaris 12, and the kernel runtime loader (krtld) feature of using
    the _depends_on symbol to load dependencies may be removed in a future
    version of Solaris.
    
    Convert the kernel module from the ancient _depends_on method to modern
    ELF dependencies.  Remove the old _depends_on symbol and specify the -dy
    and -N <name> linker options to set the ELF dependencies at link time,
    as recommended in the Solaris device driver developer guidelines [1].
    
    This commit does not change the declared dependencies, which may be
    vestiges of ancient afs versions.
    
    [1]: http://docs.oracle.com/cd/E19455-01/805-7378/6j6un037u/index.html#loading-16
    
    Change-Id: Ic5abd82108cd59c0796a8d7659ddaffa791dbeee
    Reviewed-on: https://gerrit.openafs.org/12453
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 3af0460a4a6d7bf22e1789fd9e375659e20c3a55
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Mon Nov 21 13:25:40 2016 -0500

    doc: correct help for 'bos getlog' -restricted mode
    
    Commit f085951d39c0d6c1e6a626177c30235704317600 introduced an error in
    the bos getlog helpfile.
    
    Modify the helpfile to describe the actual restrictions imposed by
    -restricted mode.
    
    Change-Id: I8d8fedb558a1bdbd55d80046b2011f3aacc71b3f
    Reviewed-on: https://gerrit.openafs.org/12454
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: Benjamin Kaduk <kaduk@mit.edu>

commit c3bbf0b4444db88192eea4580ac9e9ca3de0d286
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Thu Aug 4 18:42:27 2016 -0400

    LINUX: do not use d_invalidate to evict dentries
    
    When working within the AFS filespace, commands which access large
    numbers of OpenAFS files (e.g., git operations and builds) may result in
    active files (e.g., the current working directory) being evicted from the
    dentry cache.  One symptom of this is the following message upon return
    to the shell prompt:
    
    "fatal: unable to get current working directory: No such file or
    directory"
    
    Starting with Linux 3.18, d_invalidate returns void because it always
    succeeds.  Commit a42f01d5ebb13da575b3123800ee6990743155ab adapted
    OpenAFS to cope with the new return type, but not with the changed
    semantics of d_invalidate.  Because d_invalidate can no longer fail with
    -EBUSY when invoked on an in-use dentry. OpenAFS must no longer trust it
    to preserve in-use dentries.
    
    Modify the dentry eviction code to use a method (d_prune_aliases) that
    does not evict in-use dentries.
    
    Change-Id: I1826ae2a89ef4cf6b631da532521bb17bb8da513
    Reviewed-on: https://gerrit.openafs.org/12363
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: Benjamin Kaduk <kaduk@mit.edu>

commit 9d4be0bd01696768602a313f627a802b358b5885
Author: Marcio Barbosa <mbarbosa@sinenomine.net>
Date:   Fri Nov 11 13:21:58 2016 -0800

    macos: do not quit prefpane unexpectedly
    
    If the user opens the OpenAFS preference pane and choose the Mounts
    tab, the preference pane crashes.
    
    To fix the problem, do not assume that we can cast a NSdictionary
    object to NSMutableDictionary.
    
    Change-Id: I3b5f6cb324a6b53c6b53606f71185f61450ee793
    Reviewed-on: https://gerrit.openafs.org/12446
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: Benjamin Kaduk <kaduk@mit.edu>

commit 3e8529b6efec4625a4c67e6779fc8367291461a0
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Wed May 18 00:36:12 2016 -0400

    salvager: fix error message for invalid volumeid
    
    If the specified volumeid is invalid (e.g. volume name was specified
    instead of volume number), the error is reported via Log().  However,
    commit 24fed351fd13b38bfaf9f278c914a47782dbf670 moved the log opening
    logic from before this check to after it, effectively making this Log()
    call a no-op.
    
    Instead, use fprintf to issue the error message.
    
    Change-Id: I488bc93b178c7973e48d7c9ef4e7ecde9ba62696
    Reviewed-on: https://gerrit.openafs.org/12288
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit e8f066dede63648d7d54c632e0e257c80db6effa
Author: Anders Kaseorg <andersk@mit.edu>
Date:   Fri Nov 4 20:48:02 2016 -0400

    src/tools/rxperf/rxperf.c: Fix misleading indentation
    
    Fixes these warnings (errors with --enable-checking) from GCC 6.2:
    
    rxperf.c: In function ‘rxperf_server’:
    rxperf.c:930:4: error: this ‘if’ clause does not guard... [-Werror=misleading-indentation]
        if (ptr && *ptr != '\0')
        ^~
    rxperf.c:932:6: note: ...this statement, but the latter is misleadingly indented as if it is guarded by the ‘if’
          break;
          ^~~~~
    rxperf.c: In function ‘rxperf_client’:
    rxperf.c:1102:4: error: this ‘if’ clause does not guard... [-Werror=misleading-indentation]
        if (ptr && *ptr != '\0')
        ^~
    rxperf.c:1104:6: note: ...this statement, but the latter is misleadingly indented as if it is guarded by the ‘if’
          break;
          ^~~~~
    
    Change-Id: I4e8e1f75ec14fa9f95441275cfc136adbb448e9e
    Reviewed-on: https://gerrit.openafs.org/12440
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit 85cf397ec18ecfde36433fb65e5d91ecd325b76e
Author: Anders Kaseorg <andersk@mit.edu>
Date:   Fri Nov 4 20:46:22 2016 -0400

    src/gtx/curseswindows.c: Fix misleading indentation
    
    Fixes these warnings (errors with --enable-checking) from GCC 6.2:
    
    curseswindows.c: In function ‘gator_cursesgwin_drawchar’:
    curseswindows.c:574:5: error: this ‘if’ clause does not guard... [-Werror=misleading-indentation]
         if (params->highlight)
         ^~
    curseswindows.c:576:9: note: ...this statement, but the latter is misleadingly indented as if it is guarded by the ‘if’
             if (code)
             ^~
    curseswindows.c:579:5: error: this ‘if’ clause does not guard... [-Werror=misleading-indentation]
         if (params->highlight)
         ^~
    curseswindows.c:581:9: note: ...this statement, but the latter is misleadingly indented as if it is guarded by the ‘if’
             if (code)
             ^~
    curseswindows.c: In function ‘gator_cursesgwin_drawstring’:
    curseswindows.c:628:5: error: this ‘if’ clause does not guard... [-Werror=misleading-indentation]
         if (params->highlight)
         ^~
    curseswindows.c:630:2: note: ...this statement, but the latter is misleadingly indented as if it is guarded by the ‘if’
      if (code)
      ^~
    curseswindows.c:633:5: error: this ‘if’ clause does not guard... [-Werror=misleading-indentation]
         if (params->highlight)
         ^~
    curseswindows.c:635:2: note: ...this statement, but the latter is misleadingly indented as if it is guarded by the ‘if’
      if (code)
      ^~
    
    Change-Id: Ib53eb5755eebb5e22a5414ced8a2540825b41e15
    Reviewed-on: https://gerrit.openafs.org/12439
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit 86153c65cad10b0459d0f87bbe227a1ebe40f4ea
Author: Anders Kaseorg <andersk@mit.edu>
Date:   Fri Nov 4 20:44:00 2016 -0400

    src/afsd/afsd.c: Fix misleading indentation
    
    Fixes these warnings (errors with --enable-checking) from GCC 6.2:
    
    afsd.c: In function ‘afsd_run’:
    afsd.c:2176:6: error: this ‘if’ clause does not guard... [-Werror=misleading-indentation]
          if (enable_rxbind)
          ^~
    afsd.c:2178:3: note: ...this statement, but the latter is misleadingly indented as if it is guarded by the ‘if’
       afsd_syscall(AFSOP_ADVISEADDR, code, addrbuf, maskbuf, mtubuf);
       ^~~~~~~~~~~~
    afsd.c:2487:5: error: this ‘if’ clause does not guard... [-Werror=misleading-indentation]
         if (afsd_debug)
         ^~
    afsd.c:2490:2: note: ...this statement, but the latter is misleadingly indented as if it is guarded by the ‘if’
      afsd_syscall(AFSOP_GO, 0);
      ^~~~~~~~~~~~
    
    Change-Id: Ic4769046dc06bb58d61428ac08ea12a2f70743e9
    Reviewed-on: https://gerrit.openafs.org/12438
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit 38040db3bb7b5ae4d5b2c710da17ba60abe39935
Author: Anders Kaseorg <andersk@mit.edu>
Date:   Fri Nov 4 20:39:34 2016 -0400

    src/ubik/uinit.c: Fix misleading indentation
    
    Fixes this warning (error with --enable-checking) from GCC 6.2:
    
    uinit.c: In function ‘internal_client_init’:
    uinit.c:96:2: error: this ‘if’ clause does not guard... [-Werror=misleading-indentation]
      if (code)
      ^~
    uinit.c:98:6: note: ...this statement, but the latter is misleadingly indented as if it is guarded by the ‘if’
          return code;
          ^~~~~~
    
    Change-Id: Ib03c4128e206194fa5c34fa3c49bb06beb70e6d0
    Reviewed-on: https://gerrit.openafs.org/12437
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit 0aeb8c17a2701169ddb7397d951c73cf361087c8
Author: Anders Kaseorg <andersk@mit.edu>
Date:   Fri Nov 4 20:38:08 2016 -0400

    src/rx/rx_packet.c: Fix misleading indentation
    
    Fixes these warnings (errors with --enable-checking) from GCC 6.2:
    
    rx_packet.c: In function ‘rxi_ReceiveDebugPacket’:
    rx_packet.c:2009:9: error: this ‘if’ clause does not guard... [-Werror=misleading-indentation]
             if (rx_stats_active)
             ^~
    rx_packet.c:2011:6: note: ...this statement, but the latter is misleadingly indented as if it is guarded by the ‘if’
          s = (afs_int32 *) & rx_stats;
          ^
    rx_packet.c:2017:9: error: this ‘if’ clause does not guard... [-Werror=misleading-indentation]
             if (rx_stats_active)
             ^~
    rx_packet.c:2019:6: note: ...this statement, but the latter is misleadingly indented as if it is guarded by the ‘if’
          rxi_SendDebugPacket(ap, asocket, ahost, aport, istack);
          ^~~~~~~~~~~~~~~~~~~
    
    Change-Id: Iaecedf63e9ed393607b8700b892aea7678c774b3
    Reviewed-on: https://gerrit.openafs.org/12436
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit bd70a176c19c09c49c6c3c01ea088ca947c45966
Author: Anders Kaseorg <andersk@mit.edu>
Date:   Fri Nov 4 20:36:51 2016 -0400

    src/rxgen/rpc_parse.c: Fix misleading indentation
    
    Fixes this warning (error with --enable-checking) from GCC 6.2:
    
    rpc_parse.c: In function ‘analyze_ProcParams’:
    rpc_parse.c:861:5: error: this ‘if’ clause does not guard... [-Werror=misleading-indentation]
         if (tokp->kind != TOK_RPAREN)
         ^~
    rpc_parse.c:863:2: note: ...this statement, but the latter is misleadingly indented as if it is guarded by the ‘if’
      *tailp = decls;
      ^
    
    Change-Id: Ia63311c20eb8cd96123ba97b0bf7621b82956e79
    Reviewed-on: https://gerrit.openafs.org/12435
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit a7cc505d3be81e6aaf755bcc83d0dbcab85dbdad
Author: Anders Kaseorg <andersk@mit.edu>
Date:   Fri Nov 4 20:18:52 2016 -0400

    regen.sh: Use libtoolize -i, and .gitignore generated build-tools
    
    Recent libtoolize actually deletes build-tools/missing, which Git was
    treating as a change to the working copy.  Besides, we should let
    libtoolize copy in its more recent version of config.guess, config.sub,
    and install-sh.
    
    Change-Id: If21f22649e1e1015ad3bcfbf6d34f297b56993a1
    Reviewed-on: https://gerrit.openafs.org/12434
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 22933e02e2510f25b79230964f135571c7bfe710
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Thu Oct 27 17:27:26 2016 -0500

    Reformat src/afs/LINUX/osi_vcache.c
    
    Apply the GNU indent options from CODING, with manual adjustments
    to leave jump labels in column zero.
    
    Also rename and mark static a function-local helper function.
    
    Change-Id: I50b8300b675b2a3f76ae743136b204473ac0c8b0
    Reviewed-on: https://gerrit.openafs.org/12422
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit 742643e306929ac979ab69515a33ee2a3f2fa3fa
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Thu Aug 4 18:18:15 2016 -0400

    LINUX: split dentry eviction from osi_TryEvictVCache
    
    To make osi_TryEvictVCache clearer, and to prepare for a future change
    in dentry eviction, split the dentry eviction logic into its own routine
    osi_TryEvictDentries.
    
    No functional difference should be incurred by this commit.
    
    Change-Id: I5b255fd541d09159d70f8d7521ca8f2ae7fe5c2b
    Reviewed-on: https://gerrit.openafs.org/12362
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Joe Gorse <jhgorse@gmail.com>

commit 0bed87a15db11bccb693b3a54f704ee5751ae553
Author: Marcio Barbosa <mbarbosa@sinenomine.net>
Date:   Sun Oct 23 12:52:49 2016 -0700

    macos: packaging support for MacOS X 10.12
    
    This commit introduces the new set of changes / files required to
    successfully create the dmg installer on OS X 10.12 "Sierra".
    
    Change-Id: I8e715240c4b230c39c26c418324c0184268e1f73
    Reviewed-on: https://gerrit.openafs.org/12420
    Reviewed-by: Joe Gorse <jhgorse@gmail.com>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 0bdf750a962a81b9b2e61387d7a3340dabb13395
Author: Marcio Barbosa <mbarbosa@sinenomine.net>
Date:   Tue Oct 25 19:33:38 2016 -0700

    macos: add support for MacOS 10.12
    
    This commit introduces the new set of changes / files required to
    successfully build the OpenAFS source code on OS X 10.12 "Sierra".
    
    Change-Id: I42326cd271d84735188f9e3003e292afe5ee34be
    Reviewed-on: https://gerrit.openafs.org/12419
    Reviewed-by: Joe Gorse <jhgorse@gmail.com>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 8aeb711eeaa5ddac5a74c354091e2d4f7ac0cd63
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Thu Oct 20 00:49:37 2016 -0400

    Linux 4.9: inode_change_ok() becomes setattr_prepare()
    
    Linux commit 31051c85b5e2 "fs: Give dentry to inode_change_ok() instead
    of inode" renames and modifies inode_change_ok(inode, attrs) to
    setattr_prepare(dentry, attrs).
    
    Modify OpenAFS to cope.
    
    Change-Id: I72f8dfbdbd25d7c775e9c35116e323ea4359e95c
    Reviewed-on: https://gerrit.openafs.org/12418
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit f21e3ef8ce5093b4e0578d29666f76bd99aef1a2
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Fri Sep 16 19:01:19 2016 -0400

    Linux 4.9: inode_operation rename now takes flags
    
    In Linux 3.15 commit 520c8b16505236fc82daa352e6c5e73cd9870cff,
    inode_operation rename2() was added.  It takes the same arguments as
    rename(), with an added flags argument supporting the following values:
    
    RENAME_NOREPLACE: if "new" name exists, fail with -EEXIST.  Without
    this flag, the default behavior is to replace the "new" existing file.
    
    RENAME_EXCHANGE: exchange source and target; both must exist.
    
    OpenAFS never implemented a .rename2() routine because it was optional
    when introduced at Linux v3.15.
    
    In Linux 4.9-rc1 the following commits remove the last in-tree uses of
    .rename() and converts .rename2() to .rename().
    aadfa8019e81 vfs: add note about i_op->rename changes to porting
    2773bf00aeb9 fs: rename "rename2" i_op to "rename"
    18fc84dafaac vfs: remove unused i_op->rename
    1cd66c93ba8c fs: make remaining filesystems use .rename2
    e0e0be8a8355 libfs: support RENAME_NOREPLACE in simple_rename()
    f03b8ad8d386 fs: support RENAME_NOREPLACE for local filesystems
    
    With these changes, it is now mandatory for OpenAFS afs_linux_rename()
    to accept a 5th flag argument.
    
    Add an autoconfig test to determine the signature of .rename().  Use this
    information to implement afs_linux_rename() with the appropriate number
    of arguments.  Implement "toleration support" for the flags option by
    treating a zero flag as a normal rename; if any flags are specified,
    return -EINVAL to indicate the OpenAFS filesystem does not yet support
    any flags.
    
    Change-Id: I165d2b7956942446d97beda8504ac1ed5185a036
    Reviewed-on: https://gerrit.openafs.org/12391
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 8e81b182e36cde28ec5708e5fcbe56e4900b1ea3
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Wed Sep 14 18:01:22 2016 -0400

    Linux 4.9: deal with demise of GROUP_AT
    
    Linux commit 81243eacfa40 "cred: simpler, 1D supplementary groups"
    refactors the group_info struct, removing some members (which OpenAFS
    references only through the GROUP_AT macro) and adding a gid member.
    The GROUP_AT macro is also removed from the tree.
    
    Add an autoconfigure test for the new group_info member gid and define a
    replacement GROUP_AT macro to do the right thing under the new regime.
    
    Change-Id: I85a52c0ae0d91fc141a523f443a4ffc05eb72a2b
    Reviewed-on: https://gerrit.openafs.org/12390
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit e17cd5df703b8a924591f92c76636dd9e0d9eaf9
Author: Anders Kaseorg <andersk@mit.edu>
Date:   Sun Oct 9 06:39:12 2016 -0400

    tests/util/ktime-t.c: Specify EST offset in TZ
    
    This fixes test failures observed on new Debian build servers that no
    longer install tzdata by default.  As the tests expect, EST is defined
    as UTC−05:00 with no daylight saving time.
    
    Change-Id: Ida8cb33687b5d87761cb0422e446afd99246d47a
    Reviewed-on: https://gerrit.openafs.org/12414
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 1cd86de2912af9ad709d2d7cf8aa35d5d28fb6b3
Author: Yadav Yadavendra <yadayada@in.ibm.com>
Date:   Mon Oct 3 15:25:08 2016 -0400

    afs: afs_linux_write_end only commit copied
    
    In afs_linux_write_end() only commit the number of bytes actually copied
    to the page.
    
    Change-Id: I3576a28302d35917019d369adc9d1013ad5870c5
    Reviewed-on: https://gerrit.openafs.org/12409
    Reviewed-by: Jeffrey Altman <jaltman@auristor.com>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 0fdbc0754be58a50f60e3187fc4b34f057faf198
Author: Daria Phoebe Brashear <dariaphoebe@auristor.com>
Date:   Sun Sep 25 19:45:48 2016 -0400

    git: add a mailmap file
    
    I'd like the source tree to stop deadnaming me, so, sharing this change to do it
    
    Change-Id: Iee65d1c8e7e695ea939485db5b148615e052f953
    Reviewed-on: https://gerrit.openafs.org/12394
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 2fe3a28c6ec0ff9d19ddec5500b3a5e69b483210
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Mon Aug 22 19:53:34 2016 -0400

    tests: avoid passing NULL strings to vprintf
    
    Some libc implementations will crash when NULL string arguments are given to
    *printf.  Avoid passing NULL string arguments in the make check tests that did
    so, and pass the string "(null)" instead.
    
    Change-Id: I65f11a3eef88d1c7b210c867ae0c40018160f55a
    Reviewed-on: https://gerrit.openafs.org/12377
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit 4e0bc086d6d09db66b3dd26d221ff712ff351386
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Sat Aug 6 10:41:24 2016 -0400

    afsd: fix afsd -help crash
    
    afsd crashes after the usage is displayed with the -help option.
    
        $ afsd -help
        Usage: ./afsd [-blocks <1024 byte blocks in cache>] [-files <files in cache>]
        ...
        Segmentation fault (core dumped)
    
    The backtrace shows the crash occurs when calling afsconf_Open() with an
    invalid pointer argument, even though afsconf_Open() is not even needed
    when -help is given.
    
        (gdb) bt
        #0  __strlen_sse2 () at ../sysdeps/x86_64/multiarch/../strlen.S:32
        #1  0x00007ffff726fc36 in *__GI___strdup (s=0x0) at strdup.c:42
        #2  0x0000000000408383 in afsconf_Open (adir=0x0) at cellconfig.c:444
        #3  0x00000000004054d5 in afsd_run () at afsd.c:1926
        #4  0x0000000000407dc5 in main (argc=2, argv=0x7fffffffe348) at afsd_kernel.c:577
    
    afsconf_Open() is called with an uninitialized pointer because commit
    d72df5a18e0bb8bbcbf23df3e8591072f0cdb770 changed the libcmd
    cmd_Dispatch() to return 0 after displaying the command usage when the
    -help option is specified.  (That fix was needed for scripts which use
    the -help option to inspect command options with the -help option.)
    
    The afsd_kernel main function then incorrectly calls the afsd_run()
    function, even though mainproc() was not called, which sets up the afsd
    option variables.  The afsconf_Open() is the first function we call in
    afsd_run().
    
    Commit f77c078a291025d593f3170c57b6be5f257fc3e5 split afsd into afsd.c
    and afsd_kernel.c to support libuafs (and fuse).  This split the parsing
    of the command line arguments and the running of the afsd command into
    two functions.  The mainproc(), which originally did both, was split
    into two functions; one (still called mainproc) to check the option
    values given and setup/auto-tune values, and another (called afsd_run)
    to do the actual running of the afsd command. The afsd_parse() function
    was introduced as a wrapper around cmd_Dispatch() which "dispatches"
    mainproc.
    
    With this fix, take the opportunity to rename mainproc() to the now more
    accurately named CheckOptions() and change afsd_parse() to parse the
    command line options with cmd_Parse(), instead of abusing
    cmd_Dispatch().
    
    Change the main fuction to avoid running afsd_run() when afsd_parse()
    returns the CMD_HELP code which indicates the -help option was given.
    
    afsd.fuse splits the command line arguments into afsd recognized options
    and fuse options (everything else), so only afsd recognized arguments
    are passed to afsd_parse(), via uafs_ParseArgs(). The -help argument is
    processed as part of that splitting of arguments, so afsd.fuse never
    passes -help as an argument to afsd_parse(). This means we to not need
    to check for CMD_HELP as a return value from uafs_ParseArgs().  But
    since this is all a bit confusing, at least check the return value in
    uafs_ParseArgs().
    
    Change-Id: If510f8dc337e441c19b5e28685e2e818ff57ef5a
    Reviewed-on: https://gerrit.openafs.org/12360
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 644d3b6ec4afb5e9c0f35f48058d20f791806a9d
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Tue Aug 2 16:52:42 2016 -0400

    revert: "LINUX: Fix oops during negative dentry caching"
    
    Commit fd23587a5dbc9a15e2b2e83160b947f045c92af1 was done to fix an oops
    when parent_vcache_dv() was called without the GLOCK held.  Since the
    lockless code paths have been removed, and parent_vcache_dv() is always
    called with the GLOCK held, revert the extra locked flag argument and
    the calls obtain and release the GLOCK within parent_vcache_dv().
    
    Change-Id: I21c3272ec4ed5d4fa1a746a0f783cccfc14e0c22
    Reviewed-on: https://gerrit.openafs.org/12354
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit 74d4fea1683ccd5b4db53709fc2b5053062ea052
Author: Andrew Deason <adeason@sinenomine.net>
Date:   Wed Mar 4 14:10:23 2015 -0600

    Revert "Lockless path through afs_linux_dentry_revalidate"
    
    This reverts commit 3ecd65d3375f0a4fa4c28f9b59cdf6a1f6fd51b8.
    
    This commit made it possible to execute afs_linux_dentry_revalidate
    without taking the GLOCK under some circumstances. However, it
    achieved this by examining structure members outside of the GLOCK that
    were previously only examined under the GLOCK (such as vcp->f.states
    and vcp->f.m.DataVersion).
    
    While that does of course improve performance, it is not known to be
    completely safe. Revert this commit so we may implement a fastpath
    through afs_linux_dentry_revalidate using more trusted lockless
    techniques (atomics, RCU, etc).
    
    Change-Id: Ia3ca2cf53f97244e4e548db7c1caf218c16aca5c
    Reviewed-on: https://gerrit.openafs.org/11793
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit a13ea7038ebe262ba1e5387f4a3b12897bd8822b
Author: Andrew Deason <adeason@sinenomine.net>
Date:   Fri Feb 13 13:11:09 2015 -0600

    opr: Add opr_StaticAssert
    
    Add a static assert macro, for asserting that certain build-time
    expressions are true.
    
    Change-Id: I33b0e7168f041e8e8406710d05689e044af45fad
    Reviewed-on: https://gerrit.openafs.org/11792
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 7b99f2e4a8b7071930a5851c5f6c6ab6ddc0dd57
Author: Andrew Deason <adeason@sinenomine.net>
Date:   Thu Jun 26 15:47:46 2014 -0700

    afs: Create afs_SetDataVersion
    
    Several different places in the codebase change avc->f.m.DataVersion
    for a particular vcache, when we've noticed that the DV for the vcache
    has changed. Consolidate all of these occurrences into a single
    afs_SetDataVersion function, to make it easier to change what happens
    when we notice a change in DV number.
    
    This should incur no behavior change; it is just simple code
    reorganization.
    
    Change-Id: I5dbf2678d3c4b5a2fbef6ef045a0b5bfa8a49242
    Reviewed-on: https://gerrit.openafs.org/11791
    Reviewed-by: Marc Dionne <marc.c.dionne@gmail.com>
    Reviewed-by: Daria Phoebe Brashear <shadow@your-file-system.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Reviewed-by: Thomas Keiser <tkeiser@gmail.com>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit fac0b742960899123dca6016f6ffc6ccc944f217
Author: Andrew Deason <adeason@dson.org>
Date:   Sun May 22 21:54:30 2016 -0500

    ubik: Return an error from ContactQuorum when inquorate
    
    Currently, when we need to contact all other servers in the ubik
    quorum (to create a write transaction, and send db changes, etc), we
    call the ContactQuorum_* family of functions. To contact each server,
    those functions follow an algorithm like the following pseudocode:
    
    {
        int rcode = 0;
        int code;
        int okcalls = 0;
    
        for (ts = ubik_servers; ts; ts = ts->next) {
            if (ts->up) {
                code = contact_server(ts);
                if (code) {
                    rcode = code;
                } else {
                    okcalls++;
                }
            }
        }
    
        if (okcalls + 1 >= ubik_quorum) {
            return 0;
        } else {
            return rcode;
        }
    }
    
    This means that if we successfully contact a majority of ubik sites,
    we return success, even if some sites returned an error. If most sites
    fail, then we return an error (we arbitrarily pick the last error we
    got).
    
    This means that in most situations, a successful write transaction is
    guaranteed to have been transmitted to a majority of ubik sites, so
    the written data cannot be lost (at least one of the sites that got
    the new data will be in a future elected quorum).
    
    However, if a site is already known to be down (ts->up is 0), then we
    skip trying to contact that site, but we also don't set any errors.
    This means that if a majority of sites are already known to be down
    (ts->up is 0), then we can indicate success for a write transaction,
    even though the relevant data has not been written to a majority of
    sites. In that situation, it is possible to lose data.
    
    Most of the time this is not possible, since a majority of sites must
    be 'up' for the sync site to be elected and to allow write
    transactions at all. There are a few ways, though, in which we can get
    into a situation where most other sites are 'down', but we still let a
    write transaction go through.
    
    An example scenario:
    
    Say we have sites A, B, and C. All 3 sites come up at the same time,
    and A is the lowest IP so it starts an election (after around BIGTIME
    seconds). Right after A is elected the sync site, sites B and C will
    have 'lastYesState' set to 0, since site A hasn't yet sent out a
    beacon as the sync site.
    
    A client can then start a write to the ubik database on site A, which
    site A will allow since it's the sync site (and presumably all the
    relevant recovery flags are set). Site A will try to contact sites B
    and C for a DISK_Begin call, but lastYesState is set to 0 on those
    sites. This will cause DISK_Begin to return UNOQUORUM
    (urecovery_AllBetter will return 0, because uvote_HaveSyncAndVersion
    will return 0, because lastYesState is not set).
    
    So site A will get a UNOQUORUM error from sites B and C, and so site A
    will set 'ts->up' to 0 for sites B and C, and will return UNOQUORUM to
    the client. The client may then try to retry the call (because
    UNOQUORUM is not treated as a 'global' error in ubikclient.c's
    ubik_Call_New), or another client write request could come in. Now
    that 'ts->up' is unset for both sites B and C, we skip trying to
    contact any remote sites, and the ContactQuorum functions will return
    success. So the ubik write will go through successfully, but the new
    data will only be on site A.
    
    At this point, if site A crashes, then sites B and C will elect a
    quorum, and will not have the modifications that were written to site
    A (so the data written to site A is lost). If site A stays up, then it
    will go through database recovery, sending the entire database file to
    sites B and C.
    
    In addition, it's very possible in this scenario for a client to write
    to the database, and then try to read back data and confusingly get a
    different result. For example, if someone issues the following two
    commands while triggering the above scenario:
    
        $ pts createuser testuser
        $ pts examine testuser
    
    If the second command contacts site B or C, then it will always fail,
    saying that the user doesn't exist (even though the first command
    succeeded). This is because sites B and C don't have the new data
    written to site A, at least temporarily. While this confusing behavior
    is not completely avoidable in ubik (this can always happen
    'sometimes' due to network errors and such), with the scenario
    described here, it happens 100% of the time.
    
    The general scenario described above can also happen if sites B and C
    are suddenly legitimately unreachable from site A, instead of throwing
    the UNOQUORUM error. All of the steps are pretty much the same, but
    there is a bit of a delay while we wait for the DISK_Begin call to
    fail.
    
    To fix this, do not let 0 be returned if a quorum has not been
    reached.  In some sense, UNOQUORUM could *always* be returned in
    that case, but it is more in keeping with historical behavior to
    return a "real" error if there is one available.
    
    It is somewhat questionable whether we should even be propagating
    errors received from calls like DISK_Begin/DISK_Commit to the ubik
    client (e.g. if we get a -1 from trying to contact a remote site, we
    return -1 to the client, so the client may think it couldn't reach the
    site at all). But this commit does not change any of that logic, and
    should only change behavior when a majority of sites have 'ts->up'
    unset.  A later commit might effect the change to always return
    UNOQUORUM and ignore the actual error values from the DISK_ calls,
    but that is not needed to fix the immediate issue.
    
    An important note:
    
    Before this commit, there was a window of about 15 seconds after a
    sync site is elected where a write to the ubik db would appear to be
    successful, but would only modify the ubik db on the sync site.
    (Details described above.) With this commit, writes during that
    15-second window will instead fail, because we cannot guarantee that
    we won't lose that data. If someone relies on 'udebug' data from the
    sync site to let them know when writes will go through successfully,
    this commit could appear to cause new errors.
    
    [kaduk@mit.edu: transfer long commit message describing the issue
    from an alternative fix, and tidy up accordingly]
    Change-Id: If6842d7122ed4d137f298f0f8b7f20350b1e9de6
    Reviewed-on: https://gerrit.openafs.org/12289
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 64cc7f0ca7a44bb214396c829268a541ab286c69
Author: Andrew Deason <adeason@sinenomine.net>
Date:   Wed May 14 19:56:58 2014 -0500

    afs: Create afs_StaleVCache
    
    In numerous different places in the code, we do something like this to
    mark a vcache as stale:
    
      ObtainWriteLock(&afs_xcbhash, somenumber);
      avc->f.states &= ~CStatd;
      afs_DequeueCallback(avc);
      ReleaseWriteLock(&afs_xcbhash);
      if (avc->f.fid.Fid.Vnode & 1 || (vType(avc) == VDIR))
          osi_dnlc_purgedp(avc);
    
    There are some variations here and there, but all locations usually
    involve at least some code like that. But they all do the same general
    thing: invalidate a vcache so we hit the net the next time we need
    that vcache.
    
    In order to make it easier to modify what happens when we invalidate a
    vcache, and just to improve the code, take all of these instances and
    put the functionality in a single function, called afs_StaleVCache,
    which marks the vcache as 'stale'.
    
    To handle a few different situations that must be handled, we have
    some flags that can also be passed to the new function. These are
    primarily necessary to handle variations in the circumstances under
    which we hit this code path; for instance, we may already have
    afs_xcbhash locked, or we may be invalidating the entire osidnlc (if
    we're invalidating vcaches in bulk, for example).
    
    This should result in the same general behavior in all cases. The only
    slight differences in a few cases is that we hold locks for a few more
    operations than we used to; for example, we may clear an osidnlc entry
    while holding the vcache lock. But these are minor and shouldn't
    result in any actual differences in behavior.
    
    So, this commit should just be code reorganization and should incur no
    behavior change. However, this reorganization is complex, and should
    not be considered a simple risk-free refactoring.
    
    [kaduk@mit.edu: implement Tom Keiser's suggestion of a third argument
    to afs_StaleVCacheFlags, add AFS_STALEVC_CLEARCB and
    AFS_STALEVC_SKIP_DNLC_FOR_INIT_FLUSHED]
    
    Change-Id: I2b2f606c56d5b22826eeb98471187165260c7b91
    Reviewed-on: https://gerrit.openafs.org/11790
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 733dcec01784617e3354c2b8b29f50b09464a4bb
Author: Matt K. Light <mklight@gmail.com>
Date:   Tue Sep 13 14:18:38 2016 -0500

    Fix compile error for PPC64 gcc 6.1.1
    
    Cast function pointer stubs to remove compile errors
    on Fedora 24 PPC64 with ggcc 6.1.1
    
    FIXES 133407
    
    Change-Id: I59a191f7f8123ce17bfa6175b989ae14b5eab5a4
    Reviewed-on: https://gerrit.openafs.org/12386
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit f2f5a7bca5e77971ef71bf2ddabf93868fe79f1d
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Wed Aug 17 10:57:48 2016 -0400

    CODING: one-line if statements should not have braces
    
    Update the style guide with a declaration of the prevailing and
    preferred brace style for one-line if statements and loops. Provide an
    example and counter-example.
    
    Change-Id: Iafeea977203b76c0e67385779fb4ed57f3c6699a
    Reviewed-on: https://gerrit.openafs.org/12370
    Reviewed-by: Stephan Wiesand <stephan.wiesand@desy.de>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit f0fa5a5327c7440070d34127a124d6b7eb4bd32d
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Thu Jun 11 11:25:51 2015 -0400

    libafs: update the volume setup time when the vldb is rechecked
    
    The vldb is rechecked when the fileserver returns certain error codes,
    such as VMOVED.  When the vldb is rechecked, update the volume
    setupTime to reflect the most recent time the volume vldb information
    is known to be correct.
    
    Be sure the VRecheck flag is cleared after checking the vldb, since
    the volume write lock was dropped after finding the volume.
    
    Change-Id: I0ba389ee408de602e0059fbe8013012501c337d3
    Reviewed-on: https://gerrit.openafs.org/11897
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit ee08dbe37d9db4fe314bd88b9280bf73c92c37bd
Author: Andrew Deason <adeason@dson.org>
Date:   Sat Aug 8 16:13:54 2015 -0500

    afs: Make ONEGROUP_ENV not Linux-specific
    
    The functionality in AFS_LINUX26_ONEGROUP_ENV does not really need to
    be Linux-specific (it's just only implemented for Linux right now).
    Rename it to AFS_PAG_ONEGROUP_ENV, and remove some Linux-specific
    checks when checking for "onegroup" PAG GIDs.
    
    [mmeffie@sinenomine.net: Move AFS_PAG_ONEGROUP_ENV to param.h]
    
    Change-Id: I01d29fff309337ae95b9b6c65db3d2212cf4bf89
    Reviewed-on: https://gerrit.openafs.org/11978
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit b39095c3a7e1c631bb17816b7e707bc21a6b8c71
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Fri Sep 9 16:23:46 2016 -0400

    afs: define NUMPAGGROUPS once
    
    Define the number of groups per PAG in one place.  Prefix the define
    with AFS_ to avoid name conflicts in the future (unlikely as it may be).
    
    Fix the misnamed AFSPAGGGROUPS symbol in linux implementation of two
    groups per PAG.
    
    Change-Id: I78bb42913f2a5d84c9f323f17dc36d800d8acb84
    Reviewed-on: https://gerrit.openafs.org/12382
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit 0028ea92ad3e7aac6a4c51f63703a4d9d7b9dcd6
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Wed Apr 29 12:00:24 2015 -0400

    afs: add afsd -inumcalc option
    
    This commit adds the afsd -inumcalc command line switch to specify the
    inode number calculation method in a platform neutral way.
    
    Inode numbers reported for files within the AFS filesystem are generated
    by the cache manager using a calculation which derives a number from a
    FID. Long ago, a new type of calculation was added which generates inode
    numbers using a MD5 message digest of the FID.  The MD5 inode number
    calculation variant is computationally more expensive but greatly
    reduces the chances for inode number collisions.
    
    The MD5 calculation can be enabled on the Linux cache manager using the
    Linux sysctl interface.  Other than the sysctl method of selecting the
    inode calculation type, the MD5 inode number calculation method is not
    specific to Linux.
    
    This change introduces a command-line option which accepts a value to
    indicate the calculation method, instead of a simple flag to enable MD5
    inode numbers.  This should allow for new inode calculation methods
    in the future without the need for additional afsd command-line flags.
    
    Two values are currently accepted for -inumcalc. The value of 'compat'
    specifies the legacy inode number calculation. The value 'md5' indicates
    that the new MD5 calculation is to be used.
    
    Change-Id: I0257c68ca1a32a7a4c55ca8174a4926ff78ddea4
    Reviewed-on: https://gerrit.openafs.org/11855
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit c17d14223044936a5de5007052eff3488350e9d4
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Sat Aug 6 12:57:59 2016 -0400

    CODING: update style guide for multiline comments
    
    Document the preferred style for multiple line comment blocks and give an
    example.
    
    Change-Id: I73d6183da9014a943316e5aea1d43be2acc81ad7
    Reviewed-on: https://gerrit.openafs.org/12361
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: Benjamin Kaduk <kaduk@mit.edu>

commit aca8ac83bd456862815a7f247e9a7b89583517a8
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Wed Jul 13 18:23:50 2016 -0500

    Document minimum supported compiler versions
    
    Pick some fairly old versions of clang and gcc and document them
    as the minimum supported version.  This will let us make assumptions
    about compiler features that are available when using those compilers.
    
    Change-Id: Ibb8df72c9b12cc7adff39ece9708a428975ba703
    Reviewed-on: https://gerrit.openafs.org/12331
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 83a0f2a9ef88e63fbd300fbb436c17ca80c245b4
Author: Anders Kaseorg <andersk@mit.edu>
Date:   Mon Jul 25 21:04:59 2016 -0400

    Linux 4.7: Follow key_alloc API change
    
    Linux v4.7-rc1~124^2~2^2^2~9 adds an eighth optional argument
    restrict_link.  The same commit adds a KEY_ALLOC_BYPASS_RESTRICTION
    macro, which we test so we can avoid adding another configure test.
    
    Change-Id: I83e27b54ba5711124dccaa41de7155be77054f47
    Reviewed-on: https://gerrit.openafs.org/12345
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Anders Kaseorg <andersk@mit.edu>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit fa5af899319b69fa9542add78beca388521e3450
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Fri May 27 16:44:17 2016 -0400

    SOLARIS: corrupted content of mmap'd files over 4GiB
    
    Many Solaris programs and utilities (notably mdb and cp) use mmap() in
    their implementation.  When AFS files exceeding 4GiB are mmap'd, the
    contents of the file will be incorrectly mapped into memory. Starting at
    4GiB + 1, the first 4GiB will be repeated for the remainder of the file.
    If the mmap'd file is written back to storage (AFS or otherwise), the
    newly created file will also be corrupted.
    
    This is due to a bug in the afs_map() routine that supports mmap() of
    AFS files on Solaris.  The segvn_crarg.offset passed to the Solaris
    virtual memory APIs is incorrectly cast to u_int, causing it to wrap at
    4GiB.
    
    Although Solaris passes the offset from fop_map() to afs_map() as type
    offset_t, the destination segvn_crargs.offset is actually type
    u_offset_t.  Existing examples of other Solaris filesystems (e.g.
    zfs_map() ) cast the offset from offset_t to u_offset_t when assigning to
    segvn_crargs.offset.  If it's good enough for ZFS, it's good enough for
    AFS.
    
    Correctly cast the offset to u_offset_t.
    
    Thanks to Robert Milkowski for the report and diagnosis.
    
    Change-Id: Id25363255ec011f2ad7e003ca3e4a1385bebff7e
    Reviewed-on: https://gerrit.openafs.org/12292
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 75325fc9ab1cec4a338e1aaf1b32de1922492b12
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Thu May 26 16:53:47 2016 -0400

    SOLARIS: support mmap() over 4GiB
    
    When mmap() is issued for exactly 4GiB of a large AFS-resident file,
    mmap() fails with ENOMEM.  This is because the AFS code is handling the
    requested length as u_int instead of size_t, resulting in a 0 being
    passed back to the caller.
    
    When mmap() is issued for non-multiples of 4GiB, the subsequent mapping
    will not contain all the requested pages, and for the same reason - the
    mapped size has been truncated to 32 bits.  This results in SIGSEGV when
    accessing the non-mapped page(s).
    
    Fix the signature of afs_map() to specify the correct type for the length.
    
    Thanks to Robert Milkowski for the report and diagnosis.
    
    Change-Id: I8a9f0cb04ff9b80de5516e14d0679b06ef0b3f9a
    Reviewed-on: https://gerrit.openafs.org/12291
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Tested-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 19ffa2b7f09bffea816dda4713ad53f4d8cb93cb
Author: Marcio Barbosa <mbarbosa@sinenomine.net>
Date:   Wed Jul 20 15:09:43 2016 -0400

    macos: pkgbuild.sh should not be tracked by git
    
    The automatically generated pkgbuild.sh file should not be tracked by
    git. To fix this problem, add the name of this file to the proper
    .gitignore file.
    
    Change-Id: I9bdbad8e7cc02926de61e337ccb94d8a2c27ae43
    Reviewed-on: https://gerrit.openafs.org/12343
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: Benjamin Kaduk <kaduk@mit.edu>

commit 7f8af1b384cfdc2964a122953e4102b4d82e6cb1
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Thu Jun 18 15:32:36 2015 -0400

    afs: incorrect comments for afs_ClearStatus
    
    The brief description was identical to the one for afs_Analyze.
    
    Update it to accurately describe afs_ClearStatus.
    
    Change-Id: I70ceca41342c1b47950c35f567f8ae5a2566f925
    Reviewed-on: https://gerrit.openafs.org/12005
    Reviewed-by: Perry Ruiter <pruiter@sinenomine.net>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Michael Meffie <mmeffie@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit d3dbdade7e8eaf6da37dd6f1f53d9f1384626071
Author: Andrew Deason <adeason@dson.org>
Date:   Sun May 1 11:24:30 2016 -0500

    ubik: Don't RECFOUNDDB if can't contact most sites
    
    Currently, the ubik recovery code will always set UBIK_RECFOUNDDB
    during recovery, after asking all other sites for their dbversions.
    This happens regardless of how many sites we were actually able to
    successfully contact, even if we couldn't contact any of them.
    
    This can cause problems when we are unable to contact a majority of
    sites with DISK_GetVersion. Since, if we haven't contacted a majority
    of sites, we cannot say with confidence that we know what the best db
    version available is (which is what UBIK_RECFOUNDDB represents; that
    we've found which database is the one we should be using). This can
    also result in UBIK_RECHAVEDB in a similar situation, indicating that
    we have the best db version locally, even though we never actually
    asked anyone else what their db version was.
    
    For example, say site A is the sync site going through recovery, and
    DISK_GetVersion fails for the only other sites B and C. Site A will
    then set UBIK_RECFOUNDDB, and will claim that site A has the best db
    version available (UBIK_RECHAVEDB). This allows site A to process ubik
    write transactions (causing the db to be labelled with a new epoch),
    or possibly to send the db to the other sites via DISK_SendFile, if
    they quickly become available during recovery. Ubik write transactions
    can succeed in this situation, because our ContactQuorum_* calls will
    succeed if we never try to contact a remote site ('rcode' defaults to
    0).
    
    This situation should be rather rare, because normally a majority of
    sites must be reachable by site A for site A to be voted the sync site
    in the first place. However, it is possible for site A to lose
    connectivity to all other sites immediately after sync site election.
    It is also possible for site A to proceed far enough in the recovery
    process to set UBIK_RECHAVEDB before it loses its sync site status.
    
    As a result of all of this, if a site with an old database comes
    online and there are network connectivity problems between the other
    sites and a ubik write request comes in, it's possible for the "old"
    database to overwrite the "new" database. This makes it look as if the
    database has "rolled back" to an earlier version.
    
    This should be possible with any ubik database, though how to actually
    trigger this bug can change due to different ubik servers setting
    different network timeouts. It is probably the most likely with the
    VLDB, because the VLDB is typically the most frequently written
    database.
    
    If a VLDB reverts to an earlier version, it can result in existing
    volumes to appear to not exist in the VLDB, and can result in new
    volumes re-using volume IDs from existing volumes. This can result in
    rather confusing errors.
    
    To fix this, ensure that we have contacted a majority of sites with
    DISK_GetVersion before indicating that we have located the best db
    version. If we've contacted a majority of sites, then we are
    guaranteed (under ubik assumptions) that we've found the best version,
    since previous writes to the database should be guaranteed to hit a
    majority of sites (otherwise they wouldn't be successful).
    
    If we cannot reach a majority of sites, we just don't set
    UBIK_RECFOUNDDB, and the recovery process restarts. Presumably on the
    next iteration we'll be able to contact them, or we'll lose sync site
    status if we can't reach the other sites for long enough.
    
    Change-Id: I84f745b5e017bb62d93b538dbc9c7de845bee1bd
    Reviewed-on: https://gerrit.openafs.org/12281
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 3e531db9ce50dd41f0c64a11ab3bfcf0239ba0cd
Author: Andrew Deason <adeason@dson.org>
Date:   Thu May 12 21:34:31 2016 -0500

    vlserver: rx_SetRxDeadTime before ubik init
    
    Currently, vlserver calls rx_SetRxDeadTime to set the default rx
    deadtime to 50 seconds, but it does so after calling
    ubik_ServerInitByInfo. ubik_ServerInitByInfo creates several rx
    connections before it returns, and so these connections get the
    default rx deadtime (12 seconds), instead of the 50 seconds vlserver
    tries to set.
    
    When ubik detects that a remote site is down, ubik recreates the rx
    connections for that site, and this new connection gets the new
    deadtime of 50 seconds.
    
    This means that ubik behavior can have different timings in the
    vlserver, depending on if any remote sites have ever been detected as
    being 'down' or not. This can result in seemingly-inconsistent or
    confusing behavior, since some sequences of operations that appear
    identical can produce different results, depending on if the 12-second
    timeout or the 50-second timeout is being used.
    
    This behavior is not directly to blame for any problems, but it can be
    very confusing, especially when trying to diagnose or reproduce bugs.
    So to make things more consistent, just call rx_SetRxDeadTime earlier,
    so all conns always get the 50-second timeout.
    
    In order to do this, though, we must also ensure that rx_Init is
    called before rx_SetRxDeadTime (otherwise, rx_Init will overwrite our
    configured deadtime). So also call rx_Init earlier; rx_Init is
    idempotent, so it's okay that it may be called again after or before
    this.
    
    Note that vlserver is currently the only ubik server that sets a
    deadtime of 50 seconds, and it's not clear why. Another way to solve
    this is to just remove the call to rx_SetRxDeadTime, to make vlserver
    behave more similar to ptserver. But this commit takes a conservative
    approach to result in a deadtime that is probably the most common in
    current use. Since, most long-running vlservers will probably
    eventually lose contact with remote sites at one time or another, and
    so will eventually use a deadtime of 50 seconds.
    
    Change-Id: I49430144d9a62eb8cad1509c1aeafc9fcc927f8e
    Reviewed-on: https://gerrit.openafs.org/12285
    Tested-by: Andrew Deason <adeason@dson.org>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 48ce41a447c354b8a20b769e4aa5b502ba5bcc09
Author: Marcio Barbosa <mbarbosa@sinenomine.net>
Date:   Fri Jul 15 12:22:11 2016 -0300

    macos: use pkgbuild to build the package on 10.10/10.11
    
    PackageMaker is no longer part of OS X. As a result, it
    is not possible to build the package on OS X 10.10 and
    OS X 10.11 using the existing code.
    
    To solve this problem, a new script, along with a couple
    of new files, are provided.
    
    - pkgbuild.sh
    
    This script uses the command line tools pkgbuild and
    productbuild to build the package on OS X 10.10 and
    OS X 10.11. By default, the package built by this
    script will not be signed. Optionally, the package
    might be signed.
    
    - Distribution.xml
    
    This file is nothing more than an XML file used by
    productbuild. It is mainly used to configure how the
    installer will look and behave.
    
    - conclusion.txt
    
    Contains the text that is displayed by Installer at
    the end of the installation process. Only used by
    El Capitan and further.
    
    - Uninstall.14.15
    
    This script can be used by OS X 10.10/10.11 users
    to uninstall OpenAFS.
    
    Notes:
    
    - This work is based on a patch made by Brandon Allbery
      <ballbery@sinenomine.net> with fixes and updates from
      Andrew Deason <adeason@dson.org>.
    
    - El Capitan and further prevent us from touching
      /usr/bin directly. As a result, /opt is used.
    
    - If the package is not signed, the user will have
      to disable the OS X security protections. Otherwise,
      the client will not work.
    
    - Now we have two different scripts to build the
      package on OS X. For OS X 10.10 and newer versions,
      pkgbuild.sh will be used. For older versions,
      the existing buildpkg.sh will be used.
    
    Change-Id: If8320666c553b82af450c0263f5e80a00c33e3b8
    Reviewed-on: https://gerrit.openafs.org/12239
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 1bfc24dda0f391b88d7617c6947d03216abb0d80
Author: Marcio Barbosa <mbarbosa@sinenomine.net>
Date:   Wed Jul 6 09:56:26 2016 -0300

    pam: avoid warning messages
    
    In order to avoid some warning messages, do not
    ignore the code returned by some functions.
    
    Change-Id: Ie01fa98b54010d566fb5b980b001d58989ef9a67
    Reviewed-on: https://gerrit.openafs.org/12298
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit a0417565a3ab7e6a49d7c48efd72d62bdeb4436c
Author: Garrett Wollman <wollman@csail.mit.edu>
Date:   Sat Jul 28 18:35:13 2012 -0400

    ptuser: guarantee that all names are valid C strings
    
    The prname type is represented in XDR as a vector[PR_MAXNAMELEN]
    of char, not as a string, which means that the XDR (de)serializer
    will not guarantee null-termination.  Guarantee that all buffers
    used in the public protection server API are in fact valid strings
    by disallowing any names that are exactly PR_MAXNAMELEN (64)
    characters long.  DO NOT silently truncate names that are even
    longer than this.  Consistently use the prname typedef in
    declarations to reinforce the length limitation to those reading
    the header file.  Introduces a new protection error code,
    PRNAMETOOLONG, which will be returned if either IN or OUT parameters
    would exceed the limit.
    
    [kaduk@mit.edu convert macro to static_inline function and expand
    at call sites; add string_ wrapper to add checking to viced and libadmin;
    export the string_ wrapper from libafsauthent for the windows build]
    
    Change-Id: I65f850afcfea2fd2bc0110ca7b7f6ecca247dd58
    Reviewed-on: https://gerrit.openafs.org/7896
    Reviewed-by: Chas Williams <3chas3@gmail.com>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit f14d263a73f0be75e4de92f62e836fb2e55680dd
Author: Joe Gorse <jhgorse@gmail.com>
Date:   Thu Jun 9 14:11:23 2016 -0400

    Linux 4.6: rm PAGE_CACHE_* and page_cache_{get,release} macros
    
    This is an automatic patch generated by Coccinelle (spatch) from the commit message of the linked commit:
    https://github.com/torvalds/linux/commit/09cbfeaf1a5a67bfb3201e0c83c810cecb2efa5a
    
    We will not add an autoconfig test because the PAGE_{...} macros should exist
    where the PAGE_CACHE_{...} were previously.
    
    The spatch used:
    @@
    expression E;
    @@
    - E << (PAGE_CACHE_SHIFT - PAGE_SHIFT)
    + E
    
    @@
    expression E;
    @@
    - E >> (PAGE_CACHE_SHIFT - PAGE_SHIFT)
    + E
    
    @@
    @@
    - PAGE_CACHE_SHIFT
    + PAGE_SHIFT
    
    @@
    @@
    - PAGE_CACHE_SIZE
    + PAGE_SIZE
    
    @@
    @@
    - PAGE_CACHE_MASK
    + PAGE_MASK
    
    @@
    expression E;
    @@
    - PAGE_CACHE_ALIGN(E)
    + PAGE_ALIGN(E)
    
    @@
    expression E;
    @@
    - page_cache_get(E)
    + get_page(E)
    
    @@
    expression E;
    @@
    - page_cache_release(E)
    + put_page(E)
    
    Change-Id: Iabe29b1349ab44282c66c86eced9e5b2056c9efb
    Reviewed-on: https://gerrit.openafs.org/12297
    Reviewed-by: Michael Laß <lass@mail.uni-paderborn.de>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Stephan Wiesand <stephan.wiesand@desy.de>
    Tested-by: Stephan Wiesand <stephan.wiesand@desy.de>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 16463b602a210768f80bec9ef7c6896ea8a9909d
Author: Stephan Wiesand <stephan.wiesand@desy.de>
Date:   Wed Jul 13 16:55:11 2016 +0200

    redhat: Use a secure URL to retrieve CellServDB
    
    By default, makesrpm.pl will use wget to retrieve the CellServDB
    as specified in the spec file. Even though the script need not and
    thus should not be run by a privileged UID, make this a bit more
    secure by specifying an https URL.
    
    Change-Id: I0f14bbac35e7dc30a6e194f8706f7f3674d15a3f
    Reviewed-on: https://gerrit.openafs.org/12329
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: Benjamin Kaduk <kaduk@mit.edu>

commit 8b57f9fc423c6a69a0fb8147d0621cb703e1374e
Author: Marcio Barbosa <mbarbosa@sinenomine.net>
Date:   Thu Jun 9 15:04:18 2016 -0300

    build-sys: do not capitalize value of HAVE_PAM
    
    The value assigned to HAVE_PAM should not be capitalized.
    If so, the PAM source files will not be compiled.
    
    To fix this problem, convert to lowercase one of the values
    assigned to HAVE_PAM.
    
    Change-Id: I4973394f8d398bbea0f578fadb04aedee6fd1fc0
    Reviewed-on: https://gerrit.openafs.org/12296
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit a443accfdf8771b90e2b06da04e7e3d1e88028fd
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Thu Jun 11 11:02:20 2015 -0400

    libafs: rename volume accessTime to setupTime
    
    Since OpenAFS 1.0, the struct volume accessTime member has been the time
    time the volume structure is setup, not the last time the volume was
    used (as indicated by the comments).  This time stamp is only used to
    find the oldest available volume slot in the disked backed volume cache.
    (Perhaps in pre-OpenAFS this was updated each time the volume was
    referenced.)
    
    Rename this structure member and update the comments for it.
    
    Change-Id: I33a6371e8800b2d0f7b2700db0785fc365a8649e
    Reviewed-on: https://gerrit.openafs.org/11896
    Reviewed-by: Perry Ruiter <pruiter@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit c5b52c815972b4f623defaec9e0d8c235228b7b8
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Mon Apr 4 12:35:11 2016 -0400

    vlserver: --enable-ubik-read-while-write configure option
    
    Commit a0f416e3504929b304fefb5ca65e2d6a254ade2e unconditionally turned
    on the new ubik_BeginTransReadAnyWrite functionality for the vlserver,
    which allows us to read data from ubik during a conflicting ubik write
    lock.
    
    This feature is not ready for production use. Make it a build time
    option, marked as experimental, until more testing can be done.
    
    Change-Id: If64702e7a7ed2340066df5faf82ce8b0875fc610
    Reviewed-on: https://gerrit.openafs.org/12240
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit cd52915b3e8c8249c5af1cfebd57276cd34a00b9
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Tue Oct 7 17:17:08 2014 -0400

    LWP fileserver is no more
    
    Don't mention it in the man pages.
    
    Change-Id: I8a6d706f055545642116af5a98fa8c04f533b990
    Reviewed-on: https://gerrit.openafs.org/11529
    Reviewed-by: Marcio Brito Barbosa <mbarbosa@sinenomine.net>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 43a66de66c40171fedcf0450e9fa93b47c0d9f2e
Author: Michael Meffie <mmeffie@sinenomine.net>
Date:   Fri Jun 5 10:09:54 2015 -0400

    libafs: avoid resetting the dynroot volume every 10 minutes
    
    The dynroot volumes are synthetic, so do not need to be reset every time
    the background daemon checks the volumes.
    
    The results of osi_Time() is a signed 32-bit integer, and the volume
    expireTime is an signed 32-bit integer, so use signed 32-bit integers
    for the expiry check.
    
    Change-Id: Ib92157686c1d8b84a63d409cb148155705953b6d
    Reviewed-on: https://gerrit.openafs.org/11895
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit b3e85976936239e30d44da00bf28fbe8487f6998
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Thu Jun 18 15:54:28 2015 -0400

    afs: document missing afs_Analyze parm
    
    rxconn was missing from the comments; add it.
    
    Change-Id: I8c0cf212ca2952d3a23c3bb5db1857dfd9a8f41e
    Reviewed-on: https://gerrit.openafs.org/12004
    Reviewed-by: Perry Ruiter <pruiter@sinenomine.net>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit dda47aab6179b6940aa994a0cd7b88a4b0942fe6
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Mon Jul 4 20:13:31 2016 -0500

    Add sysname IDs for FreeBSD 10.2 and 10.3
    
    While here, de-conflict the numbers for 10.0/10.1 and 7.2/7.3
    
    Change-Id: I87697587359a26258298f4710c7232bea417f807
    Reviewed-on: https://gerrit.openafs.org/12321
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 683acaed17da90455aab0cbb3d1539c51415b137
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Sun May 15 13:51:56 2016 -0500

    viced: make -vhashsize usable for non-DAFS
    
    The ability to set the size of the volume hash table was added
    at the same time that DAFS was introduced, and got caught up
    in the same preprocessor conditional.  However, -vhashsize can
    be useful for the traditional fileserver as well (even though
    we recommend DAFS over the traditional fileserver), so let it
    be used in that case.
    
    Update the man pages accordingly and fix some grammar while here.
    
    Noted by Mark Vitale.
    
    Change-Id: Ic3282c9d661d60cf36f9ffb197e723a3f71da167
    Reviewed-on: https://gerrit.openafs.org/12287
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit d3b8a05d229a80100f40fca4dfdcd820313fcea8
Author: Marcio Barbosa <mbarbosa@sinenomine.net>
Date:   Tue Jun 28 12:48:06 2016 -0300

    venus: fix memory leak
    
    The fs getserverprefs command displays preference
    ranks for file / volume location server machine
    interfaces. In order to get the complete set of
    preference ranks, the VIOC_GETSPREFS system call
    might have to be called several times. If so, the
    memory previously allocated should be released.
    
    Change-Id: I8491117ead626e70aac40343923d52284f274efd
    Reviewed-on: https://gerrit.openafs.org/12315
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 360f4ef53c454494cd5212a5ea46c658bdb2879c
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Sun May 1 19:48:40 2016 -0400

    Linux 4.5: don't access i_mutex directly
    
    Linux commit 5955102c, in preparation for future work, introduced
    wrapper functions to lock/unlock inode mutexes.  This is to
    prepare for converting it to a read-write semaphore, so that
    lookup can be done with only the shared lock held.
    
    Adopt the afs_linux_*lock_inode() functions accordingly, and
    convert afs_linux_fsync() to using those wrappers, since the
    FOP_FSYNC_TAKES_RANGE case appears to be the current case.
    
    Amusingly, afs_linux_*lock_inode() already have a branch to
    handle the case when inode serialization is protected by a
    semaphore; it seems that this is going to come full-circle.
    
    Change-Id: Ia5a194acc559de21808655ef066151a0a3826364
    Reviewed-on: https://gerrit.openafs.org/12268
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Joe Gorse <jhgorse@gmail.com>
    Tested-by: Joe Gorse <jhgorse@gmail.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 2ef27ea1bb032cee8d26980e60e02b52a0805763
Author: Chaskiel Grundman <cg2v@andrew.cmu.edu>
Date:   Thu May 5 12:35:08 2016 -0400

    Linux 4.5: get_link instead of follow_link+put_link
    
    In linux commit 6b255391, the follow_link inode operation was
    replaced by the get_link operation, which is basically the same
    but takes the inode and dentry separately, allowing for the
    possibility of staying in RCU mode.
    
    For now, only support this if page_get_link is available and we are
    using the USABLE_KERNEL_PAGE_SYMLINK_CACHE
    
    The previous test for USABLE_KERNEL_PAGE_SYMLINK_CACHE used a bogus,
    undefined configure variable (ac_cv_linux_kernel_page_follow_link).
    Remove it, as it was not needed
    
    Change-Id: I2d7851d31dd4b1b944b16fad611addb804930eca
    Reviewed-on: https://gerrit.openafs.org/12265
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Joe Gorse <jhgorse@gmail.com>
    Tested-by: Joe Gorse <jhgorse@gmail.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit d9cfc1f3f5a75f1dbb14a56cd3da9db6b7a48065
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Sun May 1 19:04:45 2016 -0400

    Linux 4.5: no highmem in symlink ops
    
    Symlink bodies in the pagecache should not be in highmem, as
    upstream converted in commit 21fc61c73.
    
    Change-Id: I1e4c3c51308df096cdfa4d5e7b16279e275e7f41
    Reviewed-on: https://gerrit.openafs.org/12264
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Joe Gorse <jhgorse@gmail.com>
    Tested-by: Joe Gorse <jhgorse@gmail.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 49106a54993a0c9c64b407f05deaabe8f64e742d
Author: Nathaniel Wesley Filardo <nwfilardo@gmail.com>
Date:   Fri Aug 1 02:48:21 2014 -0400

    Use rxkad_crypt for inter-volser traffic, if asked
    
    Add a -s2scrypt option to the volume server, with possible options:
    
      * never -- the existing behavior
    
      * always -- switch to using afsconf_ClientAuthSecure, which uses
        rxkad_crypt, for ForwardVolume calls.
    
      * inherit -- encrypt inter-server traffic if the causal client
        connection is encrypted.  This has the effect of "inheriting" the
        "-encrypt" flag given to "vos release", for example.
    
    Thanks to Jeffrey Altman for pointers and to Andrew Deason for noting
    the existence of rxkad_GetServerInfo.
    
    [mmeffie@sinenomine.net fix assertion and style update.]
    
    Change-Id: Ia295ba3f29a8494c8250a480fb26594468d2116a
    Reviewed-on: https://gerrit.openafs.org/11349
    Reviewed-by: Mark Vitale <mvitale@sinenomine.net>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Thomas Keiser <tkeiser@gmail.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 4bd716223492aec23599a5ac01bce3cc47160bfd
Author: Benjamin Kaduk <kaduk@mit.edu>
Date:   Sat May 14 13:37:54 2016 -0500

    Fix typo in kaserver appendix
    
    Though it's very unlikely that someone would actually want to
    set up a new kaserver installation, if we have documentation for
    it, it ought to at least do what it claims to do.
    
    Thus, change kinit to klog where it was intended.
    
    Reported by Karl-Philipp Richter.
    
    FIXES 133043
    
    Change-Id: I478a42931fa863c11b4acca7624bcabc14e561b1
    Reviewed-on: https://gerrit.openafs.org/12286
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit 74413d886d047073b2dd396fbf8f606fd1b263a0
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Thu May 12 22:23:36 2016 -0400

    salvageserver: unable to write child log: out of memory
    
    Changes to salvageserver logging in commit
    24fed351fd13b38bfaf9f278c914a47782dbf670
    introduced a new bug in SalvageLogCleanup; the test for calloc() failure
    was inadvertently inverted.
    
    Fix the sense of the test.
    
    Change-Id: Id0ee4ac3e60d7285163a9ab0b32bd7d48e570ac0
    Reviewed-on: https://gerrit.openafs.org/12284
    Tested-by: BuildBot <buildbot@rampaginggeek.com>
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>

commit bf17a719e3443502e2b4bdb7f6b9d2f0c1e39510
Author: Mark Vitale <mvitale@sinenomine.net>
Date:   Tue May 10 22:51:38 2016 -0400

    salvageserver: segfault in DoSalvageVolume
    
    A typo in the recent logging changes for salvageserver
    ad455347bc99d1bd499535995958b5f77c2388ff
    caused a bad address to be passed to memset.
    
    Correctly memset the log options as intended.
    
    Change-Id: Ifef46defcc6da56df4e58f8ed9029717a77c0b39
    Reviewed-on: https://gerrit.openafs.org/12282
    Reviewed-by: Benjamin Kaduk <kaduk@mit.edu>
    Tested-by: BuildBot <buildbot@rampaginggeek.com>

commit 562efa7e4c303acadf5c1df35c72674a3743c577
Author: Andrew Deason <adeason@dson.org>
Date:   Thu May 5 00:01:22 2016 -0500

    ubik: Don't clear ubik_lastYesTime on startup
    
    In uvote_Init, we set ubik_lastYesTime to the current time just a few
    lines before. It is important to set ubik_lastYesTime to the current
    time, since that prevents us from voting for anyone in an ubik
    election for at least BIGTIME seconds.
    
    If we clear ubik_lastYesTime to 0, that means restarting a ubik server
    could cause it to immediately start voting for a different site than
    it was voting for before it started. This violates one of the ubik
    invariants; as mentioned in the comments in SVOTE_Beacon, we cannot
